/*
 * Copyright (c) 2002-2011 "Neo Technology,"
 * Network Engine for Objects in Lund AB [http://neotechnology.com]
 *
 * This file is part of Neo4j.
 *
 * Neo4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
define("neo4j/webadmin/templates/dashboard/base",["require","exports","module"],function(){return function(vars){with(vars||{})return'<div class="sidebar"><h1 class="pad">Neo4j web administration</h1><ul class="info_list"><li><h3>Server url</h3><p>'+server.url+"</p></li><li><h3>Kernel version</h3><p>"+server.version+'</p></li></ul><p class="pad">For more information, help and examples, please visit <a href="http://neo4j.org">the Neo4j community site</a>.</p><div class="foldout"><h2><a href="#" class="foldout_trigger">More about Charts</a></h2><div class="foldout_content pad"><p>To the right are charts that show the total number of primitive entities in the database over time.</p><p>You can select the timespan to show with the links in the top right corner of the chart.</p><p>To get specific info of some point in any chart, simply hover the mouse over the chart line.</p><p>The charts are automatically updated every three seconds.</p></div></div><div class="foldout"><h2><a href="#" class="foldout_trigger">More about KPIs</a></h2><div class="foldout_content pad"><p>Above the charts are one to three boxes showing different sets of KPIs. These are updated every three seconds.</p><p>Depending on what neo4j distribution you are running, the number of KPIs available will differ.</p><h3>A note on primitive counts</h3><p>The number of nodes, properties and relations are estimates based on file sizes. Actually counting the nodes is not done for performance reasons. These are usually very accurate, but in certain cases if you have experienced a database crash and subsequent recovery, they may be very wrong.</p><p>How wrong the numbers are is entirely based on the operations you were doing right before the crash. There is currently no automated way to remedy this problem.</p><h3>A note on disk size</h3><p>These KPIs are only available in neo4j enterprise edition.</p><p>Because of the way neo4j stores data, the different storage files (nodestore, relationshipstore etc.) will sometimes be very small before the server has recieved any requests.</p><p>It may be surprising to see the storage files grow rapidly when server first recieves requests, but the measurements will actually be correctly reflecting the disk size of the storage files.</p><p>This is only occurs if you are working on a relatively small graph.</p></div></div></div><div class="workarea with-sidebar"><div class="pad" id="dashboard-info"></div><div class="break"></div><div id="dashboard-charts"></div></div>'}}),define("neo4j/webadmin/templates/dashboard/info",["require","exports","module"],function(){return function(vars){with(vars||{})return'<div class="pad"><table cellspacing="0" class="info-table"><tbody>'+function(){return primitives.isDataAvailable()?"<tr><td>"+primitives.get("NumberOfNodeIdsInUse")+"</td><th>nodes</th><td>"+primitives.get("NumberOfPropertyIdsInUse")+"</td><th>properties</th><td>"+primitives.get("NumberOfRelationshipIdsInUse")+"</td><th>relationships</th><td>"+primitives.get("NumberOfRelationshipTypeIdsInUse")+"</td><th>relationship types</th></tr>":""}.call(this)+function(){return diskUsage.isDataAvailable()?"<tr><td>"+Math.round(diskUsage.get("TotalStoreSize")/1024)+" kB </td><th>total disk usage</th><td>"+Math.round(diskUsage.getDatabaseSize()/1024)+" kB ("+diskUsage.getDatabasePercentage()+"%)</td><th>database disk usage</th><td>"+Math.round(diskUsage.getLogicalLogSize()/1024)+" kB ("+diskUsage.getLogicalLogPercentage()+"%)</td><th>logical log disk usage</th><td></td><th></th></tr>":""}.call(this)+function(){return cacheUsage.isDataAvailable()?"<tr><td>"+cacheUsage.get("NodeCacheSize")+"</td><th>cached nodes</th><td>"+cacheUsage.get("RelationshipCacheSize")+"</td><th>cached relationships</th><td>"+cacheUsage.get("CacheType")+"</td><th>is the cache type</th><td></td><th></th></tr>":""}.call(this)+'</tbody></table><div class="break"></div></div>'}}),function(a,b){function p(a){return"scrollTo"in a&&a.document?a:a.nodeType===9?a.defaultView||a.parentWindow:!1}function o(a,b){var c={};q.each(bT.concat.apply([],bT.slice(0,b)),function(){c[this]=a});return c}function n(a,b,c){var d,e,f;b=b&&b[0]?b[0].ownerDocument||b[0]:t;if(a.length===1&&typeof a[0]==="string"&&a[0].length<512&&b===t&&!bn.test(a[0])&&(q.support.checkClone||!bo.test(a[0]))){e=!0;if(f=q.fragments[a[0]])f!==1&&(d=f)}d||(d=b.createDocumentFragment(),q.clean(a,b,d,c)),e&&(q.fragments[a[0]]=f?d:1);return{fragment:d,cacheable:e}}function m(a,b){var c=0;b.each(function(){if(this.nodeName===(a[c]&&a[c].nodeName)){var b=q.data(a[c++]),d=q.data(this,b);if(b=b&&b.events){delete d.handle,d.events={};for(var e in b)for(var f in b[e])q.event.add(this,e,b[e][f],b[e][f].data)}}})}function l(a){return!a||!a.parentNode||a.parentNode.nodeType===11}function k(a,b){return"live."+(a&&a!=="*"?a+".":"")+b.replace(/\./g,"`").replace(/ /g,"&")}function j(a){var b,c=[],d=[],e=arguments,f,g,h,i,j,k;g=q.data(this,"events");if(a.liveFired!==this&&g&&g.live&&(!a.button||a.type!=="click")){a.liveFired=this;var l=g.live.slice(0);for(i=0;i<l.length;i++)g=l[i],g.origType.replace(U,"")===a.type?d.push(g.selector):l.splice(i--,1);f=q(a.target).closest(d,a.currentTarget),j=0;for(k=f.length;j<k;j++)for(i=0;i<l.length;i++){g=l[i];if(f[j].selector===g.selector){h=f[j].elem,d=null;if(g.preType==="mouseenter"||g.preType==="mouseleave")d=q(a.relatedTarget).closest(g.selector)[0];(!d||d!==h)&&c.push({elem:h,handleObj:g})}}j=0;for(k=c.length;j<k;j++){f=c[j],a.currentTarget=f.elem,a.data=f.handleObj.data,a.handleObj=f.handleObj;if(f.handleObj.origHandler.apply(f.elem,e)===!1){b=!1;break}}return b}}function i(a,b,c){c[0].type=a;return q.event.handle.apply(b,c)}function h(){return!0}function g(){return!1}function f(){return(new Date).getTime()}function e(a,c,d,f,g,h){var i=a.length;if(typeof c==="object"){for(var j in c)e(a,j,c[j],f,g,d);return a}if(d!==b){f=!h&&f&&q.isFunction(d);for(j=0;j<i;j++)g(a[j],c,f?d.call(a[j],j,g(a[j],c)):d,h);return a}return i?g(a[0],c):b}function d(a,b){b.src?q.ajax({url:b.src,async:!1,dataType:"script"}):q.globalEval(b.text||b.textContent||b.innerHTML||""),b.parentNode&&b.parentNode.removeChild(b)}function c(){if(!q.isReady){try{t.documentElement.doScroll("left")}catch(a){setTimeout(c,1);return}q.ready()}}var q=function(a,b){return new q.fn.init(a,b)},r=a.jQuery,s=a.$,t=a.document,u,v=/^[^<]*(<[\w\W]+>)[^>]*$|^#([\w-]+)$/,w=/^.[^:#\[\.,]*$/,x=/\S/,y=/^(\s|\u00A0)+|(\s|\u00A0)+$/g,z=/^<(\w+)\s*\/?>(?:<\/\1>)?$/,A=navigator.userAgent,B=!1,C=[],D,E=Object.prototype.toString,F=Object.prototype.hasOwnProperty,G=Array.prototype.push,H=Array.prototype.slice,I=Array.prototype.indexOf;q.fn=q.prototype={init:function(a,c){var d,e;if(!a)return this;if(a.nodeType){this.context=this[0]=a,this.length=1;return this}if(a==="body"&&!c){this.context=t,this[0]=t.body,this.selector="body",this.length=1;return this}if(typeof a==="string"){if(!(d=v.exec(a))||!d[1]&&c){if(!c&&/^\w+$/.test(a)){this.selector=a,this.context=t,a=t.getElementsByTagName(a);return q.merge(this,a)}return!c||c.jquery?(c||u).find(a):q(c).find(a)}if(d[1]){e=c?c.ownerDocument||c:t,(a=z.exec(a))?q.isPlainObject(c)?(a=[t.createElement(a[1])],q.fn.attr.call(a,c,!0)):a=[e.createElement(a[1])]:(a=n([d[1]],[e]),a=(a.cacheable?a.fragment.cloneNode(!0):a.fragment).childNodes);return q.merge(this,a)}if(c=t.getElementById(d[2])){if(c.id!==d[2])return u.find(a);this.length=1,this[0]=c}this.context=t,this.selector=a;return this}if(q.isFunction(a))return u.ready(a);a.selector!==b&&(this.selector=a.selector,this.context=a.context);return q.makeArray(a,this)},selector:"",jquery:"1.4.2",length:0,size:function(){return this.length},toArray:function(){return H.call(this,0)},get:function(a){return a==null?this.toArray():a<0?this.slice(a)[0]:this[a]},pushStack:function(a,b,c){var d=q();q.isArray(a)?G.apply(d,a):q.merge(d,a),d.prevObject=this,d.context=this.context,b==="find"?d.selector=this.selector+(this.selector?" ":"")+c:b&&(d.selector=this.selector+"."+b+"("+c+")");return d},each:function(a,b){return q.each(this,a,b)},ready:function(a){q.bindReady(),q.isReady?a.call(t,q):C&&C.push(a);return this},eq:function(a){return a===-1?this.slice(a):this.slice(a,+a+1)},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},slice:function(){return this.pushStack(H.apply(this,arguments),"slice",H.call(arguments).join(","))},map:function(a){return this.pushStack(q.map(this,function(b,c){return a.call(b,c,b)}))},end:function(){return this.prevObject||q(null)},push:G,sort:[].sort,splice:[].splice},q.fn.init.prototype=q.fn,q.extend=q.fn.extend=function(){var a=arguments[0]||{},c=1,d=arguments.length,e=!1,f,g,h,i;typeof a==="boolean"&&(e=a,a=arguments[1]||{},c=2),typeof a!=="object"&&!q.isFunction(a)&&(a={}),d===c&&(a=this,--c);for(;c<d;c++)if((f=arguments[c])!=null)for(g in f)h=a[g],i=f[g],a!==i&&(e&&i&&(q.isPlainObject(i)||q.isArray(i))?(h=h&&(q.isPlainObject(h)||q.isArray(h))?h:q.isArray(i)?[]:{},a[g]=q.extend(e,h,i)):i!==b&&(a[g]=i));return a},q.extend({noConflict:function(b){a.$=s,b&&(a.jQuery=r);return q},isReady:!1,ready:function(){if(!q.isReady){if(!t.body)return setTimeout(q.ready,13);q.isReady=!0;if(C){for(var a,b=0;a=C[b++];)a.call(t,q);C=null}q.fn.triggerHandler&&q(t).triggerHandler("ready")}},bindReady:function(){if(!B){B=!0;if(t.readyState==="complete")return q.ready();if(t.addEventListener)t.addEventListener("DOMContentLoaded",D,!1),a.addEventListener("load",q.ready,!1);else if(t.attachEvent){t.attachEvent("onreadystatechange",D),a.attachEvent("onload",q.ready);var b=!1;try{b=a.frameElement==null}catch(d){}t.documentElement.doScroll&&b&&c()}}},isFunction:function(a){return E.call(a)==="[object Function]"},isArray:function(a){return E.call(a)==="[object Array]"},isPlainObject:function(a){if(!a||E.call(a)!=="[object Object]"||a.nodeType||a.setInterval)return!1;if(a.constructor&&!F.call(a,"constructor")&&!F.call(a.constructor.prototype,"isPrototypeOf"))return!1;var c;for(c in a);return c===b||F.call(a,c)},isEmptyObject:function(a){for(var b in a)return!1;return!0},error:function(a){throw a},parseJSON:function(b){if(typeof b!=="string"||!b)return null;b=q.trim(b);if(/^[\],:{}\s]*$/.test(b.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,"@").replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,"]").replace(/(?:^|:|,)(?:\s*\[)+/g,"")))return a.JSON&&a.JSON.parse?a.JSON.parse(b):(new Function("return "+b))();q.error("Invalid JSON: "+b)},noop:function(){},globalEval:function(a){if(a&&x.test(a)){var b=t.getElementsByTagName("head")[0]||t.documentElement,c=t.createElement("script");c.type="text/javascript",q.support.scriptEval?c.appendChild(t.createTextNode(a)):c.text=a,b.insertBefore(c,b.firstChild),b.removeChild(c)}},nodeName:function(a,b){return a.nodeName&&a.nodeName.toUpperCase()===b.toUpperCase()},each:function(a,c,d){var e,f=0,g=a.length,h=g===b||q.isFunction(a);if(d){if(h){for(e in a)if(c.apply(a[e],d)===!1)break}else for(;f<g;)if(c.apply(a[f++],d)===!1)break}else if(h){for(e in a)if(c.call(a[e],e,a[e])===!1)break}else for(d=a[0];f<g&&c.call(d,f,d)!==!1;d=a[++f]);return a},trim:function(a){return(a||"").replace(y,"")},makeArray:function(a,b){b=b||[],a!=null&&(a.length==null||typeof a==="string"||q.isFunction(a)||typeof a!=="function"&&a.setInterval?G.call(b,a):q.merge(b,a));return b},inArray:function(a,b){if(b.indexOf)return b.indexOf(a);for(var c=0,d=b.length;c<d;c++)if(b[c]===a)return c;return-1},merge:function(a,c){var d=a.length,e=0;if(typeof c.length==="number")for(var f=c.length;e<f;e++)a[d++]=c[e];else for(;c[e]!==b;)a[d++]=c[e++];a.length=d;return a},grep:function(a,b,c){for(var d=[],e=0,f=a.length;e<f;e++)!c!==!b(a[e],e)&&d.push(a[e]);return d},map:function(a,b,c){for(var d=[],e,f=0,g=a.length;f<g;f++)e=b(a[f],f,c),e!=null&&(d[d.length]=e);return d.concat.apply([],d)},guid:1,proxy:function(a,c,d){arguments.length===2&&(typeof c==="string"?(d=a,a=d[c],c=b):c&&!q.isFunction(c)&&(d=c,c=b)),!c&&a&&(c=function(){return a.apply(d||this,arguments)}),a&&(c.guid=a.guid=a.guid||c.guid||q.guid++);return c},uaMatch:function(a){a=a.toLowerCase(),a=/(webkit)[ \/]([\w.]+)/.exec(a)||/(opera)(?:.*version)?[ \/]([\w.]+)/.exec(a)||/(msie) ([\w.]+)/.exec(a)||!/compatible/.test(a)&&/(mozilla)(?:.*? rv:([\w.]+))?/.exec(a)||[];return{browser:a[1]||"",version:a[2]||"0"}},browser:{}}),A=q.uaMatch(A),A.browser&&(q.browser[A.browser]=!0,q.browser.version=A.version),q.browser.webkit&&(q.browser.safari=!0),I&&(q.inArray=function(a,b){return I.call(b,a)}),u=q(t),t.addEventListener?D=function(){t.removeEventListener("DOMContentLoaded",D,!1),q.ready()}:t.attachEvent&&(D=function(){t.readyState==="complete"&&(t.detachEvent("onreadystatechange",D),q.ready())}),function(){q.support={};var b=t.documentElement,c=t.createElement("script"),d=t.createElement("div"),e="script"+f();d.style.display="none",d.innerHTML="   <link/><table></table><a href='/a' style='color:red;float:left;opacity:.55;'>a</a><input type='checkbox'/>";var g=d.getElementsByTagName("*"),h=d.getElementsByTagName("a")[0];if(g&&g.length&&h){q.support={leadingWhitespace:d.firstChild.nodeType===3,tbody:!d.getElementsByTagName("tbody").length,htmlSerialize:!!d.getElementsByTagName("link").length,style:/red/.test(h.getAttribute("style")),hrefNormalized:h.getAttribute("href")==="/a",opacity:/^0.55$/.test(h.style.opacity),cssFloat:!!h.style.cssFloat,checkOn:d.getElementsByTagName("input")[0].value==="on",optSelected:t.createElement("select").appendChild(t.createElement("option")).selected,parentNode:d.removeChild(d.appendChild(t.createElement("div"))).parentNode===null,deleteExpando:!0,checkClone:!1,scriptEval:!1,noCloneEvent:!0,boxModel:null},c.type="text/javascript";try{c.appendChild(t.createTextNode("window."+e+"=1;"))}catch(i){}b.insertBefore(c,b.firstChild),a[e]&&(q.support.scriptEval=!0,delete a[e]);try{delete c.test}catch(j){q.support.deleteExpando=!1}b.removeChild(c),d.attachEvent&&d.fireEvent&&(d.attachEvent("onclick",function k(){q.support.noCloneEvent=!1,d.detachEvent("onclick",k)}),d.cloneNode(!0).fireEvent("onclick")),d=t.createElement("div"),d.innerHTML="<input type='radio' name='radiotest' checked='checked'/>",b=t.createDocumentFragment(),b.appendChild(d.firstChild),q.support.checkClone=b.cloneNode(!0).cloneNode(!0).lastChild.checked,q(function(){var a=t.createElement("div");a.style.width=a.style.paddingLeft="1px",t.body.appendChild(a),q.boxModel=q.support.boxModel=a.offsetWidth===2,t.body.removeChild(a).style.display="none"}),b=function(a){var b=t.createElement("div");a="on"+a;var c=a in b;c||(b.setAttribute(a,"return;"),c=typeof b[a]==="function");return c},q.support.submitBubbles=b("submit"),q.support.changeBubbles=b("change"),b=c=d=g=h=null}}(),q.props={"for":"htmlFor","class":"className",readonly:"readOnly",maxlength:"maxLength",cellspacing:"cellSpacing",rowspan:"rowSpan",colspan:"colSpan",tabindex:"tabIndex",usemap:"useMap",frameborder:"frameBorder"};var J="jQuery"+f(),K=0,L={};q.extend({cache:{},expando:J,noData:{embed:!0,object:!0,applet:!0},data:function(c,d,e){if(!c.nodeName||!q.noData[c.nodeName.toLowerCase()]){c=c==a?L:c;var f=c[J],g=q.cache;if(!f&&typeof d==="string"&&e===b)return null;f||(f=++K),typeof d==="object"?(c[J]=f,g[f]=q.extend(!0,{},d)):g[f]||(c[J]=f,g[f]={}),c=g[f],e!==b&&(c[d]=e);return typeof d==="string"?c[d]:c}},removeData:function(b,c){if(!b.nodeName||!q.noData[b.nodeName.toLowerCase()]){b=b==a?L:b;var d=b[J],e=q.cache,f=e[d];c?f&&(delete f[c],q.isEmptyObject(f)&&q.removeData(b)):(q.support.deleteExpando?delete b[q.expando]:b.removeAttribute&&b.removeAttribute(q.expando),delete e[d])}}}),q.fn.extend({data:function(a,c){if(typeof a==="undefined"&&this.length)return q.data(this[0]);if(typeof a==="object")return this.each(function(){q.data(this,a)});var d=a.split(".");d[1]=d[1]?"."+d[1]:"";if(c===b){var e=this.triggerHandler("getData"+d[1]+"!",[d[0]]);e===b&&this.length&&(e=q.data(this[0],a));return e===b&&d[1]?this.data(d[0]):e}return this.trigger("setData"+d[1]+"!",[d[0],c]).each(function(){q.data(this,a,c)})},removeData:function(a){return this.each(function(){q.removeData(this,a)})}}),q.extend({queue:function(a,b,c){if(a){b=(b||"fx")+"queue";var d=q.data(a,b);if(!c)return d||[];!d||q.isArray(c)?d=q.data(a,b,q.makeArray(c)):d.push(c);return d}},dequeue:function(a,b){b=b||"fx";var c=q.queue(a,b),d=c.shift();d==="inprogress"&&(d=c.shift()),d&&(b==="fx"&&c.unshift("inprogress"),d.call(a,function(){q.dequeue(a,b)}))}}),q.fn.extend({queue:function(a,c){typeof a!=="string"&&(c=a,a="fx");if(c===b)return q.queue(this[0],a);return this.each(function(){var b=q.queue(this,a,c);a==="fx"&&b[0]!=="inprogress"&&q.dequeue(this,a)})},dequeue:function(a){return this.each(function(){q.dequeue(this,a)})},delay:function(a,b){a=q.fx?q.fx.speeds[a]||a:a,b=b||"fx";return this.queue(b,function(){var c=this;setTimeout(function(){q.dequeue(c,b)},a)})},clearQueue:function(a){return this.queue(a||"fx",[])}});var M=/[\n\t]/g,N=/\s+/,O=/\r/g,P=/href|src|style/,Q=/(button|input)/i,R=/(button|input|object|select|textarea)/i,S=/^(a|area)$/i,T=/radio|checkbox/;q.fn.extend({attr:function(a,b){return e(this,a,b,!0,q.attr)},removeAttr:function(a){return this.each(function(){q.attr(this,a,""),this.nodeType===1&&this.removeAttribute(a)})},addClass:function(a){if(q.isFunction(a))return this.each(function(b){var c=q(this);c.addClass(a.call(this,b,c.attr("class")))});if(a&&typeof a==="string")for(var b=(a||"").split(N),c=0,d=this.length;c<d;c++){var e=this[c];if(e.nodeType===1)if(e.className){for(var f=" "+e.className+" ",g=e.className,h=0,i=b.length;h<i;h++)f.indexOf(" "+b[h]+" ")<0&&(g+=" "+b[h]);e.className=q.trim(g)}else e.className=a}return this},removeClass:function(a){if(q.isFunction(a))return this.each(function(b){var c=q(this);c.removeClass(a.call(this,b,c.attr("class")))});if(a&&typeof a==="string"||a===b)for(var c=(a||"").split(N),d=0,e=this.length;d<e;d++){var f=this[d];if(f.nodeType===1&&f.className)if(a){for(var g=(" "+f.className+" ").replace(M," "),h=0,i=c.length;h<i;h++)g=g.replace(" "+c[h]+" "," ");f.className=q.trim(g)}else f.className=""}return this},toggleClass:function(a,b){var c=typeof a,d=typeof b==="boolean";if(q.isFunction(a))return this.each(function(c){var d=q(this);d.toggleClass(a.call(this,c,d.attr("class"),b),b)});return this.each(function(){if(c==="string")for(var e,f=0,g=q(this),h=b,i=a.split(N);e=i[f++];)h=d?h:!g.hasClass(e),g[h?"addClass":"removeClass"](e);else if(c==="undefined"||c==="boolean")this.className&&q.data(this,"__className__",this.className),this.className=this.className||a===!1?"":q.data(this,"__className__")||""})},hasClass:function(a){a=" "+a+" ";for(var b=0,c=this.length;b<c;b++)if((" "+this[b].className+" ").replace(M," ").indexOf(a)>-1)return!0;return!1},val:function(a){if(a===b){var c=this[0];if(c){if(q.nodeName(c,"option"))return(c.attributes.value||{}).specified?c.value:c.text;if(q.nodeName(c,"select")){var d=c.selectedIndex,e=[],f=c.options;c=c.type==="select-one";if(d<0)return null;var g=c?d:0;for(d=c?d+1:f.length;g<d;g++){var h=f[g];if(h.selected){a=q(h).val();if(c)return a;e.push(a)}}return e}if(T.test(c.type)&&!q.support.checkOn)return c.getAttribute("value")===null?"on":c.value;return(c.value||"").replace(O,"")}return b}var i=q.isFunction(a);return this.each(function(b){var c=q(this),d=a;if(this.nodeType===1){i&&(d=a.call(this,b,c.val())),typeof d==="number"&&(d+="");if(q.isArray(d)&&T.test(this.type))this.checked=q.inArray(c.val(),d)>=0;else if(q.nodeName(this,"select")){var e=q.makeArray(d);q("option",this).each(function(){this.selected=q.inArray(q(this).val(),e)>=0}),e.length||(this.selectedIndex=-1)}else this.value=d}})}}),q.extend({attrFn:{val:!0,css:!0,html:!0,text:!0,data:!0,width:!0,height:!0,offset:!0},attr:function(a,c,d,e){if(!a||a.nodeType===3||a.nodeType===8)return b;if(e&&c in q.attrFn)return q(a)[c](d);e=a.nodeType!==1||!q.isXMLDoc(a);var f=d!==b;c=e&&q.props[c]||c;if(a.nodeType===1){var g=P.test(c);if(c in a&&e&&!g){f&&(c==="type"&&Q.test(a.nodeName)&&a.parentNode&&q.error("type property can't be changed"),a[c]=d);if(q.nodeName(a,"form")&&a.getAttributeNode(c))return a.getAttributeNode(c).nodeValue;if(c==="tabIndex")return(c=a.getAttributeNode("tabIndex"))&&c.specified?c.value:R.test(a.nodeName)||S.test(a.nodeName)&&a.href?0:b;return a[c]}if(!q.support.style&&e&&c==="style"){f&&(a.style.cssText=""+d);return a.style.cssText}f&&a.setAttribute(c,""+d),a=!q.support.hrefNormalized&&e&&g?a.getAttribute(c,2):a.getAttribute(c);return a===null?b:a}return q.style(a,c,d)}});var U=/\.(.*)$/,V=function(a){return a.replace(/[^\w\s\.\|`]/g,function(a){return"\\"+a})};q.event={add:function(c,d,e,f){if(c.nodeType!==3&&c.nodeType!==8){c.setInterval&&c!==a&&!c.frameElement&&(c=a);var g,h;e.handler&&(g=e,e=g.handler),e.guid||(e.guid=q.guid++);if(h=q.data(c)){var i=h.events=h.events||{},j=h.handle;j||(h.handle=j=function(){return typeof q!=="undefined"&&!q.event.triggered?q.event.handle.apply(j.elem,arguments):b}),j.elem=c,d=d.split(" ");for(var k,l=0,m;k=d[l++];){h=g?q.extend({},g):{handler:e,data:f},k.indexOf(".")>-1?(m=k.split("."),k=m.shift(),h.namespace=m.slice(0).sort().join(".")):(m=[],h.namespace=""),h.type=k,h.guid=e.guid;var n=i[k],o=q.event.special[k]||{};if(!n){n=i[k]=[];if(!o.setup||o.setup.call(c,f,m,j)===!1)c.addEventListener?c.addEventListener(k,j,!1):c.attachEvent&&c.attachEvent("on"+k,j)}o.add&&(o.add.call(c,h),h.handler.guid||(h.handler.guid=e.guid)),n.push(h),q.event.global[k]=!0}c=null}}},global:{},remove:function(a,b,c,d){if(a.nodeType!==3&&a.nodeType!==8){var e,f=0,g,h,i,j,k,l,m=q.data(a),n=m&&m.events;if(m&&n){b&&b.type&&(c=b.handler,b=b.type);if(!b||typeof b==="string"&&b.charAt(0)==="."){b=b||"";for(e in n)q.event.remove(a,e+b)}else{for(b=b.split(" ");e=b[f++];){j=e,g=e.indexOf(".")<0,h=[],g||(h=e.split("."),e=h.shift(),i=new RegExp("(^|\\.)"+q.map(h.slice(0).sort(),V).join("\\.(?:.*\\.)?")+"(\\.|$)"));if(k=n[e])if(c){j=q.event.special[e]||{};for(o=d||0;o<k.length;o++){l=k[o];if(c.guid===l.guid){if(g||i.test(l.namespace))d==null&&k.splice(o--,1),j.remove&&j.remove.call(a,l);if(d!=null)break}}if(k.length===0||d!=null&&k.length===1)(!j.teardown||j.teardown.call(a,h)===!1)&&W(a,e,m.handle),delete n[e]}else for(var o=0;o<k.length;o++){l=k[o];if(g||i.test(l.namespace))q.event.remove(a,j,l.handler,o),k.splice(o--,1)}}if(q.isEmptyObject(n)){if(b=m.handle)b.elem=null;delete m.events,delete m.handle,q.isEmptyObject(m)&&q.removeData(a)}}}}},trigger:function(a,c,d,e){var f=a.type||a;if(!e){a=typeof a==="object"?a[J]?a:q.extend(q.Event(f),a):q.Event(f),f.indexOf("!")>=0&&(a.type=f=f.slice(0,-1),a.exclusive=!0),d||(a.stopPropagation(),q.event.global[f]&&q.each(q.cache,function(){this.events&&this.events[f]&&q.event.trigger(a,c,this.handle.elem)}));if(!d||d.nodeType===3||d.nodeType===8)return b;a.result=b,a.target=d,c=q.makeArray(c),c.unshift(a)}a.currentTarget=d,(e=q.data(d,"handle"))&&e.apply(d,c),e=d.parentNode||d.ownerDocument;try{d&&d.nodeName&&q.noData[d.nodeName.toLowerCase()]||d["on"+f]&&d["on"+f].apply(d,c)===!1&&(a.result=!1)}catch(g){}if(!a.isPropagationStopped()&&e)q.event.trigger(a,c,e,!0);else if(!a.isDefaultPrevented()){e=a.target;var h,i=q.nodeName(e,"a")&&f==="click",j=q.event.special[f]||{};if((!j._default||j._default.call(d,a)===!1)&&!i&&!(e&&e.nodeName&&q.noData[e.nodeName.toLowerCase()])){try{if(e[f]){if(h=e["on"+f])e["on"+f]=null;q.event.triggered=!0,e[f]()}}catch(k){}h&&(e["on"+f]=h),q.event.triggered=!1}}},handle:function(c){var d,e,f,g;c=arguments[0]=q.event.fix(c||a.event),c.currentTarget=this,d=c.type.indexOf(".")<0&&!c.exclusive,d||(e=c.type.split("."),c.type=e.shift(),f=new RegExp("(^|\\.)"+e.slice(0).sort().join("\\.(?:.*\\.)?")+"(\\.|$)")),g=q.data(this,"events"),e=g[c.type];if(g&&e){e=e.slice(0),g=0;for(var h=e.length;g<h;g++){var i=e[g];if(d||f.test(i.namespace)){c.handler=i.handler,c.data=i.data,c.handleObj=i,i=i.handler.apply(this,arguments),i!==b&&(c.result=i,i===!1&&(c.preventDefault(),c.stopPropagation()));if(c.isImmediatePropagationStopped())break}}}return c.result},props:"altKey attrChange attrName bubbles button cancelable charCode clientX clientY ctrlKey currentTarget data detail eventPhase fromElement handler keyCode layerX layerY metaKey newValue offsetX offsetY originalTarget pageX pageY prevValue relatedNode relatedTarget screenX screenY shiftKey srcElement target toElement view wheelDelta which".split(" "),fix:function(a){if(a[J])return a;var c=a;a=q.Event(c);for(var d=this.props.length,e;d;)e=this.props[--d],a[e]=c[e];a.target||(a.target=a.srcElement||t),a.target.nodeType===3&&(a.target=a.target.parentNode),!a.relatedTarget&&a.fromElement&&(a.relatedTarget=a.fromElement===a.target?a.toElement:a.fromElement),a.pageX==null&&a.clientX!=null&&(c=t.documentElement,d=t.body,a.pageX=a.clientX+(c&&c.scrollLeft||d&&d.scrollLeft||0)-(c&&c.clientLeft||d&&d.clientLeft||0),a.pageY=a.clientY+(c&&c.scrollTop||d&&d.scrollTop||0)-(c&&c.clientTop||d&&d.clientTop||0)),!a.which&&(a.charCode||a.charCode===0?a.charCode:a.keyCode)&&(a.which=a.charCode||a.keyCode),!a.metaKey&&a.ctrlKey&&(a.metaKey=a.ctrlKey),!a.which&&a.button!==b&&(a.which=a.button&1?1:a.button&2?3:a.button&4?2:0);return a},guid:1e8,proxy:q.proxy,special:{ready:{setup:q.bindReady,teardown:q.noop},live:{add:function(a){q.event.add(this,a.origType,q.extend({},a,{handler:j}))},remove:function(a){var b=!0,c=a.origType.replace(U,"");q.each(q.data(this,"events").live||[],function(){if(c===this.origType.replace(U,""))return b=!1}),b&&q.event.remove(this,a.origType,j)}},beforeunload:{setup:function(a,b,c){this.setInterval&&(this.onbeforeunload=c);return!1},teardown:function(a,b){this.onbeforeunload===b&&(this.onbeforeunload=null)}}}};var W=t.removeEventListener?function(a,b,c){a.removeEventListener(b,c,!1)}:function(a,b,c){a.detachEvent("on"+b,c)};q.Event=function(a){if(!this.preventDefault)return new q.Event(a);a&&a.type?(this.originalEvent=a,this.type=a.type):this.type=a,this.timeStamp=f(),this[J]=!0},q.Event.prototype={preventDefault:function(){this.isDefaultPrevented=h;var a=this.originalEvent;a&&(a.preventDefault&&a.preventDefault(),a.returnValue=!1)},stopPropagation:function(){this.isPropagationStopped=h;var a=this.originalEvent;a&&(a.stopPropagation&&a.stopPropagation(),a.cancelBubble=!0)},stopImmediatePropagation:function(){this.isImmediatePropagationStopped=h,this.stopPropagation()},isDefaultPrevented:g,isPropagationStopped:g,isImmediatePropagationStopped:g};var X=function(a){var b=a.relatedTarget;try{for(;b&&b!==this;)b=b.parentNode;b!==this&&(a.type=a.data,q.event.handle.apply(this,arguments))}catch(c){}},Y=function(a){a.type=a.data,q.event.handle.apply(this,arguments)};q.each({mouseenter:"mouseover",mouseleave:"mouseout"},function(a,b){q.event.special[a]={setup:function(c){q.event.add(this,b,c&&c.selector?Y:X,a)},teardown:function(a){q.event.remove(this,b,a&&a.selector?Y:X)}}}),q.support.submitBubbles||(q.event.special.submit={setup:function(){if(this.nodeName.toLowerCase()!=="form")q.event.add(this,"click.specialSubmit",function(a){var b=a.target,c=b.type;if((c==="submit"||c==="image")&&q(b).closest("form").length)return i("submit",this,arguments)}),q.event.add(this,"keypress.specialSubmit",function(a){var b=a.target,c=b.type;if((c==="text"||c==="password")&&q(b).closest("form").length&&a.keyCode===13)return i("submit",this,arguments)});else return!1},teardown:function(){q.event.remove(this,".specialSubmit")}});if(!q.support.changeBubbles){var Z=/textarea|input|select/i,$,_=function(a){var b=a.type,c=a.value;b==="radio"||b==="checkbox"?c=a.checked:b==="select-multiple"?c=a.selectedIndex>-1?q.map(a.options,function(a){return a.selected}).join("-"):"":a.nodeName.toLowerCase()==="select"&&(c=a.selectedIndex);return c},ba=function(a,c){var d=a.target,e,f;if(Z.test(d.nodeName)&&!d.readOnly){e=q.data(d,"_change_data"),f=_(d),(a.type!=="focusout"||d.type!=="radio")&&q.data(d,"_change_data",f);if(e!==b&&f!==e)if(e!=null||f){a.type="change";return q.event.trigger(a,c,d)}}};q.event.special.change={filters:{focusout:ba,click:function(a){var b=a.target,c=b.type;if(c==="radio"||c==="checkbox"||b.nodeName.toLowerCase()==="select")return ba.call(this,a)},keydown:function(a){var b=a.target,c=b.type;if(a.keyCode===13&&b.nodeName.toLowerCase()!=="textarea"||a.keyCode===32&&(c==="checkbox"||c==="radio")||c==="select-multiple")return ba.call(this,a)},beforeactivate:function(a){a=a.target,q.data(a,"_change_data",_(a))}},setup:function(){if(this.type==="file")return!1;for(var a in $)q.event.add(this,a+".specialChange",$[a]);return Z.test(this.nodeName)},teardown:function(){q.event.remove(this,".specialChange");return Z.test(this.nodeName)}},$=q.event.special.change.filters}t.addEventListener&&q.each({focus:"focusin",blur:"focusout"},function(a,b){function c(a){a=q.event.fix(a),a.type=b;return q.event.handle.call(this,a)}q.event.special[b]={setup:function(){this.addEventListener(a,c,!0)},teardown:function(){this.removeEventListener(a,c,!0)}}}),q.each(["bind","one"],function(a,c){q.fn[c]=function(a,d,e){if(typeof a==="object"){for(var f in a)this[c](f,d,a[f],e);return this}q.isFunction(d)&&(e=d,d=b);var g=c==="one"?q.proxy(e,function(a){q(this).unbind(a,g);return e.apply(this,arguments)}):e;if(a==="unload"&&c!=="one")this.one(a,d,e);else{f=0;for(var h=this.length;f<h;f++)q.event.add(this[f],a,g,d)}return this}}),q.fn.extend({unbind:function(a,b){if(typeof a!=="object"||a.preventDefault){c=0;for(var d=this.length;c<d;c++)q.event.remove(this[c],a,b)}else for(var c in a)this.unbind(c,a[c]);return this},delegate:function(a,b,c,d){return this.live(b,c,d,a)},undelegate:function(a,b,c){return arguments.length===0?this.unbind("live"):this.die(b,null,c,a)},trigger:function(a,b){return this.each(function(){q.event.trigger(a,b,this)})},triggerHandler:function(a,b){if(this[0]){a=q.Event(a),a.preventDefault(),a.stopPropagation(),q.event.trigger(a,b,this[0]);return a.result}},toggle:function(a){for(var b=arguments,c=1;c<b.length;)q.proxy(a,b[c++]);return this.click(q.proxy(a,function(d){var e=(q.data(this,"lastToggle"+a.guid)||0)%c;q.data(this,"lastToggle"+a.guid,e+1),d.preventDefault();return b[e].apply(this,arguments)||!1}))},hover:function(a,b){return this.mouseenter(a).mouseleave(b||a)}});var bb={focus:"focusin",blur:"focusout",mouseenter:"mouseover",mouseleave:"mouseout"};q.each(["live","die"],function(a,c){q.fn[c]=function(a,d,e,f){var g,h=0,i,j,l=f||this.selector,m=f?this:q(this.context);q.isFunction(d)&&(e=d,d=b);for(a=(a||"").split(" ");(g=a[h++])!=null;)f=U.exec(g),i="",f&&(i=f[0],g=g.replace(U,"")),g==="hover"?a.push("mouseenter"+i,"mouseleave"+i):(j=g,g==="focus"||g==="blur"?(a.push(bb[g]+i),g+=i):g=(bb[g]||g)+i,c==="live"?m.each(function(){q.event.add(this,k(g,l),{data:d,selector:l,handler:e,origType:g,origHandler:e,preType:j})}):m.unbind(k(g,l),e));return this}}),q.each("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error".split(" "),function(a,b){q.fn[b]=function(a){return a?this.bind(b,a):this.trigger(b)},q.attrFn&&(q.attrFn[b]=!0)}),a.attachEvent&&!a.addEventListener&&a.attachEvent("onunload",function(){for(var a in q.cache)if(q.cache[a].handle)try{q.event.remove(q.cache[a].handle.elem)}catch(b){}}),function(){function d(a,b,c,d,e,f){e=0;for(var g=d.length;e<g;e++){var h=d[e];if(h){h=h[a];for(var i=!1;h;){if(h.sizcache===c){i=d[h.sizset];break}if(h.nodeType===1){f||(h.sizcache=c,h.sizset=e);if(typeof b!=="string"){if(h===b){i=!0;break}}else if(j.filter(b,[h]).length>0){i=h;break}}h=h[a]}d[e]=i}}}function c(a,b,c,d,e,f){e=0;for(var g=d.length;e<g;e++){var h=d[e];if(h){h=h[a];for(var i=!1;h;){if(h.sizcache===c){i=d[h.sizset];break}h.nodeType===1&&!f&&(h.sizcache=c,h.sizset=e);if(h.nodeName.toLowerCase()===b){i=h;break}h=h[a]}d[e]=i}}}function a(b){for(var c="",d,e=0;b[e];e++)d=b[e],d.nodeType===3||d.nodeType===4?c+=d.nodeValue:d.nodeType!==8&&(c+=a(d.childNodes));return c}var e=/((?:\((?:\([^()]+\)|[^()]+)+\)|\[(?:\[[^[\]]*\]|['"][^'"]*['"]|[^[\]'"]+)+\]|\\.|[^ >+~,(\[\\]+)+|[>+~])(\s*,\s*)?((?:.|\r|\n)*)/g,f=0,g=Object.prototype.toString,h=!1,i=!0;[0,0].sort(function(){i=!1;return 0});var j=function(a,b,c,d){c=c||[];var f=b=b||t;if(b.nodeType!==1&&b.nodeType!==9)return[];if(!a||typeof a!=="string")return c;for(var h=[],i,m,o,p,q=!0,v=s(b),w=a;(e.exec(""),i=e.exec(w))!==null;){w=i[3],h.push(i[1]);if(i[2]){p=i[3];break}}if(h.length>1&&l.exec(a))if(h.length===2&&k.relative[h[0]])m=u(h[0]+h[1],b);else for(m=k.relative[h[0]]?[b]:j(h.shift(),b);h.length;)a=h.shift(),k.relative[a]&&(a+=h.shift()),m=u(a,m);else{!d&&h.length>1&&b.nodeType===9&&!v&&k.match.ID.test(h[0])&&!k.match.ID.test(h[h.length-1])&&(i=j.find(h.shift(),b,v),b=i.expr?j.filter(i.expr,i.set)[0]:i.set[0]);if(b){i=d?{expr:h.pop(),set:n(d)}:j.find(h.pop(),h.length===1&&(h[0]==="~"||h[0]==="+")&&b.parentNode?b.parentNode:b,v),m=i.expr?j.filter(i.expr,i.set):i.set,h.length>0?o=n(m):q=!1;for(;h.length;){var x=h.pop();i=x,k.relative[x]?i=h.pop():x="",i==null&&(i=b),k.relative[x](o,i,v)}}else o=[]}o||(o=m),o||j.error(x||a);if(g.call(o)==="[object Array]")if(q)if(b&&b.nodeType===1)for(a=0;o[a]!=null;a++)o[a]&&(o[a]===!0||o[a].nodeType===1&&r(b,o[a]))&&c.push(m[a]);else for(a=0;o[a]!=null;a++)o[a]&&o[a].nodeType===1&&c.push(m[a]);else c.push.apply(c,o);else n(o,c);p&&(j(p,f,c,d),j.uniqueSort(c));return c};j.uniqueSort=function(a){if(p){h=i,a.sort(p);if(h)for(var b=1;b<a.length;b++)a[b]===a[b-1]&&a.splice(b--,1)}return a},j.matches=function(a,b){return j(a,null,null,b)},j.find=function(a,b,c){var d,e;if(!a)return[];for(var f=0,g=k.order.length;f<g;f++){var h=k.order[f];if(e=k.leftMatch[h].exec(a)){var i=e[1];e.splice(1,1);if(i.substr(i.length-1)!=="\\"){e[1]=(e[1]||"").replace(/\\/g,""),d=k.find[h](e,b,c);if(d!=null){a=a.replace(k.match[h],"");break}}}}d||(d=b.getElementsByTagName("*"));return{set:d,expr:a}},j.filter=function(a,c,d,e){for(var f=a,g=[],h=c,i,l,m=c&&c[0]&&s(c[0]);a&&c.length;){for(var n in k.filter)if((i=k.leftMatch[n].exec(a))!=null&&i[2]){var o=k.filter[n],p,q;q=i[1],l=!1,i.splice(1,1);if(q.substr(q.length-1)!=="\\"){h===g&&(g=[]);if(k.preFilter[n])if(i=k.preFilter[n](i,h,d,g,e,m)){if(i===!0)continue}else l=p=!0;if(i)for(var r=0;(q=h[r])!=null;r++)if(q){p=o(q,i,r,h);var t=e^!!p;d&&p!=null?t?l=!0:h[r]=!1:t&&(g.push(q),l=!0)}if(p!==b){d||(h=g),a=a.replace(k.match[n],"");if(!l)return[];break}}}if(a===f)if(l==null)j.error(a);else break;f=a}return h},j.error=function(a){throw"Syntax error, unrecognized expression: "+a};var k=j.selectors={order:["ID","NAME","TAG"],match:{ID:/#((?:[\w\u00c0-\uFFFF-]|\\.)+)/,CLASS:/\.((?:[\w\u00c0-\uFFFF-]|\\.)+)/,NAME:/\[name=['"]*((?:[\w\u00c0-\uFFFF-]|\\.)+)['"]*\]/,ATTR:/\[\s*((?:[\w\u00c0-\uFFFF-]|\\.)+)\s*(?:(\S?=)\s*(['"]*)(.*?)\3|)\s*\]/,TAG:/^((?:[\w\u00c0-\uFFFF\*-]|\\.)+)/,CHILD:/:(only|nth|last|first)-child(?:\((even|odd|[\dn+-]*)\))?/,POS:/:(nth|eq|gt|lt|first|last|even|odd)(?:\((\d*)\))?(?=[^-]|$)/,PSEUDO:/:((?:[\w\u00c0-\uFFFF-]|\\.)+)(?:\((['"]?)((?:\([^\)]+\)|[^\(\)]*)+)\2\))?/},leftMatch:{},attrMap:{"class":"className","for":"htmlFor"},attrHandle:{href:function(a){return a.getAttribute("href")}},relative:{"+":function(a,b){var c=typeof b==="string",d=c&&!/\W/.test(b);c=c&&!d,d&&(b=b.toLowerCase()),d=0;for(var e=a.length,f;d<e;d++)if(f=a[d]){for(;(f=f.previousSibling)&&f.nodeType!==1;);a[d]=c||f&&f.nodeName.toLowerCase()===b?f||!1:f===b}c&&j.filter(b,a,!0)},">":function(a,b){var c=typeof b==="string";if(c&&!/\W/.test(b)){b=b.toLowerCase();for(var d=0,e=a.length;d<e;d++){var f=a[d];f&&(c=f.parentNode,a[d]=c.nodeName.toLowerCase()===b?c:!1)}}else{d=0;for(e=a.length;d<e;d++)if(f=a[d])a[d]=c?f.parentNode:f.parentNode===b;c&&j.filter(b,a,!0)}},"":function(a,b,e){var g=f++,h=d;if(typeof b==="string"&&!/\W/.test(b)){var i=b=b.toLowerCase();h=c}h("parentNode",b,g,a,i,e)},"~":function(a,b,e){var g=f++,h=d;if(typeof b==="string"&&!/\W/.test(b)){var i=b=b.toLowerCase();h=c}h("previousSibling",b,g,a,i,e)}},find:{ID:function(a,b,c){if(typeof b.getElementById!=="undefined"&&!c)return(a=b.getElementById(a[1]))?[a]:[]},NAME:function(a,b){if(typeof b.getElementsByName!=="undefined"){var c=[];b=b.getElementsByName(a[1]);for(var d=0,e=b.length;d<e;d++)b[d].getAttribute("name")===a[1]&&c.push(b[d]);return c.length===0?null:c}},TAG:function(a,b){return b.getElementsByTagName(a[1])}},preFilter:{CLASS:function(a,b,c,d,e,f){a=" "+a[1].replace(/\\/g,"")+" ";if(f)return a;f=0;for(var g;(g=b[f])!=null;f++)g&&(e^(g.className&&(" "+g.className+" ").replace(/[\t\n]/g," ").indexOf(a)>=0)?c||d.push(g):c&&(b[f]=!1));return!1},ID:function(a){return a[1].replace(/\\/g,"")},TAG:function(a){return a[1].toLowerCase()},CHILD:function(a){if(a[1]==="nth"){var b=/(-?)(\d*)n((?:\+|-)?\d*)/.exec(a[2]==="even"&&"2n"||a[2]==="odd"&&"2n+1"||!/\D/.test(a[2])&&"0n+"+a[2]||a[2]);a[2]=b[1]+(b[2]||1)-0,a[3]=b[3]-0}a[0]=f++;return a},ATTR:function(a,b,c,d,e,f){b=a[1].replace(/\\/g,""),!f&&k.attrMap[b]&&(a[1]=k.attrMap[b]),a[2]==="~="&&(a[4]=" "+a[4]+" ");return a},PSEUDO:function(a,b,c,d,f){if(a[1]==="not")if((e.exec(a[3])||"").length>1||/^\w/.test(a[3]))a[3]=j(a[3],null,null,b);else{a=j.filter(a[3],b,c,!0^f),c||d.push.apply(d,a);return!1}else if(k.match.POS.test(a[0])||k.match.CHILD.test(a[0]))return!0;return a},POS:function(a){a.unshift(!0);return a}},filters:{enabled:function(a){return a.disabled===!1&&a.type!=="hidden"},disabled:function(a){return a.disabled===!0},checked:function(a){return a.checked===!0},selected:function(a){return a.selected===!0},parent:function(a){return!!a.firstChild},empty:function(a){return!a.firstChild},has:function(a,b,c){return!!j(c[3],a).length},header:function(a){return/h\d/i.test(a.nodeName)},text:function(a){return"text"===a.type},radio:function(a){return"radio"===a.type},checkbox:function(a){return"checkbox"===a.type},file:function(a){return"file"===a.type},password:function(a){return"password"===a.type},submit:function(a){return"submit"===a.type},image:function(a){return"image"===a.type},reset:function(a){return"reset"===a.type},button:function(a){return"button"===a.type||a.nodeName.toLowerCase()==="button"},input:function(a){return/input|select|textarea|button/i.test(a.nodeName)}},setFilters:{first:function(a,b){return b===0},last:function(a,b,c,d){return b===d.length-1},even:function(a,b){return b%2===0},odd:function(a,b){return b%2===1},lt:function(a,b,c){return b<c[3]-0},gt:function(a,b,c){return b>c[3]-0},nth:function(a,b,c){return c[3]-0===b},eq:function(a,b,c){return c[3]-0===b}},filter:{PSEUDO:function(b,c,d,e){var f=c[1],g=k.filters[f];if(g)return g(b,d,c,e);if(f==="contains")return(b.textContent||b.innerText||a([b])||"").indexOf(c[3])>=0;if(f==="not"){c=c[3],d=0;for(e=c.length;d<e;d++)if(c[d]===b)return!1;return!0}j.error("Syntax error, unrecognized expression: "+f)},CHILD:function(a,b){var c=b[1],d=a;switch(c){case"only":case"first":for(;d=d.previousSibling;)if(d.nodeType===1)return!1;if(c==="first")return!0;d=a;case"last":for(;d=d.nextSibling;)if(d.nodeType===1)return!1;return!0;case"nth":c=b[2];var e=b[3];if(c===1&&e===0)return!0;b=b[0];var f=a.parentNode;if(f&&(f.sizcache!==b||!a.nodeIndex)){var g=0;for(d=f.firstChild;d;d=d.nextSibling)d.nodeType===1&&(d.nodeIndex=++g);f.sizcache=b}a=a.nodeIndex-e;return c===0?a===0:a%c===0&&a/c>=0}},ID:function(a,b){return a.nodeType===1&&a.getAttribute("id")===b},TAG:function(a,b){return b==="*"&&a.nodeType===1||a.nodeName.toLowerCase()===b},CLASS:function(a,b){return(" "+(a.className||a.getAttribute("class"))+" ").indexOf(b)>-1},ATTR:function(a,b){var c=b[1];a=k.attrHandle[c]?k.attrHandle[c](a):a[c]!=null?a[c]:a.getAttribute(c),c=a+"";var d=b[2];b=b[4];return a==null?d==="!=":d==="="?c===b:d==="*="?c.indexOf(b)>=0:d==="~="?(" "+c+" ").indexOf(b)>=0:b?d==="!="?c!==b:d==="^="?c.indexOf(b)===0:d==="$="?c.substr(c.length-b.length)===b:d==="|="?c===b||c.substr(0,b.length+1)===b+"-":!1:c&&a!==!1},POS:function(a,b,c,d){var e=k.setFilters[b[2]];if(e)return e(a,c,b,d)}}},l=k.match.POS;for(var m in k.match)k.match[m]=new RegExp(k.match[m].source+/(?![^\[]*\])(?![^\(]*\))/.source),k.leftMatch[m]=new RegExp(/(^(?:.|\r|\n)*?)/.source+k.match[m].source.replace(/\\(\d+)/g,function(a,b){return"\\"+(b-0+1)}));var n=function(a,b){a=Array.prototype.slice.call(a,0);if(b){b.push.apply(b,a);return b}return a};try{Array.prototype.slice.call(t.documentElement.childNodes,0)}catch(o){n=function(a,b){b=b||[];if(g.call(a)==="[object Array]")Array.prototype.push.apply(b,a);else if(typeof a.length==="number")for(var c=0,d=a.length;c<d;c++)b.push(a[c]);else for(c=0;a[c];c++)b.push(a[c]);return b}}var p;t.documentElement.compareDocumentPosition?p=function(a,b){if(!a.compareDocumentPosition||!b.compareDocumentPosition){a==b&&(h=!0);return a.compareDocumentPosition?-1:1}a=a.compareDocumentPosition(b)&4?-1:a===b?0:1,a===0&&(h=!0);return a}:"sourceIndex"in t.documentElement?p=function(a,b){if(!a.sourceIndex||!b.sourceIndex){a==b&&(h=!0);return a.sourceIndex?-1:1}a=a.sourceIndex-b.sourceIndex,a===0&&(h=!0);return a}:t.createRange&&(p=function(a,b){if(!a.ownerDocument||!b.ownerDocument){a==b&&(h=!0);return a.ownerDocument?-1:1}var c=a.ownerDocument.createRange(),d=b.ownerDocument.createRange();c.setStart(a,0),c.setEnd(a,0),d.setStart(b,0),d.setEnd(b,0),a=c.compareBoundaryPoints(Range.START_TO_END,d),a===0&&(h=!0);return a}),function(){var a=t.createElement("div"),c="script"+(new Date).getTime();a.innerHTML="<a name='"+c+"'/>";var d=t.documentElement;d.insertBefore(a,d.firstChild),t.getElementById(c)&&(k.find.ID=function(a,c,d){if(typeof c.getElementById!=="undefined"&&!d)return(c=c.getElementById(a[1]))?c.id===a[1]||typeof c.getAttributeNode!=="undefined"&&c.getAttributeNode("id").nodeValue===a[1]?[c]:b:[]},k.filter.ID=function(a,b){var c=typeof a.getAttributeNode!=="undefined"&&a.getAttributeNode("id");return a.nodeType===1&&c&&c.nodeValue===b}),d.removeChild(a),d=a=null}(),function(){var a=t.createElement("div");a.appendChild(t.createComment("")),a.getElementsByTagName("*").length>0&&(k.find.TAG=function(a,b){b=b.getElementsByTagName(a[1]);if(a[1]==="*"){a=[];for(var c=0;b[c];c++)b[c].nodeType===1&&a.push(b[c]);b=a}return b}),a.innerHTML="<a href='#'></a>",a.firstChild&&typeof a.firstChild.getAttribute!=="undefined"&&a.firstChild.getAttribute("href")!=="#"&&(k.attrHandle.href=function(a){return a.getAttribute("href",2)}),a=null}(),t.querySelectorAll&&function(){var a=j,b=t.createElement("div");b.innerHTML="<p class='TEST'></p>";if(!b.querySelectorAll||b.querySelectorAll(".TEST").length!==0){j=function(b,c,d,e){c=c||t;if(!e&&c.nodeType===9&&!s(c))try{return n(c.querySelectorAll(b),d)}catch(f){}return a(b,c,d,e)};for(var c in a)j[c]=a[c];b=null}}(),function(){var a=t.createElement("div");a.innerHTML="<div class='test e'></div><div class='test'></div>",a.getElementsByClassName&&a.getElementsByClassName("e").length!==0&&(a.lastChild.className="e",a.getElementsByClassName("e").length!==1&&(k.order.splice(1,0,"CLASS"),k.find.CLASS=function(a,b,c){if(typeof b.getElementsByClassName!=="undefined"&&!c)return b.getElementsByClassName(a[1])},a=null))}();var r=t.compareDocumentPosition?function(a,b){return!!(a.compareDocumentPosition(b)&16)}:function(a,b){return a!==b&&(a.contains?a.contains(b):!0)},s=function(a){return(a=(a?a.ownerDocument||a:0).documentElement)?a.nodeName!=="HTML":!1},u=function(a,b){var c=[],d="",e;for(b=b.nodeType?[b]:b;e=k.match.PSEUDO.exec(a);)d+=e[0],a=a.replace(k.match.PSEUDO,"");a=k.relative[a]?a+"*":a,e=0;for(var f=b.length;e<f;e++)j(a,b[e],c);return j.filter(d,c)};q.find=j,q.expr=j.selectors,q.expr[":"]=q.expr.filters,q.unique=j.uniqueSort,q.text=a,q.isXMLDoc=s,q.contains=r}();var bc=/Until$/,bd=/^(?:parents|prevUntil|prevAll)/,be=/,/;H=Array.prototype.slice;var bf=function(a,b,c){if(q.isFunction(b))return q.grep(a,function(a,d){return!!b.call(a,d,a)===c});if(b.nodeType)return q.grep(a,function(a){return a===b===c});if(typeof b==="string"){var d=q.grep(a,function(a){return a.nodeType===1});if(w.test(b))return q.filter(b,d,!c);b=q.filter(b,d)}return q.grep(a,function(a){return q.inArray(a,b)>=0===c})};q.fn.extend({find:function(a){for(var b=this.pushStack("","find",a),c=0,d=0,e=this.length;d<e;d++){c=b.length,q.find(a,this[d],b);if(d>0)for(var f=c;f<b.length;f++)for(var g=0;g<c;g++)if(b[g]===b[f]){b.splice(f--,1);break}}return b},has:function(a){var b=q(a);return this.filter(function(){for(var a=0,c=b.length;a<c;a++)if(q.contains(this,b[a]))return!0})},not:function(a){return this.pushStack(bf(this,a,!1),"not",a)},filter:function(a){return this.pushStack(bf(this,a,!0),"filter",a)},is:function(a){return!!a&&q.filter(a,this).length>0},closest:function(a,b){if(q.isArray(a)){var c=[],d=this[0],e,f={},g;if(d&&a.length){e=0;for(var h=a.length;e<h;e++)g=a[e],f[g]||(f[g]=q.expr.match.POS.test(g)?q(g,b||this.context):g);for(;d&&d.ownerDocument&&d!==b;){for(g in f){e=f[g];if(e.jquery?e.index(d)>-1:q(d).is(e))c.push({selector:g,elem:d}),delete f[g]}d=d.parentNode}}return c}var i=q.expr.match.POS.test(a)?q(a,b||this.context):null;return this.map(function(c,d){for(;d&&d.ownerDocument&&d!==b;){if(i?i.index(d)>-1:q(d).is(a))return d;d=d.parentNode}return null})},index:function(a){if(!a||typeof a==="string")return q.inArray(this[0],a?q(a):this.parent().children());return q.inArray(a.jquery?a[0]:a,this)},add:function(a,b){a=typeof a==="string"?q(a,b||this.context):q.makeArray(a),b=q.merge(this.get(),a);return this.pushStack(l(a[0])||l(b[0])?b:q.unique(b))},andSelf:function(){return this.add(this.prevObject)}}),q.each({parent:function(a){return(a=a.parentNode)&&a.nodeType!==11?a:null},parents:function(a){return q.dir(a,"parentNode")},parentsUntil:function(a,b,c){return q.dir(a,"parentNode",c)},next:function(a){return q.nth(a,2,"nextSibling")},prev:function(a){return q.nth(a,2,"previousSibling")},nextAll:function(a){return q.dir(a,"nextSibling")},prevAll:function(a){return q.dir(a,"previousSibling")},nextUntil:function(a,b,c){return q.dir(a,"nextSibling",c)},prevUntil:function(a,b,c){return q.dir(a,"previousSibling",c)},siblings:function(a){return q.sibling(a.parentNode.firstChild,a)},children:function(a){return q.sibling(a.firstChild)},contents:function(a){return q.nodeName(a,"iframe")?a.contentDocument||a.contentWindow.document:q.makeArray(a.childNodes)}},function(a,b){q.fn[a]=function(c,d){var e=q.map(this,b,c);bc.test(a)||(d=c),d&&typeof d==="string"&&(e=q.filter(d,e)),e=this.length>1?q.unique(e):e,(this.length>1||be.test(d))&&bd.test(a)&&(e=e.reverse());return this.pushStack(e,a,H.call(arguments).join(","))}}),q.extend({filter:function(a,b,c){c&&(a=":not("+a+")");return q.find.matches(a,b)},dir:function(a,c,d){var e=[];for(a=a[c];a&&a.nodeType!==9&&(d===b||a.nodeType!==1||!q(a).is(d));)a.nodeType===1&&e.push(a),a=a[c];return e},nth:function(a,b,c){b=b||1;for(var d=0;a;a=a[c])if(a.nodeType===1&&++d===b)break;return a},sibling:function(a,b){for(var c=[];a;a=a.nextSibling)a.nodeType===1&&a!==b&&c.push(a);return c}});var bg=/ jQuery\d+="(?:\d+|null)"/g,bh=/^\s+/,bi=/(<([\w:]+)[^>]*?)\/>/g,bj=/^(?:area|br|col|embed|hr|img|input|link|meta|param)$/i,bk=/<([\w:]+)/,bl=/<tbody/i,bm=/<|&#?\w+;/,bn=/<script|<object|<embed|<option|<style/i,bo=/checked\s*(?:[^=]|=\s*.checked.)/i,bp=function(a,b,c){return bj.test(c)?a:b+"></"+c+">"},bq={option:[1,"<select multiple='multiple'>","</select>"],legend:[1,"<fieldset>","</fieldset>"],thead:[1,"<table>","</table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],col:[2,"<table><tbody></tbody><colgroup>","</colgroup></table>"],area:[1,"<map>","</map>"],_default:[0,"",""]};bq.optgroup=bq.option,bq.tbody=bq.tfoot=bq.colgroup=bq.caption=bq.thead,bq.th=bq.td,q.support.htmlSerialize||(bq._default=[1,"div<div>","</div>"]),q.fn.extend({text:function(a){if(q.isFunction(a))return this.each(function(b){var c=q(this);c.text(a.call(this,b,c.text()))});if(typeof a!=="object"&&a!==b)return this.empty().append((this[0]&&this[0].ownerDocument||t).createTextNode(a));return q.text(this)},wrapAll:function(a){if(q.isFunction(a))return this.each(function(b){q(this).wrapAll(a.call(this,b))});if(this[0]){var b=q(a,this[0].ownerDocument).eq(0).clone(!0);this[0].parentNode&&b.insertBefore(this[0]),b.map(function(){for(var a=this;a.firstChild&&a.firstChild.nodeType===1;)a=a.firstChild;return a}).append(this)}return this},wrapInner:function(a){if(q.isFunction(a))return this.each(function(b){q(this).wrapInner(a.call(this,b))});return this.each(function(){var b=q(this),c=b.contents();c.length?c.wrapAll(a):b.append(a)})},wrap:function(a){return this.each(function(){q(this).wrapAll(a)})},unwrap:function(){return this.parent().each(function(){q.nodeName(this,"body")||q(this).replaceWith(this.childNodes)}).end()},append:function(){return this.domManip(arguments,!0,function(a){this.nodeType===1&&this.appendChild(a)})},prepend:function(){return this.domManip(arguments,!0,function(a){this.nodeType===1&&this.insertBefore(a,this.firstChild)})},before:function(){if(this[0]&&this[0].parentNode)return this.domManip(arguments,!1,function(a){this.parentNode.insertBefore(a,this)});if(arguments.length){var a=q(arguments[0]);a.push.apply(a,this.toArray());return this.pushStack(a,"before",arguments)}},after:function(){if(this[0]&&this[0].parentNode)return this.domManip(arguments,!1,function(a){this.parentNode.insertBefore(a,this.nextSibling)});if(arguments.length){var a=this.pushStack(this,"after",arguments);a.push.apply(a,q(arguments[0]).toArray());return a}},remove:function(a,b){for(var c=0,d;(d=this[c])!=null;c++)if(!a||q.filter(a,[d]).length)!b&&d.nodeType===1&&(q.cleanData(d.getElementsByTagName("*")),q.cleanData([d])),d.parentNode&&d.parentNode.removeChild(d);return this},empty:function(){for(var a=0,b;(b=this[a])!=null;a++)for(b.nodeType===1&&q.cleanData(b.getElementsByTagName("*"));b.firstChild;)b.removeChild(b.firstChild);return this},clone:function(a){var b=this.map(function(){if(q.support.noCloneEvent||q.isXMLDoc(this))return this.cloneNode(!0);var a=this.outerHTML,b=this.ownerDocument;a||(a=b.createElement("div"),a.appendChild(this.cloneNode(!0)),a=a.innerHTML);return q.clean([a.replace(bg,"").replace(/=([^="'>\s]+\/)>/g,'="$1">').replace(bh,"")],b)[0]});a===!0&&(m(this,b),m(this.find("*"),b.find("*")));return b},html:function(a){if(a===b)return this[0]&&this[0].nodeType===1?this[0].innerHTML.replace(bg,""):null;if(typeof a!=="string"||bn.test(a)||!q.support.leadingWhitespace&&bh.test(a)||bq[(bk.exec(a)||["",""])[1].toLowerCase()])q.isFunction(a)?this.each(function(b){var c=q(this),d=c.html();c.empty().append(function(){return a.call(this,b,d)})}):this.empty().append(a);else{a=a.replace(bi,bp);try{for(var c=0,d=this.length;c<d;c++)this[c].nodeType===1&&(q.cleanData(this[c].getElementsByTagName("*")),this[c].innerHTML=a)}catch(e){this.empty().append(a)}}return this},replaceWith:function(a){if(this[0]&&this[0].parentNode){if(q.isFunction(a))return this.each(function(b){var c=q(this),d=c.html();c.replaceWith(a.call(this,b,d))});typeof a!=="string"&&(a=q(a).detach());return this.each(function(){var b=this.nextSibling,c=this.parentNode;q(this).remove(),b?q(b).before(a):q(c).append(a)})}return this.pushStack(q(q.isFunction(a)?a():a),"replaceWith",a)},detach:function(a){return this.remove(a,!0)},domManip:function(a,c,e){function f(a){return q.nodeName(a,"table")?a.getElementsByTagName("tbody")[0]||a.appendChild(a.ownerDocument.createElement("tbody")):a}var g,h,i=a[0],j=[],k;if(!q.support.checkClone&&arguments.length===3&&typeof i==="string"&&bo.test(i))return this.each(function(){q(this).domManip(a,c,e,!0)});if(q.isFunction(i))return this.each(function(d){var f=q(this);a[0]=i.call(this,d,c?f.html():b),f.domManip(a,c,e)});if(this[0]){g=i&&i.parentNode,g=q.support.parentNode&&g&&g.nodeType===11&&g.childNodes.length===this.length?{fragment:g}:n(a,this,j),k=g.fragment;if(h=k.childNodes.length===1?k=k.firstChild:k.firstChild){c=c&&q.nodeName(h,"tr");for(var l=0,m=this.length;l<m;l++)e.call(c?f(this[l],h):this[l],l>0||g.cacheable||this.length>1?k.cloneNode(!0):k)}j.length&&q.each(j,d)}return this}}),q.fragments={},q.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(a,b){q.fn[a]=function(c){var d=[];c=q(c);var e=this.length===1&&this[0].parentNode;if(e&&e.nodeType===11&&e.childNodes.length===1&&c.length===1){c[b](this[0]);return this}e=0;for(var f=c.length;e<f;e++){var g=(e>0?this.clone(!0):this).get();q.fn[b].apply(q(c[e]),g),d=d.concat(g)}return this.pushStack(d,a,c.selector)}}),q.extend({clean:function(a,b,c,d){b=b||t,typeof b.createElement==="undefined"&&(b=b.ownerDocument||b[0]&&b[0].ownerDocument||t);for(var e=[],f=0,g;(g=a[f])!=null;f++){typeof g==="number"&&(g+="");if(g){if(typeof g!=="string"||bm.test(g)){if(typeof g==="string"){g=g.replace(bi,bp);var h=(bk.exec(g)||["",""])[1].toLowerCase(),i=bq[h]||bq._default,j=i[0],k=b.createElement("div");for(k.innerHTML=i[1]+g+i[2];j--;)k=k.lastChild;if(!q.support.tbody){j=bl.test(g),h=h==="table"&&!j?k.firstChild&&k.firstChild.childNodes:i[1]==="<table>"&&!j?k.childNodes:[];for(i=h.length-1;i>=0;--i)q.nodeName(h[i],"tbody")&&!h[i].childNodes.length&&h[i].parentNode.removeChild(h[i])}!q.support.leadingWhitespace&&bh.test(g)&&k.insertBefore(b.createTextNode(bh.exec(g)[0]),k.firstChild),g=k.childNodes}}else g=b.createTextNode(g);g.nodeType?e.push(g):e=q.merge(e,g)}}if(c)for(f=0;e[f];f++)!d||!q.nodeName(e[f],"script")||e[f].type&&e[f].type.toLowerCase()!=="text/javascript"?(e[f].nodeType===1&&e.splice.apply(e,[f+1,0].concat(q.makeArray(e[f].getElementsByTagName("script")))),c.appendChild(e[f])):d.push(e[f].parentNode?e[f].parentNode.removeChild(e[f]):e[f]);return e},cleanData:function(a){for(var b,c,d=q.cache,e=q.event.special,f=q.support.deleteExpando,g=0,h;(h=a[g])!=null;g++)if(c=h[q.expando]){b=d[c];if(b.events)for(var i in b.events)e[i]?q.event.remove(h,i):W(h,i,b.handle);f?delete h[q.expando]:h.removeAttribute&&h.removeAttribute(q.expando),delete d[c]}}});var br=/z-?index|font-?weight|opacity|zoom|line-?height/i,bs=/alpha\([^)]*\)/,bt=/opacity=([^)]*)/,bu=/float/i,bv=/-([a-z])/ig,bw=/([A-Z])/g,bx=/^-?\d+(?:px)?$/i,by=/^-?\d/,bz={position:"absolute",visibility:"hidden",display:"block"},bA=["Left","Right"],bB=["Top","Bottom"],bC=t.defaultView&&t.defaultView.getComputedStyle,bD=q.support.cssFloat?"cssFloat":"styleFloat",bE=function(a,b){return b.toUpperCase()};q.fn.css=function(a,c){return e(this,a,c,!0,function(a,c,d){if(d===b)return q.curCSS(a,c);typeof d==="number"&&!br.test(c)&&(d+="px"),q.style(a,c,d)})},q.extend({style:function(a,c,d){if(!a||a.nodeType===3||a.nodeType===8)return b;(c==="width"||c==="height")&&parseFloat(d)<0&&(d=b);var e=a.style||a,f=d!==b;if(!q.support.opacity&&c==="opacity"){f&&(e.zoom=1,c=parseInt(d,10)+"NaN"?"":"alpha(opacity="+d*100+")",a=e.filter||q.curCSS(a,"filter")||"",e.filter=bs.test(a)?a.replace(bs,c):c);return e.filter&&e.filter.indexOf("opacity=")>=0?parseFloat(bt.exec(e.filter)[1])/100+"":""}bu.test(c)&&(c=bD),c=c.replace(bv,bE),f&&(e[c]=d);return e[c]},css:function(a,b,c,d){if(b==="width"||b==="height"){var e,f=b==="width"?bA:bB;function g(){e=b==="width"?a.offsetWidth:a.offsetHeight,d!=="border"&&q.each(f,function(){d||(e-=parseFloat(q.curCSS(a,"padding"+this,!0))||0),d==="margin"?e+=parseFloat(q.curCSS(a,"margin"+this,!0))||0:e-=parseFloat(q.curCSS(a,"border"+this+"Width",!0))||0})}a.offsetWidth!==0?g():q.swap(a,bz,g);return Math.max(0,Math.round(e))}return q.curCSS(a,b,c)},curCSS:function(a,b,c){var d,e=a.style;if(!q.support.opacity&&b==="opacity"&&a.currentStyle){d=bt.test(a.currentStyle.filter||"")?parseFloat(RegExp.$1)/100+"":"";return d===""?"1":d}bu.test(b)&&(b=bD);if(!c&&e&&e[b])d=e[b];else if(bC){bu.test(b)&&(b="float"),b=b.replace(bw,"-$1").toLowerCase(),e=a.ownerDocument.defaultView;if(!e)return null;if(a=e.getComputedStyle(a,null))d=a.getPropertyValue(b);b==="opacity"&&d===""&&(d="1")}else if(a.currentStyle){c=b.replace(bv,bE),d=a.currentStyle[b]||a.currentStyle[c];if(!bx.test(d)&&by.test(d)){b=e.left;var f=a.runtimeStyle.left;a.runtimeStyle.left=a.currentStyle.left,e.left=c==="fontSize"?"1em":d||0,d=e.pixelLeft+"px",e.left=b,a.runtimeStyle.left=f}}return d},swap:function(a,b,c){var d={};for(var e in b)d[e]=a.style[e],a.style[e]=b[e];c.call(a);for(e in b)a.style[e]=d[e]}}),q.expr&&q.expr.filters&&(q.expr.filters.hidden=function(a){var b=a.offsetWidth,c=a.offsetHeight,d=a.nodeName.toLowerCase()==="tr";return b===0&&c===0&&!d?!0:b>0&&c>0&&!d?!1:q.curCSS(a,"display")==="none"},q.expr.filters.visible=function(a){return!q.expr.filters.hidden(a)});var bF=f(),bG=/<script(.|\s)*?\/script>/gi,bH=/select|textarea/i,bI=/color|date|datetime|email|hidden|month|number|password|range|search|tel|text|time|url|week/i,bJ=/=\?(&|$)/,bK=/\?/,bL=/(\?|&)_=.*?(&|$)/,bM=/^(\w+:)?\/\/([^\/?#]+)/,bN=/%20/g,bO=q.fn.load;q.fn.extend({load:function(a,b,c){if(typeof a!=="string")return bO.call(this,a);if(!this.length)return this;var d=a.indexOf(" ");if(d>=0){var e=a.slice(d,a.length);a=a.slice(0,d)}d="GET",b&&(q.isFunction(b)?(c=b,b=null):typeof b==="object"&&(b=q.param(b,q.ajaxSettings.traditional),d="POST"));var f=this;q.ajax({url:a,type:d,dataType:"html",data:b,complete:function(a,b){(b==="success"||b==="notmodified")&&f.html(e?q("<div />").append(a.responseText.replace(bG,"")).find(e):a.responseText),c&&f.each(c,[a.responseText,b,a])}});return this},serialize:function(){return q.param(this.serializeArray())},serializeArray:function(){return this.map(function(){return this.elements?q.makeArray(this.elements):this}).filter(function(){return this.name&&!this.disabled&&(this.checked||bH.test(this.nodeName)||bI.test(this.type))}).map(function(a,b){a=q(this).val();return a==null?null:q.isArray(a)?q.map(a,function(a){return{name:b.name,value:a}}):{name:b.name,value:a}}).get()}}),q.each("ajaxStart ajaxStop ajaxComplete ajaxError ajaxSuccess ajaxSend".split(" "),function(a,b){q.fn[b]=function(a){return this.bind(b,a)}}),q.extend({get:function(a,b,c,d){q.isFunction(b)&&(d=d||c,c=b,b=null);return q.ajax({type:"GET",url:a,data:b,success:c,dataType:d})},getScript:function(a,b){return q.get(a,null,b,"script")},getJSON:function(a,b,c){return q.get(a,b,c,"json")},post:function(a,b,c,d){q.isFunction(b)&&(d=d||c,c=b,b={});return q.ajax({type:"POST",url:a,data:b,success:c,dataType:d})},ajaxSetup:function(a){q.extend(q.ajaxSettings,a)},ajaxSettings:{url:location.href,global:!0,type:"GET",contentType:"application/x-www-form-urlencoded",processData:!0,async:!0,xhr:a.XMLHttpRequest&&(a.location.protocol!=="file:"||!a.ActiveXObject)?function(){return new a.XMLHttpRequest}:function(){try{return new a.ActiveXObject("Microsoft.XMLHTTP")}catch(b){}},accepts:{xml:"application/xml, text/xml",html:"text/html",script:"text/javascript, application/javascript",json:"application/json, text/javascript",text:"text/plain",_default:"*/*"}},lastModified:{},etag:{},ajax:function(c){function g(a,b){(h.context?q(h.context):q.event).trigger(a,b)}function e(){h.complete&&h.complete.call(l,v,j),h.global&&g("ajaxComplete",[v,h]),h.global&&!--q.active&&q.event.trigger("ajaxStop")}function d(){h.success&&h.success.call(l,k,j,v),h.global&&g("ajaxSuccess",[v,h])}var h=q.extend(!0,{},q.ajaxSettings,c),i,j,k,l=c&&c.context||h,m=h.type.toUpperCase();h.data&&h.processData&&typeof h.data!=="string"&&(h.data=q.param(h.data,h.traditional));if(h.dataType==="jsonp"){if(m==="GET")bJ.test(h.url)||(h.url+=(bK.test(h.url)?"&":"?")+(h.jsonp||"callback")+"=?");else if(!h.data||!bJ.test(h.data))h.data=(h.data?h.data+"&":"")+(h.jsonp||"callback")+"=?";h.dataType="json"}h.dataType==="json"&&(h.data&&bJ.test(h.data)||bJ.test(h.url))&&(i=h.jsonpCallback||"jsonp"+bF++,h.data&&(h.data=(h.data+"").replace(bJ,"="+i+"$1")),h.url=h.url.replace(bJ,"="+i+"$1"),h.dataType="script",a[i]=a[i]||function(c){k=c,d(),e(),a[i]=b;try{delete a[i]}catch(f){}p&&p.removeChild(r)}),h.dataType==="script"&&h.cache===null&&(h.cache=!1);if(h.cache===!1&&m==="GET"){var n=f(),o=h.url.replace(bL,"$1_="+n+"$2");h.url=o+(o===h.url?(bK.test(h.url)?"&":"?")+"_="+n:"")}h.data&&m==="GET"&&(h.url+=(bK.test(h.url)?"&":"?")+h.data),h.global&&!(q.active++)&&q.event.trigger("ajaxStart"),n=(n=bM.exec(h.url))&&(n[1]&&n[1]!==location.protocol||n[2]!==location.host);if(h.dataType==="script"&&m==="GET"&&n){var p=t.getElementsByTagName("head")[0]||t.documentElement,r=t.createElement("script");r.src=h.url,h.scriptCharset&&(r.charset=h.scriptCharset);if(!i){var s=!1;r.onload=r.onreadystatechange=function(){!s&&(!this.readyState||this.readyState==="loaded"||this.readyState==="complete")&&(s=!0,d(),e(),r.onload=r.onreadystatechange=null,p&&r.parentNode&&p.removeChild(r))}}p.insertBefore(r,p.firstChild);return b}var u=!1,v=h.xhr();if(v){h.username?v.open(m,h.url,h.async,h.username,h.password):v.open(m,h.url,h.async);try{(h.data||c&&c.contentType)&&v.setRequestHeader("Content-Type",h.contentType),h.ifModified&&(q.lastModified[h.url]&&v.setRequestHeader("If-Modified-Since",q.lastModified[h.url]),q.etag[h.url]&&v.setRequestHeader("If-None-Match",q.etag[h.url])),n||v.setRequestHeader("X-Requested-With","XMLHttpRequest"),v.setRequestHeader("Accept",h.dataType&&h.accepts[h.dataType]?h.accepts[h.dataType]+", */*":h.accepts._default)}catch(w){}if(h.beforeSend&&h.beforeSend.call(l,v,h)===!1){h.global&&!--q.active&&q.event.trigger("ajaxStop"),v.abort();return!1}h.global&&g("ajaxSend",[v,h]);var x=v.onreadystatechange=function(a){if(v&&v.readyState!==0&&a!=="abort"){if(!u&&v&&(v.readyState===4||a==="timeout")){u=!0,v.onreadystatechange=q.noop,j=a==="timeout"?"timeout":q.httpSuccess(v)?h.ifModified&&q.httpNotModified(v,h.url)?"notmodified":"success":"error";var b;if(j==="success")try{k=q.httpData(v,h.dataType,h)}catch(c){j="parsererror",b=c}j==="success"||j==="notmodified"?i||d():q.handleError(h,v,j,b),e(),a==="timeout"&&v.abort(),h.async&&(v=null)}}else u||e(),u=!0,v&&(v.onreadystatechange=q.noop)};try{var y=v.abort;v.abort=function(){v&&y.call(v),x("abort")}}catch(z){}h.async&&h.timeout>0&&setTimeout(function(){v&&!u&&x("timeout")},h.timeout);try{v.send(m==="POST"||m==="PUT"||m==="DELETE"?h.data:null)}catch(A){q.handleError(h,v,null,A),e()}h.async||x();return v}},handleError:function(a,b,c,d){a.error&&a.error.call(a.context||a,b,c,d),a.global&&(a.context?q(a.context):q.event).trigger("ajaxError",[b,a,d])},active:0,httpSuccess:function(a){try{return!a.status&&location.protocol==="file:"||a.status>=200&&a.status<300||a.status===304||a.status===1223||a.status===0}catch(b){}return!1},httpNotModified:function(a,b){var c=a.getResponseHeader("Last-Modified"),d=a.getResponseHeader("Etag");c&&(q.lastModified[b]=c),d&&(q.etag[b]=d);return a.status===304||a.status===0},httpData:function(a,b,c){var d=a.getResponseHeader("content-type")||"",e=b==="xml"||!b&&d.indexOf("xml")>=0;a=e?a.responseXML:a.responseText,e&&a.documentElement.nodeName==="parsererror"&&q.error("parsererror"),c&&c.dataFilter&&(a=c.dataFilter(a,b)),typeof a==="string"&&(b==="json"||!b&&d.indexOf("json")>=0?a=q.parseJSON(a):(b==="script"||!b&&d.indexOf("javascript")>=0)&&q.globalEval(a));return a},param:function(a,c){function e(a,b){b=q.isFunction(b)?b():b,f[f.length]=encodeURIComponent(a)+"="+encodeURIComponent(b)}function d(a,b){q.isArray(b)?q.each(b,function(b,f){c||/\[\]$/.test(a)?e(a,f):d(a+"["+(typeof f==="object"||q.isArray(f)?b:"")+"]",f)}):!c&&b!=null&&typeof b==="object"?q.each(b,function(b,c){d(a+"["+b+"]",c)}):e(a,b)}var f=[];c===b&&(c=q.ajaxSettings.traditional);if(q.isArray(a)||a.jquery)q.each(a,function(){e(this.name,this.value)});else for(var g in a)d(g,a[g]);return f.join("&").replace(bN,"+")}});var bP={},bQ=/toggle|show|hide/,bR=/^([+-]=)?([\d+-.]+)(.*)$/,bS,bT=[["height","marginTop","marginBottom","paddingTop","paddingBottom"],["width","marginLeft","marginRight","paddingLeft","paddingRight"],["opacity"]];q.fn.extend({show:function(a,b){if(a||a===0)return this.animate(o("show",3),a,b);a=0;for(b=this.length;a<b;a++){var c=q.data(this[a],"olddisplay");this[a].style.display=c||"";if(q.css(this[a],"display")==="none"){c=this[a].nodeName;var d;if(bP[c])d=bP[c];else{var e=q("<"+c+" />").appendTo("body");d=e.css("display"),d==="none"&&(d="block"),e.remove(),bP[c]=d}q.data(this[a],"olddisplay",d)}}a=0;for(b=this.length;a<b;a++)this[a].style.display=q.data(this[a],"olddisplay")||"";return this},hide:function(a,b){if(a||a===0)return this.animate(o("hide",3),a,b);a=0;for(b=this.length;a<b;a++){var c=q.data(this[a],"olddisplay");!c&&c!=="none"&&q.data(this[a],"olddisplay",q.css(this[a],"display"))}a=0;for(b=this.length;a<b;a++)this[a].style.display="none";return this},_toggle:q.fn.toggle,toggle:function(a,b){var c=typeof a==="boolean";q.isFunction(a)&&q.isFunction(b)?this._toggle.apply(this,arguments):a==null||c?this.each(function(){var b=c?a:q(this).is(":hidden");q(this)[b?"show":"hide"]()}):this.animate(o("toggle",3),a,b);return this},fadeTo:function(a,b,c){return this.filter(":hidden").css("opacity",0).show().end().animate({opacity:b},a,c)},animate:function(a,b,c,d){var e=q.speed(b,c,d);if(q.isEmptyObject(a))return this.each(e.complete);return this[e.queue===!1?"each":"queue"](function(){var b=q.extend({},e),c,d=this.nodeType===1&&q(this).is(":hidden"),f=this;for(c in a){var g=c.replace(bv,bE);c!==g&&(a[g]=a[c],delete a[c],c=g);if(a[c]==="hide"&&d||a[c]==="show"&&!d)return b.complete.call(this);(c==="height"||c==="width")&&this.style&&(b.display=q.css(this,"display"),b.overflow=this.style.overflow),q.isArray(a[c])&&((b.specialEasing=b.specialEasing||{})[c]=a[c][1],a[c]=a[c][0])}b.overflow!=null&&(this.style.overflow="hidden"),b.curAnim=q.extend({},a),q.each(a,function(c,e){var g=new q.fx(f,b,c);if(bQ.test(e))g[e==="toggle"?d?"show":"hide":e](a);else{var h=bR.exec(e),i=g.cur(!0)||0;if(h){e=parseFloat(h[2]);var j=h[3]||"px";j!=="px"&&(f.style[c]=(e||1)+j,i=(e||1)/g.cur(!0)*i,f.style[c]=i+j),h[1]&&(e=(h[1]==="-="?-1:1)*e+i),g.custom(i,e,j)}else g.custom(i,e,"")}});return!0})},stop:function(a,b){var c=q.timers;a&&this.queue([]),this.each(function(){for(var a=c.length-1;a>=0;a--)c[a].elem===this&&(b&&c[a](!0),c.splice(a,1))}),b||this.dequeue();return this}}),q.each({slideDown:o("show",1),slideUp:o("hide",1),slideToggle:o("toggle",1),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"}},function(a,b){q.fn[a]=function(a,c){return this.animate(b,a,c)}}),q.extend({speed:function(a,b,c){var d=a&&typeof a==="object"?a:{complete:c||!c&&b||q.isFunction(a)&&a,duration:a,easing:c&&b||b&&!q.isFunction(b)&&b};d.duration=q.fx.off?0:typeof d.duration==="number"?d.duration:q.fx.speeds[d.duration]||q.fx.speeds._default,d.old=d.complete,d.complete=function(){d.queue!==!1&&q(this).dequeue(),q.isFunction(d.old)&&d.old.call(this)};return d},easing:{linear:function(a,b,c,d){return c+d*a},swing:function(a,b,c,d){return(-Math.cos(a*Math.PI)/2+.5)*d+c}},timers:[],fx:function(a,b,c){this.options=b,this.elem=a,this.prop=c,b.orig||(b.orig={})}}),q.fx.prototype={update:function(){this.options.step&&this.options.step.call(this.elem,this.now,this),(q.fx.step[this.prop]||q.fx.step._default)(this),(this.prop==="height"||this.prop==="width")&&this.elem.style&&(this.elem.style.display="block")},cur:function(a){if(this.elem[this.prop]!=null&&(!this.elem.style||this.elem.style[this.prop]==null))return this.elem[this.prop];return(a=parseFloat(q.css(this.elem,this.prop,a)))&&a>-1e4?a:parseFloat(q.curCSS(this.elem,this.prop))||0},custom:function(a,b,c){function d(a){return e.step(a)}this.startTime=f(),this.start=a,this.end=b,this.unit=c||this.unit||"px",this.now=this.start,this.pos=this.state=0;var e=this;d.elem=this.elem,d()&&q.timers.push(d)&&!bS&&(bS=setInterval(q.fx.tick,13))},show:function(){this.options.orig[this.prop]=q.style(this.elem,this.prop),this.options.show=!0,this.custom(this.prop==="width"||this.prop==="height"?1:0,this.cur()),q(this.elem).show()},hide:function(){this.options.orig[this.prop]=q.style(this.elem,this.prop),this.options.hide=!0,this.custom(this.cur(),0)},step:function(a){var b=f(),c=!0;if(a||b>=this.options.duration+this.startTime){this.now=this.end,this.pos=this.state=1,this.update(),this.options.curAnim[this.prop]=!0;for(var d in this.options.curAnim)this.options.curAnim[d]!==!0&&(c=!1);if(c){this.options.display!=null&&(this.elem.style.overflow=this.options.overflow,a=q.data(this.elem,"olddisplay"),this.elem.style.display=a?a:this.options.display,q.css(this.elem,"display")==="none"&&(this.elem.style.display="block")),this.options.hide&&q(this.elem).hide();if(this.options.hide||this.options.show)for(var e in this.options.curAnim)q.style(this.elem,e,this.options.orig[e]);this.options.complete.call(this.elem)}return!1}e=b-this.startTime,this.state=e/this.options.duration,a=this.options.easing||(q.easing.swing?"swing":"linear"),this.pos=q.easing[this.options.specialEasing&&this.options.specialEasing[this.prop]||a](this.state,e,0,1,this.options.duration),this.now=this.start+(this.end-this.start)*this.pos,this.update();return!0}},q.extend(q.fx,{tick:function(){for(var a=q.timers,b=0;b<a.length;b++)a[b]()||a.splice(b--,1);a.length||q.fx.stop()},stop:function(){clearInterval(bS),bS=null},speeds:{slow:600,fast:200,_default:400},step:{opacity:function(a){q.style(a.elem,"opacity",a.now)},_default:function(a){a.elem.style&&a.elem.style[a.prop]!=null?a.elem.style[a.prop]=(a.prop==="width"||a.prop==="height"?Math.max(0,a.now):a.now)+a.unit:a.elem[a.prop]=a.now}}}),q.expr&&q.expr.filters&&(q.expr.filters.animated=function(a){return q.grep(q.timers,function(b){return a===b.elem}).length}),q.fn.offset="getBoundingClientRect"in t.documentElement?function(a){var b=this[0];if(a)return this.each(function(b){q.offset.setOffset(this,a,b)});if(!b||!b.ownerDocument)return null;if(b===b.ownerDocument.body)return q.offset.bodyOffset(b);var c=b.getBoundingClientRect(),d=b.ownerDocument;b=d.body,d=d.documentElement;return{top:c.top+(self.pageYOffset||q.support.boxModel&&d.scrollTop||b.scrollTop)-(d.clientTop||b.clientTop||0),left:c.left+(self.pageXOffset||q.support.boxModel&&d.scrollLeft||b.scrollLeft)-(d.clientLeft||b.clientLeft||0)}}:function(a){var b=this[0];if(a)return this.each(function(b){q.offset.setOffset(this,a,b)});if(!b||!b.ownerDocument)return null;if(b===b.ownerDocument.body)return q.offset.bodyOffset(b);q.offset.initialize();var c=b.offsetParent,d=b,e=b.ownerDocument,f,g=e.documentElement,h=e.body;d=(e=e.defaultView)?e.getComputedStyle(b,null):b.currentStyle;for(var i=b.offsetTop,j=b.offsetLeft;(b=b.parentNode)&&b!==h&&b!==g;){if(q.offset.supportsFixedPosition&&d.position==="fixed")break;f=e?e.getComputedStyle(b,null):b.currentStyle,i-=b.scrollTop,j-=b.scrollLeft,b===c&&(i+=b.offsetTop,j+=b.offsetLeft,q.offset.doesNotAddBorder&&(!q.offset.doesAddBorderForTableAndCells||!/^t(able|d|h)$/i.test(b.nodeName))&&(i+=parseFloat(f.borderTopWidth)||0,j+=parseFloat(f.borderLeftWidth)||0),d=c,c=b.offsetParent),q.offset.subtractsBorderForOverflowNotVisible&&f.overflow!=="visible"&&(i+=parseFloat(f.borderTopWidth)||0,j+=parseFloat(f.borderLeftWidth)||0),d=f}if(d.position==="relative"||d.position==="static")i+=h.offsetTop,j+=h.offsetLeft;q.offset.supportsFixedPosition&&d.position==="fixed"&&(i+=Math.max(g.scrollTop,h.scrollTop),j+=Math.max(g.scrollLeft,h.scrollLeft));return{top:i,left:j}},q.offset={initialize:function(){var a=t.body,b=t.createElement("div"),c,d,e,f=parseFloat(q.curCSS(a,"marginTop",!0))||0;q.extend(b.style,{position:"absolute",top:0,left:0,margin:0,border:0,width:"1px",height:"1px",visibility:"hidden"}),b.innerHTML="<div style='position:absolute;top:0;left:0;margin:0;border:5px solid #000;padding:0;width:1px;height:1px;'><div></div></div><table style='position:absolute;top:0;left:0;margin:0;border:5px solid #000;padding:0;width:1px;height:1px;' cellpadding='0' cellspacing='0'><tr><td></td></tr></table>",a.insertBefore(b,a.firstChild),c=b.firstChild,d=c.firstChild,e=c.nextSibling.firstChild.firstChild,this.doesNotAddBorder=d.offsetTop!==5,this.doesAddBorderForTableAndCells=e.offsetTop===5,d.style.position="fixed",d.style.top="20px",this.supportsFixedPosition=d.offsetTop===20||d.offsetTop===15,d.style.position=d.style.top="",c.style.overflow="hidden",c.style.position="relative",this.subtractsBorderForOverflowNotVisible=d.offsetTop===-5,this.doesNotIncludeMarginInBodyOffset=a.offsetTop!==f,a.removeChild(b),q.offset.initialize=q.noop},bodyOffset:function(a){var b=a.offsetTop,c=a.offsetLeft;q.offset.initialize(),q.offset.doesNotIncludeMarginInBodyOffset&&(b+=parseFloat(q.curCSS(a,"marginTop",!0))||0,c+=parseFloat(q.curCSS(a,"marginLeft",!0))||0);return{top:b,left:c}},setOffset:function(a,b,c){/static/.test(q.curCSS(a,"position"))&&(a.style.position="relative");var d=q(a),e=d.offset(),f=parseInt(q.curCSS(a,"top",!0),10)||0,g=parseInt(q.curCSS(a,"left",!0),10)||0;q.isFunction(b)&&(b=b.call(a,c,e)),c={top:b.top-e.top+f,left:b.left-e.left+g},"using"in b?b.using.call(a,c):d.css(c)}},q.fn.extend({position:function(){if(!this[0])return null;var a=this[0],b=this.offsetParent(),c=this.offset(),d=/^body|html$/i.test(b[0].nodeName)?{top:0,left:0}:b.offset();c.top-=parseFloat(q.curCSS(a,"marginTop",!0))||0,c.left-=parseFloat(q.curCSS(a,"marginLeft",!0))||0,d.top+=parseFloat(q.curCSS(b[0],"borderTopWidth",!0))||0,d.left+=parseFloat(q.curCSS(b[0],"borderLeftWidth",!0))||0;return{top:c.top-d.top,left:c.left-d.left}},offsetParent:function(){return this.map(function(){for(var a=this.offsetParent||t.body;a&&!/^body|html$/i.test(a.nodeName)&&q.css(a,"position")==="static";)a=a.offsetParent;return a})}}),q.each(["Left","Top"],function(a,c){var d="scroll"+c;q.fn[d]=function(c){var e=this[0],f;if(!e)return null;return c!==b?this.each(function(){(f=p(this))?f.scrollTo(a?q(f).scrollLeft():c,a?c:q(f).scrollTop()):this[d]=c}):(f=p(e))?"pageXOffset"in f?f[a?"pageYOffset":"pageXOffset"]:q.support.boxModel&&f.document.documentElement[d]||f.document.body[d]:e[d]}}),q.each(["Height","Width"],function(a,c){var d=c.toLowerCase();q.fn["inner"+c]=function(){return this[0]?q.css(this[0],d,!1,"padding"):null},q.fn["outer"+c]=function(a){return this[0]?q.css(this[0],d,!1,a?"margin":"border"):null},q.fn[d]=function(a){var e=this[0];if(!e)return a==null?null:this;if(q.isFunction(a))return this.each(function(b){var c=q(this);c[d](a.call(this,b,c[d]()))});return"scrollTo"in e&&e.document?e.document.compatMode==="CSS1Compat"&&e.document.documentElement["client"+c]||e.document.body["client"+c]:e.nodeType===9?Math.max(e.documentElement["client"+c],e.body["scroll"+c],e.documentElement["scroll"+c],e.body["offset"+c],e.documentElement["offset"+c]):a===b?q.css(e,d):this.css(d,typeof a==="string"?a:a+"px")}}),a.jQuery=a.$=q}(window),define("lib/jquery",function(){}),define("lib/underscore",["./jquery"],function(){var a=window,b=a._,c={},d=Array.prototype,e=Object.prototype,f=d.slice,g=d.unshift,h=e.toString,i=e.hasOwnProperty,j=d.forEach,k=d.map,l=d.reduce,m=d.reduceRight,n=d.filter,o=d.every,p=d.some,q=d.indexOf,r=d.lastIndexOf,s=Array.isArray,t=Object.keys,u=function(a){return new z(a)};typeof module!=="undefined"&&module.exports?(module.exports=u,u._=u):a._=u,u.VERSION="1.1.3";var v=u.each=u.forEach=function(a,b,d){var e;if(j&&a.forEach===j)a.forEach(b,d);else if(u.isNumber(a.length)){for(var f=0,g=a.length;f<g;f++)if(b.call(d,a[f],f,a)===c)return}else for(var h in a)if(i.call(a,h))if(b.call(d,a[h],h,a)===c)return};u.map=function(a,b,c){if(k&&a.map===k)return a.map(b,c);var d=[];v(a,function(a,e,f){d[d.length]=b.call(c,a,e,f)});return d},u.reduce=u.foldl=u.inject=function(a,b,c,d){var e=c!==void 0;if(l&&a.reduce===l){d&&(b=u.bind(b,d));return e?a.reduce(b,c):a.reduce(b)}v(a,function(a,f,g){e||f!==0?c=b.call(d,c,a,f,g):c=a});return c},u.reduceRight=u.foldr=function(a,b,c,d){if(m&&a.reduceRight===m){d&&(b=u.bind(b,d));return c!==void 0?a.reduceRight(b,c):a.reduceRight(b)}var e=(u.isArray(a)?a.slice():u.toArray(a)).reverse();return u.reduce(e,b,c,d)},u.find=u.detect=function(a,b,c){var d;w(a,function(a,e,f){if(b.call(c,a,e,f)){d=a;return!0}});return d},u.filter=u.select=function(a,b,c){if(n&&a.filter===n)return a.filter(b,c);var d=[];v(a,function(a,e,f){b.call(c,a,e,f)&&(d[d.length]=a)});return d},u.reject=function(a,b,c){var d=[];v(a,function(a,e,f){b.call(c,a,e,f)||(d[d.length]=a)});return d},u.every=u.all=function(a,b,d){b=b||u.identity;if(o&&a.every===o)return a.every(b,d);var e=!0;v(a,function(a,f,g){if(!(e=e&&b.call(d,a,f,g)))return c});return e};var w=u.some=u.any=function(a,b,d){b=b||u.identity;if(p&&a.some===p)return a.some(b,d);var e=!1;v(a,function(a,f,g){if(e=b.call(d,a,f,g))return c});return e};u.include=u.contains=function(a,b){if(q&&a.indexOf===q)return a.indexOf(b)!=-1;var c=!1;w(a,function(a){if(c=a===b)return!0});return c},u.invoke=function(a,b){var c=f.call(arguments,2);return u.map(a,function(a){return(b?a[b]:a).apply(a,c)})},u.pluck=function(a,b){return u.map(a,function(a){return a[b]})},u.max=function(a,b,c){if(!b&&u.isArray(a))return Math.max.apply(Math,a);var d={computed:-Infinity};v(a,function(a,e,f){var g=b?b.call(c,a,e,f):a;g>=d.computed&&(d={value:a,computed:g})});return d.value},u.min=function(a,b,c){if(!b&&u.isArray(a))return Math.min.apply(Math,a);var d={computed:Infinity};v(a,function(a,e,f){var g=b?b.call(c,a,e,f):a;g<d.computed&&(d={value:a,computed:g})});return d.value},u.sortBy=function(a,b,c){return u.pluck(u.map(a,function(a,d,e){return{value:a,criteria:b.call(c,a,d,e)}}).sort(function(a,b){var c=a.criteria,d=b.criteria;return c<d?-1:c>d?1:0}),"value")},u.sortedIndex=function(a,b,c){c=c||u.identity;var d=0,e=a.length;while(d<e){var f=d+e>>1;c(a[f])<c(b)?d=f+1:e=f}return d},u.toArray=function(a){if(!a)return[];if(a.toArray)return a.toArray();if(u.isArray(a))return a;if(u.isArguments(a))return f.call(a);return u.values(a)},u.size=function(a){return u.toArray(a).length},u.first=u.head=function(a,b,c){return b&&!c?f.call(a,0,b):a[0]},u.rest=u.tail=function(a,b,c){return f.call(a,u.isUndefined(b)||c?1:b)},u.last=function(a){return a[a.length-1]},u.compact=function(a){return u.filter(a,function(a){return!!a})},u.flatten=function(a){return u.reduce(a,function(a,b){if(u.isArray(b))return a.concat(u.flatten(b));a[a.length]=b;return a},[])},u.without=function(a){var b=f.call(arguments,1);return u.filter(a,function(a){return!u.include(b,a)})},u.uniq=u.unique=function(a,b){return u.reduce(a,function(a,c,d){if(0==d||(b===!0?u.last(a)!=c:!u.include(a,c)))a[a.length]=c;return a},[])},u.intersect=function(a){var b=f.call(arguments,1);return u.filter(u.uniq(a),function(a){return u.every(b,function(b){return u.indexOf(b,a)>=0})})},u.zip=function(){var a=f.call(arguments),b=u.max(u.pluck(a,"length")),c=Array(b);for(var d=0;d<b;d++)c[d]=u.pluck(a,""+d);return c},u.indexOf=function(a,b){if(q&&a.indexOf===q)return a.indexOf(b);for(var c=0,d=a.length;c<d;c++)if(a[c]===b)return c;return-1},u.lastIndexOf=function(a,b){if(r&&a.lastIndexOf===r)return a.lastIndexOf(b);var c=a.length;while(c--)if(a[c]===b)return c;return-1},u.range=function(a,b,c){var d=f.call(arguments),e=d.length<=1,a=e?0:d[0],b=e?d[0]:d[1],c=d[2]||1,g=Math.max(Math.ceil((b-a)/c),0),h=0,i=Array(g);while(h<g)i[h++]=a,a+=c;return i},u.bind=function(a,b){var c=f.call(arguments,2);return function(){return a.apply(b||{},c.concat(f.call(arguments)))}},u.bindAll=function(a){var b=f.call(arguments,1);b.length==0&&(b=u.functions(a)),v(b,function(b){a[b]=u.bind(a[b],a)});return a},u.memoize=function(a,b){var c={};b=b||u.identity;return function(){var d=b.apply(this,arguments);return d in c?c[d]:c[d]=a.apply(this,arguments)}},u.delay=function(a,b){var c=f.call(arguments,2);return setTimeout(function(){return a.apply(a,c)},b)},u.defer=function(a){return u.delay.apply(u,[a,1].concat(f.call(arguments,1)))};var x=function(a,b,c){var d;return function(){var e=this,f=arguments,g=function(){d=null,a.apply(e,f)};c&&clearTimeout(d);if(c||!d)d=setTimeout(g,b)}};u.throttle=function(a,b){return x(a,b,!1)},u.debounce=function(a,b){return x(a,b,!0)},u.wrap=function(a,b){return function(){var c=[a].concat(f.call(arguments));return b.apply(b,c)}},u.compose=function(){var a=f.call(arguments);return function(){var b=f.call(arguments);for(var c=a.length-1;c>=0;c--)b=[a[c].apply(this,b)];return b[0]}},u.keys=t||function(a){if(u.isArray(a))return u.range(0,a.length);var b=[];for(var c in a)i.call(a,c)&&(b[b.length]=c);return b},u.values=function(a){return u.map(a,u.identity)},u.functions=u.methods=function(a){return u.filter(u.keys(a),function(b){return u.isFunction(a[b])}).sort()},u.extend=function(a){v(f.call(arguments,1),function(b){for(var c in b)a[c]=b[c]});return a},u.clone=function(a){return u.isArray(a)?a.slice():u.extend({},a)},u.tap=function(a,b){b(a);return a},u.isEqual=function(a,b){if(a===b)return!0;var c=typeof a,d=typeof b;if(c!=d)return!1;if(a==b)return!0;if(!a&&b||a&&!b)return!1;if(a.isEqual)return a.isEqual(b);if(u.isDate(a)&&u.isDate(b))return a.getTime()===b.getTime();if(u.isNaN(a)&&u.isNaN(b))return!1;if(u.isRegExp(a)&&u.isRegExp(b))return a.source===b.source&&a.global===b.global&&a.ignoreCase===b.ignoreCase&&a.multiline===b.multiline;if(c!=="object")return!1;if(a.length&&a.length!==b.length)return!1;var e=u.keys(a),f=u.keys(b);if(e.length!=f.length)return!1;for(var g in a)if(!(g in b)||!u.isEqual(a[g],b[g]))return!1;return!0},u.isEmpty=function(a){if(u.isArray(a)||u.isString(a))return a.length===0;for(var b in a)if(i.call(a,b))return!1;return!0},u.isElement=function(a){return a&&a.nodeType==1},u.isArray=s||function(a){return a&&a.concat&&a.unshift&&!a.callee},u.isArguments=function(a){return a&&a.callee},u.isFunction=function(a){return!!(a&&a.constructor&&a.call&&a.apply)},u.isString=function(a){return!!(a===""||a&&a.charCodeAt&&a.substr)},u.isNumber=function(a){return!!(a===0||a&&a.toExponential&&a.toFixed)},u.isNaN=function(a){return h.call(a)==="[object Number]"&&isNaN(a)},u.isBoolean=function(a){return a===!0||a===!1},u.isDate=function(a){return!!(a&&a.getTimezoneOffset&&a.setUTCFullYear)},u.isRegExp=function(a){return a&&a.test&&a.exec&&(a.ignoreCase||a.ignoreCase===!1)},u.isNull=function(a){return a===null},u.isUndefined=function(a){return a===void 0},u.noConflict=function(){a._=b;return this},u.identity=function(a){return a},u.times=function(a,b,c){for(var d=0;d<a;d++)b.call(c,d)},u.mixin=function(a){v(u.functions(a),function(b){B(b,u[b]=a[b])})};var y=0;u.uniqueId=function(a){var b=y++;return a?a+b:b},u.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g},u.template=function(a,b){var c=u.templateSettings,d="var __p=[],print=function(){__p.push.apply(__p,arguments);};with(obj||{}){__p.push('"+a.replace(/\\/g,"\\\\").replace(/'/g,"\\'").replace(c.interpolate,function(a,b){return"',"+b.replace(/\\'/g,"'")+",'"}).replace(c.evaluate||null,function(a,b){return"');"+b.replace(/\\'/g,"'").replace(/[\r\n\t]/g," ")+"__p.push('"}).replace(/\r/g,"\\r").replace(/\n/g,"\\n").replace(/\t/g,"\\t")+"');}return __p.join('');",e=new Function("obj",d);return b?e(b):e};var z=function(a){this._wrapped=a};u.prototype=z.prototype;var A=function(a,b){return b?u(a).chain():a},B=function(a,b){z.prototype[a]=function(){var a=f.call(arguments);g.call(a,this._wrapped);return A(b.apply(u,a),this._chain)}};u.mixin(u),v(["pop","push","reverse","shift","sort","splice","unshift"],function(a){var b=d[a];z.prototype[a]=function(){b.apply(this._wrapped,arguments);return A(this._wrapped,this._chain)}}),v(["concat","join","slice"],function(a){var b=d[a];z.prototype[a]=function(){return A(b.apply(this._wrapped,arguments),this._chain)}}),z.prototype.chain=function(){this._chain=!0;return this},z.prototype.value=function(){return this._wrapped}}),define("lib/backbone",["./underscore"],function(){var a;typeof exports!=="undefined"?a=exports:a=window.Backbone={},a.VERSION="0.3.3";var b=this._;!b&&typeof require!=="undefined"&&(b=require("underscore")._);var c=this.jQuery||this.Zepto;a.emulateHTTP=!1,a.emulateJSON=!1,a.Events={bind:function(a,b){var c=this._callbacks||(this._callbacks={}),d=this._callbacks[a]||(this._callbacks[a]=[]);d.push(b);return this},unbind:function(a,b){var c;if(a){if(c=this._callbacks)if(b){var d=c[a];if(!d)return this;for(var e=0,f=d.length;e<f;e++)if(b===d[e]){d.splice(e,1);break}}else c[a]=[]}else this._callbacks={};return this},trigger:function(a){var b,c,d,e;if(!(c=this._callbacks))return this;if(c[a]){b=c[a].slice(0);for(d=0,e=b.length;d<e;d++)b[d].apply(this,Array.prototype.slice.call(arguments,1))}if(c.all){b=c.all.slice(0);for(d=0,e=b.length;d<e;d++)b[d].apply(this,arguments)}return this}},a.Model=function(a,c){var d;a||(a={});if(d=this.defaults)b.isFunction(d)&&(d=d()),a=b.extend({},d,a);this.attributes={},this._escapedAttributes={},this.cid=b.uniqueId("c"),this.set(a,{silent:!0}),this._changed=!1,this._previousAttributes=b.clone(this.attributes),c&&c.collection&&(this.collection=c.collection),this.initialize(a,c)},b.extend(a.Model.prototype,a.Events,{_previousAttributes:null,_changed:!1,idAttribute:"id",initialize:function(){},toJSON:function(){return b.clone(this.attributes)},get:function(a){return this.attributes[a]},escape:function(a){var b;if(b=this._escapedAttributes[a])return b;var c=this.attributes[a];return this._escapedAttributes[a]=t(c==null?"":""+c)},has:function(a){return this.attributes[a]!=null},set:function(a,c){c||(c={});if(!a)return this;a.attributes&&(a=a.attributes);var d=this.attributes,e=this._escapedAttributes;if(!c.silent&&this.validate&&!this._performValidation(a,c))return!1;this.idAttribute in a&&(this.id=a[this.idAttribute]);for(var f in a){var g=a[f];b.isEqual(d[f],g)||(d[f]=g,delete e[f],this._changed=!0,c.silent||this.trigger("change:"+f,this,g,c))}!c.silent&&this._changed&&this.change(c);return this},unset:function(a,b){if(!(a in this.attributes))return this;b||(b={});var c=this.attributes[a],d={};d[a]=void 0;if(!b.silent&&this.validate&&!this._performValidation(d,b))return!1;delete this.attributes[a],delete this._escapedAttributes[a],a==this.idAttribute&&delete this.id,this._changed=!0,b.silent||(this.trigger("change:"+a,this,void 0,b),this.change(b));return this},clear:function(a){a||(a={});var b=this.attributes,c={};for(attr in b)c[attr]=void 0;if(!a.silent&&this.validate&&!this._performValidation(c,a))return!1;this.attributes={},this._escapedAttributes={},this._changed=!0;if(!a.silent){for(attr in b)this.trigger("change:"+attr,this,void 0,a);this.change(a)}return this},fetch:function(b){b||(b={});var c=this,d=b.success;b.success=function(a){if(!c.set(c.parse(a),b))return!1;d&&d(c,a)},b.error=s(b.error,c,b),(this.sync||a.sync).call(this,"read",this,b);return this},save:function(b,c){c||(c={});if(b&&!this.set(b,c))return!1;var d=this,e=c.success;c.success=function(a){if(!d.set(d.parse(a),c))return!1;e&&e(d,a)},c.error=s(c.error,d,c);var f=this.isNew()?"create":"update";(this.sync||a.sync).call(this,f,this,c);return this},destroy:function(b){b||(b={});var c=this,d=b.success;b.success=function(a){c.trigger("destroy",c,c.collection,b),d&&d(c,a)},b.error=s(b.error,c,b),(this.sync||a.sync).call(this,"delete",this,b);return this},url:function(){var a=q(this.collection)||this.urlRoot||r();if(this.isNew())return a;return a+(a.charAt(a.length-1)=="/"?"":"/")+encodeURIComponent(this.id)},parse:function(a){return a},clone:function(){return new this.constructor(this)},isNew:function(){return!this.id},change:function(a){this.trigger("change",this,a),this._previousAttributes=b.clone(this.attributes),this._changed=!1},hasChanged:function(a){if(a)return this._previousAttributes[a]!=this.attributes[a];return this._changed},changedAttributes:function(a){a||(a=this.attributes);var c=this._previousAttributes,d=!1;for(var e in a)b.isEqual(c[e],a[e])||(d=d||{},d[e]=a[e]);return d},previous:function(a){if(!a||!this._previousAttributes)return null;return this._previousAttributes[a]},previousAttributes:function(){return b.clone(this._previousAttributes)},_performValidation:function(a,b){var c=this.validate(a);if(c){b.error?b.error(this,c):this.trigger("error",this,c,b);return!1}return!0}}),a.Collection=function(a,c){c||(c={}),c.comparator&&(this.comparator=c.comparator,delete c.comparator),b.bindAll(this,"_onModelEvent","_removeReference"),this._reset(),a&&this.refresh(a,{silent:!0}),this.initialize(a,c)},b.extend(a.Collection.prototype,a.Events,{model:a.Model,initialize:function(){},toJSON:function(){return this.map(function(a){return a.toJSON()})},add:function(a,c){if(b.isArray(a))for(var d=0,e=a.length;d<e;d++)this._add(a[d],c);else this._add(a,c);return this},remove:function(a,c){if(b.isArray(a))for(var d=0,e=a.length;d<e;d++)this._remove(a[d],c);else this._remove(a,c);return this},get:function(a){if(a==null)return null;return this._byId[a.id!=null?a.id:a]},getByCid:function(a){return a&&this._byCid[a.cid||a]},at:function(a){return this.models[a]},sort:function(a){a||(a={});if(!this.comparator)throw new Error("Cannot sort a set without a comparator");this.models=this.sortBy(this.comparator),a.silent||this.trigger("refresh",this,a);return this},pluck:function(a){return b.map(this.models,function(b){return b.get(a)})},refresh:function(a,b){a||(a=[]),b||(b={}),this.each(this._removeReference),this._reset(),this.add(a,{silent:!0}),b.silent||this.trigger("refresh",this,b);return this},fetch:function(b){b||(b={});var c=this,d=b.success;b.success=function(a){c[b.add?"add":"refresh"](c.parse(a),b),d&&d(c,a)},b.error=s(b.error,c,b),(this.sync||a.sync).call(this,"read",this,b);return this},create:function(b,c){var d=this;c||(c={});if(b instanceof a.Model)b.collection=d;else{var e=b;b=new this.model(null,{collection:d});if(!b.set(e))return!1}var f=c.success;c.success=function(a,b){d.add(a),f&&f(a,b)};return b.save(null,c)},parse:function(a){return a},chain:function(){return b(this.models).chain()},_reset:function(a){this.length=0,this.models=[],this._byId={},this._byCid={}},_add:function(b,c){c||(c={}),b instanceof a.Model||(b=new this.model(b,{collection:this}));var d=this.getByCid(b);if(d)throw new Error(["Can't add the same model to a set twice",d.id]);this._byId[b.id]=b,this._byCid[b.cid]=b,b.collection||(b.collection=this);var e=this.comparator?this.sortedIndex(b,this.comparator):this.length;this.models.splice(e,0,b),b.bind("all",this._onModelEvent),this.length++,c.silent||b.trigger("add",b,this,c);return b},_remove:function(a,b){b||(b={}),a=this.getByCid(a)||this.get(a);if(!a)return null;delete this._byId[a.id],delete this._byCid[a.cid],this.models.splice(this.indexOf(a),1),this.length--,b.silent||a.trigger("remove",a,this,b),this._removeReference(a);return a},_removeReference:function(a){this==a.collection&&delete a.collection,a.unbind("all",this._onModelEvent)},_onModelEvent:function(a,b,c,d){if(a!="add"&&a!="remove"||c==this)a=="destroy"&&this._remove(b,d),a==="change:"+b.idAttribute&&(delete this._byId[b.previous(b.idAttribute)],this._byId[b.id]=b),this.trigger.apply(this,arguments)}});var d=["forEach","each","map","reduce","reduceRight","find","detect","filter","select","reject","every","all","some","any","include","invoke","max","min","sortBy","sortedIndex","toArray","size","first","rest","last","without","indexOf","lastIndexOf","isEmpty"];b.each(d,function(c){a.Collection.prototype[c]=function(){return b[c].apply(b,[this.models].concat(b.toArray(arguments)))}}),a.Controller=function(a){a||(a={}),a.routes&&(this.routes=a.routes),this._bindRoutes(),this.initialize(a)};var e=/:([\w\d]+)/g,f=/\*([\w\d]+)/g,g=/[-[\]{}()+?.,\\^$|#\s]/g;b.extend(a.Controller.prototype,a.Events,{initialize:function(){},route:function(c,d,e){a.history||(a.history=new a.History),b.isRegExp(c)||(c=this._routeToRegExp(c)),a.history.route(c,b.bind(function(a){var b=this._extractParameters(c,a);e.apply(this,b),this.trigger.apply(this,["route:"+d].concat(b))},this))},saveLocation:function(b){a.history.saveLocation(b)},_bindRoutes:function(){if(this.routes){var a=[];for(var b in this.routes)a.unshift([b,this.routes[b]]);for(var c=0,d=a.length;c<d;c++)this.route(a[c][0],a[c][1],this[a[c][1]])}},_routeToRegExp:function(a){a=a.replace(g,"\\$&").replace(e,"([^/]*)").replace(f,"(.*?)");return new RegExp("^"+a+"$")},_extractParameters:function(a,b){return a.exec(b).slice(1)}}),a.History=function(){this.handlers=[],this.fragment=this.getFragment(),b.bindAll(this,"checkUrl")};var h=/^#*/,i=!1;b.extend(a.History.prototype,{interval:50,getFragment:function(a){return(a||window.location).hash.replace(h,"")},start:function(){if(i)throw new Error("Backbone.history has already been started");var a=document.documentMode,b=c.browser.msie&&(!a||a<=7);b&&(this.iframe=c('<iframe src="javascript:0" tabindex="-1" />').hide().appendTo("body")[0].contentWindow),"onhashchange"in window&&!b?c(window).bind("hashchange",this.checkUrl):setInterval(this.checkUrl,this.interval),i=!0;return this.loadUrl()},route:function(a,b){this.handlers.unshift({route:a,callback:b})},checkUrl:function(){var a=this.getFragment();a==this.fragment&&this.iframe&&(a=this.getFragment(this.iframe.location));if(a==this.fragment||a==decodeURIComponent(this.fragment))return!1;this.iframe&&(window.location.hash=this.iframe.location.hash=a),this.loadUrl()},loadUrl:function(){var a=this.fragment=this.getFragment(),c=b.any(this.handlers,function(b){if(b.route.test(a)){b.callback(a);return!0}});return c},saveLocation:function(a){a=(a||"").replace(h,"");this.fragment!=a&&(window.location.hash=this.fragment=a,this.iframe&&a!=this.getFragment(this.iframe.location)&&(this.iframe.document.open().close(),this.iframe.location.hash=a))}}),a.View=function(a){this.cid=b.uniqueId("view"),this._configure(a||{}),this._ensureElement(),this.delegateEvents(),this.initialize(a)};var j=function(a){return c(a,this.el)},k=/^(\w+)\s*(.*)$/,l=["model","collection","el","id","attributes","className","tagName"];b.extend(a.View.prototype,a.Events,{tagName:"div",$:j,initialize:function(){},render:function(){return this},remove:function(){c(this.el).remove();return this},make:function(a,b,d){var e=document.createElement(a);b&&c(e).attr(b),d&&c(e).html(d);return e},delegateEvents:function(a){if(a||(a=this.events)){c(this.el).unbind(".delegateEvents"+this.cid);for(var d in a){var e=a[d],f=d.match(k),g=f[1],h=f[2],i=b.bind(this[e],this);g+=".delegateEvents"+this.cid,h===""?c(this.el).bind(g,i):c(this.el).delegate(h,g,i)}}},_configure:function(a){this.options&&(a=b.extend({},this.options,a));for(var c=0,d=l.length;c<d;c++){var e=l[c];a[e]&&(this[e]=a[e])}this.options=a},_ensureElement:function(){if(this.el)b.isString(this.el)&&(this.el=c(this.el).get(0));else{var a=this.attributes||{};this.id&&(a.id=this.id),this.className&&(a["class"]=this.className),this.el=this.make(this.tagName,a)}}});var m=function(a,b){var c=p(this,a,b);c.extend=m;return c};a.Model.extend=a.Collection.extend=a.Controller.extend=a.View.extend=m;var n={create:"POST",update:"PUT","delete":"DELETE",read:"GET"};a.sync=function(d,e,f){var g=n[d],h=b.extend({type:g,contentType:"application/json",dataType:"json",processData:!1},f);h.url||(h.url=q(e)||r()),!h.data&&e&&(d=="create"||d=="update")&&(h.data=JSON.stringify(e.toJSON())),a.emulateJSON&&(h.contentType="application/x-www-form-urlencoded",h.processData=!0,h.data=h.data?{model:h.data}:{});if(a.emulateHTTP)if(g==="PUT"||g==="DELETE")a.emulateJSON&&(h.data._method=g),h.type="POST",h.beforeSend=function(a){a.setRequestHeader("X-HTTP-Method-Override",g)};c.ajax(h)};var o=function(){},p=function(a,c,d){var e;c&&c.hasOwnProperty("constructor")?e=c.constructor:e=function(){return a.apply(this,arguments)},b.extend(e,a),o.prototype=a.prototype,e.prototype=new o,c&&b.extend(e.prototype,c),d&&b.extend(e,d),e.prototype.constructor=e,e.__super__=a.prototype;return e},q=function(a){if(!a||!a.url)return null;return b.isFunction(a.url)?a.url():a.url},r=function(){throw new Error("A 'url' property or function must be specified")},s=function(a,b,c){return function(d){a?a(b,d,c):b.trigger("error",b,d,c)}},t=function(a){return a.replace(/&(?!\w+;)/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;")}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/View",["lib/backbone"],function(b){var d;return d=function(){function b(){this.attach=a(this.attach,this),this.detach=a(this.detach,this),b.__super__.constructor.apply(this,arguments)}c(b,Backbone.View),b.prototype.detach=function(){return $(this.el).detach()},b.prototype.attach=function(a){return $(a).append(this.el)},b.prototype.height=function(a){return $(this.el).height(a)},b.prototype.width=function(a){return $(this.el).width(a)};return b}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/dashboard/DashboardInfoView",["neo4j/webadmin/templates/dashboard/info","neo4j/webadmin/views/View","lib/backbone"],function(b,d){var e;return e=function(){function e(){this.remove=a(this.remove,this),this.render=a(this.render,this),this.initialize=a(this.initialize,this),e.__super__.constructor.apply(this,arguments)}c(e,d),e.prototype.template=b,e.prototype.initialize=function(a){this.primitives=a.primitives,this.diskUsage=a.diskUsage,this.cacheUsage=a.cacheUsage,this.primitives.bind("change",this.render),this.diskUsage.bind("change",this.render);return this.cacheUsage.bind("change",this.render)},e.prototype.render=function(){$(this.el).html(this.template({primitives:this.primitives,diskUsage:this.diskUsage,cacheUsage:this.cacheUsage}));return this},e.prototype.remove=function(){this.primitives.unbind("change",this.render),this.diskUsage.unbind("change",this.render),this.cacheUsage.unbind("change",this.render);return e.__super__.remove.call(this)};return e}()})}.call(this),define("lib/DateFormat",["require","exports","module"],function(){var a=function(){var b=/d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,c=/\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,d=/[^-+\dA-Z]/g,e=function(a,b){a=String(a),b=b||2;while(a.length<b)a="0"+a;return a};return function(f,g,h){var i=a;arguments.length==1&&Object.prototype.toString.call(f)=="[object String]"&&!/\d/.test(f)&&(g=f,f=undefined),f=f?new Date(f):new Date;if(isNaN(f))throw SyntaxError("invalid date");g=String(i.masks[g]||g||i.masks["default"]),g.slice(0,4)=="UTC:"&&(g=g.slice(4),h=!0);var j=h?"getUTC":"get",k=f[j+"Date"](),l=f[j+"Day"](),m=f[j+"Month"](),n=f[j+"FullYear"](),o=f[j+"Hours"](),p=f[j+"Minutes"](),q=f[j+"Seconds"](),r=f[j+"Milliseconds"](),s=h?0:f.getTimezoneOffset(),t={d:k,dd:e(k),ddd:i.i18n.dayNames[l],dddd:i.i18n.dayNames[l+7],m:m+1,mm:e(m+1),mmm:i.i18n.monthNames[m],mmmm:i.i18n.monthNames[m+12],yy:String(n).slice(2),yyyy:n,h:o%12||12,hh:e(o%12||12),H:o,HH:e(o),M:p,MM:e(p),s:q,ss:e(q),l:e(r,3),L:e(r>99?Math.round(r/10):r),t:o<12?"a":"p",tt:o<12?"am":"pm",T:o<12?"A":"P",TT:o<12?"AM":"PM",Z:h?"UTC":(String(f).match(c)||[""]).pop().replace(d,""),o:(s>0?"-":"+")+e(Math.floor(Math.abs(s)/60)*100+Math.abs(s)%60,4),S:["th","st","nd","rd"][k%10>3?0:(k%100-k%10!=10)*k%10]};return g.replace(b,function(a){return a in t?t[a]:a.slice(1,a.length-1)})}}();a.masks={"default":"ddd mmm dd yyyy HH:MM:ss",shortDate:"m/d/yy",mediumDate:"mmm d, yyyy",longDate:"mmmm d, yyyy",fullDate:"dddd, mmmm d, yyyy",shortTime:"h:MM TT",mediumTime:"h:MM:ss TT",longTime:"h:MM:ss TT Z",isoDate:"yyyy-mm-dd",isoTime:"HH:MM:ss",isoDateTime:"yyyy-mm-dd'T'HH:MM:ss",isoUtcDateTime:"UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"},a.i18n={dayNames:["Sun","Mon","Tue","Wed","Thu","Fri","Sat","Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],monthNames:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec","January","February","March","April","May","June","July","August","September","October","November","December"]};return{format:a}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/ui/Tooltip",["lib/backbone","lib/jquery"],function(){var b;return b=function(){function b(b){b==null&&(b={}),this.getTooltipPositionFor=a(this.getTooltipPositionFor,this),this.getPosition=a(this.getPosition,this),this.onWindowResized=a(this.onWindowResized,this),this.remove=a(this.remove,this),this.hide=a(this.hide,this),this.show=a(this.show,this),this._tooltip=$("<div class='tooltip-wrap'></div>"),this._tooltipContent=$("<div class='tooltip'></div>"),this._closeButton=$("<div class='tooltip-close'></div>"),this._currentPos=[0,0],this._currentContent="",this._visible=!1,this.settings=_.extend(this.defaultSettings,b),this.settings.hideOnMouseOut&&this._tooltip.bind("mouseout",this.hide),this._tooltip.addClass("tooltip-pos-"+this.settings.position),this._tooltip.css(this.settings.css),this._tooltip.append(this._tooltipContent),this.settings.closeButton&&(this._tooltip.append(this._closeButton),this._closeButton.bind("click",this.hide)),this._tooltip.appendTo("body"),$(window).resize(this.onWindowResized)}b.prototype.defaultSettings={hideOnMouseOut:!0,css:{},position:"above",closeButton:!0},b.prototype.show=function(a,b,c){this._currentPos=b,this._currentContent=a,this._tooltipContent.html(a),b=this.getTooltipPositionFor(this.getPosition(b)),this._tooltip.css({left:b[0],top:b[1]}).show(),this._visible=!0;if(c)return setTimeout(this.hide,c)},b.prototype.hide=function(){this._tooltip.hide();return this._visible=!1},b.prototype.remove=function(){this._tooltip.unbind("mouseout",this.hide),this._closeButton.unbind("click",this.hide);return this._tooltip.remove()},b.prototype.onWindowResized=function(){var b;if(this._visible){b=a(function(){return this.show(this._currentContent,this._currentPos)},this);return setTimeout(b,0)}},b.prototype.getPosition=function(a){var b;if(_.isArray(a))return a;b=$(a),a=b.offset();switch(this.settings.position){case"right":return[a.left+b.width(),a.top+b.height()/2];case"left":return[a.left,a.top+b.height()/2];case"above":return[a.left+b.width()/2,a.top];default:return[a.left+b.width()/2,a.top-b.height()]}},b.prototype.getTooltipPositionFor=function(a){switch(this.settings.position){case"right":return[a[0]+10,a[1]-this._tooltip.height()/2];case"left":return[a[0]-(this._tooltip.width()+10),a[1]-this._tooltip.height()/2];case"above":return[a[0]-this._tooltip.width()/2,a[1]-(this._tooltip.height()+10)];default:return[a[0]-this._tooltip.width()/2,a[1]+this._tooltip.height()]}};return b}()})}.call(this),function(){jQuery.color={},jQuery.color.make=function(a,b,c,d){var e={};e.r=a||0,e.g=b||0,e.b=c||0,e.a=d!=null?d:1,e.add=function(a,b){for(var c=0;c<a.length;++c)e[a.charAt(c)]+=b;return e.normalize()},e.scale=function(a,b){for(var c=0;c<a.length;++c)e[a.charAt(c)]*=b;return e.normalize()},e.toString=function(){return e.a<1?"rgba("+[e.r,e.g,e.b,e.a].join(",")+")":"rgb("+[e.r,e.g,e.b].join(",")+")"},e.normalize=function(){function a(a,b,c){return b<a?a:b>c?c:b}e.r=a(0,parseInt(e.r),255),e.g=a(0,parseInt(e.g),255),e.b=a(0,parseInt(e.b),255),e.a=a(0,e.a,1);return e},e.clone=function(){return jQuery.color.make(e.r,e.b,e.g,e.a)};return e.normalize()},jQuery.color.extract=function(a,b){var c;do{c=a.css(b).toLowerCase();if(c!=""&&c!="transparent")break;a=a.parent()}while(!jQuery.nodeName(a.get(0),"body"));c=="rgba(0, 0, 0, 0)"&&(c="transparent");return jQuery.color.parse(c)},jQuery.color.parse=function(b){var c,d=jQuery.color.make;if(c=/rgb\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*\)/.exec(b))return d(parseInt(c[1],10),parseInt(c[2],10),parseInt(c[3],10));if(c=/rgba\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]+(?:\.[0-9]+)?)\s*\)/.exec(b))return d(parseInt(c[1],10),parseInt(c[2],10),parseInt(c[3],10),parseFloat(c[4]));if(c=/rgb\(\s*([0-9]+(?:\.[0-9]+)?)\%\s*,\s*([0-9]+(?:\.[0-9]+)?)\%\s*,\s*([0-9]+(?:\.[0-9]+)?)\%\s*\)/.exec(b))return d(parseFloat(c[1])*2.55,parseFloat(c[2])*2.55,parseFloat(c[3])*2.55);if(c=/rgba\(\s*([0-9]+(?:\.[0-9]+)?)\%\s*,\s*([0-9]+(?:\.[0-9]+)?)\%\s*,\s*([0-9]+(?:\.[0-9]+)?)\%\s*,\s*([0-9]+(?:\.[0-9]+)?)\s*\)/.exec(b))return d(parseFloat(c[1])*2.55,parseFloat(c[2])*2.55,parseFloat(c[3])*2.55,parseFloat(c[4]));if(c=/#([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-F0-9]{2})/.exec(b))return d(parseInt(c[1],16),parseInt(c[2],16),parseInt(c[3],16));if(c=/#([a-fA-F0-9])([a-fA-F0-9])([a-fA-F0-9])/.exec(b))return d(parseInt(c[1]+c[1],16),parseInt(c[2]+c[2],16),parseInt(c[3]+c[3],16));var e=jQuery.trim(b).toLowerCase();if(e=="transparent")return d(255,255,255,0);c=a[e];return d(c[0],c[1],c[2])};var a={aqua:[0,255,255],azure:[240,255,255],beige:[245,245,220],black:[0,0,0],blue:[0,0,255],brown:[165,42,42],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgrey:[169,169,169],darkgreen:[0,100,0],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkviolet:[148,0,211],fuchsia:[255,0,255],gold:[255,215,0],green:[0,128,0],indigo:[75,0,130],khaki:[240,230,140],lightblue:[173,216,230],lightcyan:[224,255,255],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightyellow:[255,255,224],lime:[0,255,0],magenta:[255,0,255],maroon:[128,0,0],navy:[0,0,128],olive:[128,128,0],orange:[255,165,0],pink:[255,192,203],purple:[128,0,128],violet:[128,0,128],red:[255,0,0],silver:[192,192,192],white:[255,255,255],yellow:[255,255,0]}}(),function(a){function c(a,b){return b*Math.floor(a/b)}function b(b,d,e,f){function bh(b,c,d,e){if(typeof b=="string")return b;var f=m.createLinearGradient(0,d,0,c);for(var g=0,h=b.colors.length;g<h;++g){var i=b.colors[g];typeof i!="string"&&(i=a.color.parse(e).scale("rgb",i.brightness),i.a*=i.opacity,i=i.toString()),f.addColorStop(g/(h-1),i)}return f}function bg(b,c){n.lineWidth=b.bars.lineWidth,n.strokeStyle=a.color.parse(b.color).scale("a",.5).toString();var d=a.color.parse(b.color).scale("a",.5).toString(),e=b.bars.align=="left"?0:-b.bars.barWidth/2;R(c[0],c[1],c[2]||0,e,e+b.bars.barWidth,0,function(){return d},b.xaxis,b.yaxis,n,b.bars.horizontal)}function bf(b,c){var d=c[0],e=c[1],f=b.xaxis,g=b.yaxis;if(!(d<f.min||d>f.max||e<g.min||e>g.max)){var h=b.points.radius+b.points.lineWidth/2;n.lineWidth=h,n.strokeStyle=a.color.parse(b.color).scale("a",.5).toString();var i=1.5*h;n.beginPath(),n.arc(f.p2c(d),g.p2c(e),i,0,2*Math.PI,!1),n.stroke()}}function be(a,b){for(var c=0;c<V.length;++c){var d=V[c];if(d.series==a&&d.point[0]==b[0]&&d.point[1]==b[1])return c}return-1}function bd(a,b){a==null&&b==null&&(V=[],ba()),typeof a=="number"&&(a=g[a]),typeof b=="number"&&(b=a.data[b]);var c=be(a,b);c!=-1&&(V.splice(c,1),ba())}function bc(a,b,c){typeof a=="number"&&(a=g[a]),typeof b=="number"&&(b=a.data[b]);var d=be(a,b);d==-1?(V.push({series:a,point:b,auto:c}),ba()):c||(V[d].auto=!1)}function bb(){W=null,n.save(),n.clearRect(0,0,q,r),n.translate(p.left,p.top);var a,b;for(a=0;a<V.length;++a)b=V[a],b.series.bars.show?bg(b.series,b.point):bf(b.series,b.point);n.restore(),w(u.drawOverlay,[n])}function ba(){W||(W=setTimeout(bb,30))}function _(a,c,d){var e=l.offset(),f={pageX:c.pageX,pageY:c.pageY},g=c.pageX-e.left-p.left,i=c.pageY-e.top-p.top;o.xaxis.used&&(f.x=o.xaxis.c2p(g)),o.yaxis.used&&(f.y=o.yaxis.c2p(i)),o.x2axis.used&&(f.x2=o.x2axis.c2p(g)),o.y2axis.used&&(f.y2=o.y2axis.c2p(i));var j=X(g,i,d);j&&(j.pageX=parseInt(j.series.xaxis.p2c(j.datapoint[0])+e.left+p.left),j.pageY=parseInt(j.series.yaxis.p2c(j.datapoint[1])+e.top+p.top));if(h.grid.autoHighlight){for(var k=0;k<V.length;++k){var m=V[k];m.auto==a&&(!j||m.series!=j.series||m.point!=j.datapoint)&&bd(m.series,m.point)}j&&bc(j.series,j.datapoint,a)}b.trigger(a,[f,j])}function Z(a){_("plotclick",a,function(a){return a.clickable!=!1})}function Y(a){h.grid.hoverable&&_("plothover",a,function(a){return a.hoverable!=!1})}function X(a,b,c){var d=h.grid.mouseActiveRadius,e=d*d+1,f=null,i=!1,j,k;for(j=0;j<g.length;++j){if(!c(g[j]))continue;var l=g[j],m=l.xaxis,n=l.yaxis,o=l.datapoints.points,p=l.datapoints.pointsize,q=m.c2p(a),r=n.c2p(b),s=d/m.scale,t=d/n.scale;if(l.lines.show||l.points.show)for(k=0;k<o.length;k+=p){var u=o[k],v=o[k+1];if(u==null)continue;if(u-q>s||u-q<-s||v-r>t||v-r<-t)continue;var w=Math.abs(m.p2c(u)-a),x=Math.abs(n.p2c(v)-b),y=w*w+x*x;y<=e&&(e=y,f=[j,k/p])}if(l.bars.show&&!f){var z=l.bars.align=="left"?0:-l.bars.barWidth/2,A=z+l.bars.barWidth;for(k=0;k<o.length;k+=p){var u=o[k],v=o[k+1],B=o[k+2];if(u==null)continue;if(g[j].bars.horizontal?q<=Math.max(B,u)&&q>=Math.min(B,u)&&r>=v+z&&r<=v+A:q>=u+z&&q<=u+A&&r>=Math.min(B,v)&&r<=Math.max(B,v))f=[j,k/p]}}}if(f){j=f[0],k=f[1],p=g[j].datapoints.pointsize;return{datapoint:g[j].datapoints.points.slice(k*p,(k+1)*p),dataIndex:k,series:g[j],seriesIndex:j}}return null}function U(){b.find(".legend").remove();if(h.legend.show){var c=[],d=!1,e=h.legend.labelFormatter,f,j;for(i=0;i<g.length;++i){f=g[i],j=f.label;if(!j)continue;i%h.legend.noColumns==0&&(d&&c.push("</tr>"),c.push("<tr>"),d=!0),e&&(j=e(j,f)),c.push('<td class="legendColorBox"><div style="border:1px solid '+h.legend.labelBoxBorderColor+';padding:1px"><div style="width:4px;height:0;border:5px solid '+f.color+';overflow:hidden"></div></div></td><td class="legendLabel">'+j+"</td>")}d&&c.push("</tr>");if(c.length==0)return;var k='<table style="font-size:smaller;color:'+h.grid.color+'">'+c.join("")+"</table>";if(h.legend.container!=null)a(h.legend.container).html(k);else{var l="",m=h.legend.position,n=h.legend.margin;n[0]==null&&(n=[n,n]),m.charAt(0)=="n"?l+="top:"+(n[1]+p.top)+"px;":m.charAt(0)=="s"&&(l+="bottom:"+(n[1]+p.bottom)+"px;"),m.charAt(1)=="e"?l+="right:"+(n[0]+p.right)+"px;":m.charAt(1)=="w"&&(l+="left:"+(n[0]+p.left)+"px;");var o=a('<div class="legend">'+k.replace('style="','style="position:absolute;'+l+";")+"</div>").appendTo(b);if(h.legend.backgroundOpacity!=0){var q=h.legend.backgroundColor;q==null&&(q=h.grid.backgroundColor,q&&typeof q=="string"?q=a.color.parse(q):q=a.color.extract(o,"background-color"),q.a=1,q=q.toString());var r=o.children();a('<div style="position:absolute;width:'+r.width()+"px;height:"+r.height()+"px;"+l+"background-color:"+q+';"> </div>').prependTo(o).css("opacity",h.legend.backgroundOpacity)}}}}function T(b,c,d,e){var f=b.fill;if(!f)return null;if(b.fillColor)return bh(b.fillColor,d,e,c);var g=a.color.parse(c);g.a=typeof f=="number"?f:.4,g.normalize();return g.toString()}function S(a){function b(b,c,d,e,f,g,h){var i=b.points,j=b.pointsize;for(var k=0;k<i.length;k+=j){if(i[k]==null)continue;R(i[k],i[k+1],i[k+2],c,d,e,f,g,h,m,a.bars.horizontal)}}m.save(),m.translate(p.left,p.top),m.lineWidth=a.bars.lineWidth,m.strokeStyle=a.color;var c=a.bars.align=="left"?0:-a.bars.barWidth/2,d=a.bars.fill?function(b,c){return T(a.bars,a.color,b,c)}:null;b(a.datapoints,c,c+a.bars.barWidth,0,d,a.xaxis,a.yaxis),m.restore()}function R(a,b,c,d,e,f,g,h,i,j,k){var l,m,n,o,p,q,r,s,t;k?(s=q=r=!0,p=!1,l=c,m=a,o=b+d,n=b+e,m<l&&(t=m,m=l,l=t,p=!0,q=!1)):(p=q=r=!0,s=!1,l=a+d,m=a+e,n=c,o=b,o<n&&(t=o,o=n,n=t,s=!0,r=!1));if(!(m<h.min||l>h.max||o<i.min||n>i.max)){l<h.min&&(l=h.min,p=!1),m>h.max&&(m=h.max,q=!1),n<i.min&&(n=i.min,s=!1),o>i.max&&(o=i.max,r=!1),l=h.p2c(l),n=i.p2c(n),m=h.p2c(m),o=i.p2c(o),g&&(j.beginPath(),j.moveTo(l,n),j.lineTo(l,o),j.lineTo(m,o),j.lineTo(m,n),j.fillStyle=g(n,o),j.fill());if(p||q||r||s)j.beginPath(),j.moveTo(l,n+f),p?j.lineTo(l,o+f):j.moveTo(l,o+f),r?j.lineTo(m,o+f):j.moveTo(m,o+f),q?j.lineTo(m,n+f):j.moveTo(m,n+f),s?j.lineTo(l,n+f):j.moveTo(l,n+f),j.stroke()}}function Q(a){function b(a,b,c,d,e,f,g){var h=a.points,i=a.pointsize;for(var j=0;j<h.length;j+=i){var k=h[j],l=h[j+1];if(k==null||k<f.min||k>f.max||l<g.min||l>g.max)continue;m.beginPath(),m.arc(f.p2c(k),g.p2c(l)+d,b,0,e,!1),c&&(m.fillStyle=c,m.fill()),m.stroke()}}m.save(),m.translate(p.left,p.top);var c=a.lines.lineWidth,d=a.shadowSize,e=a.points.radius;if(c>0&&d>0){var f=d/2;m.lineWidth=f,m.strokeStyle="rgba(0,0,0,0.1)",b(a.datapoints,e,null,f+f/2,Math.PI,a.xaxis,a.yaxis),m.strokeStyle="rgba(0,0,0,0.2)",b(a.datapoints,e,null,f/2,Math.PI,a.xaxis,a.yaxis)}m.lineWidth=c,m.strokeStyle=a.color,b(a.datapoints,e,T(a.points,a.color),0,2*Math.PI,a.xaxis,a.yaxis),m.restore()}function P(a){function c(a,b,c){var d=a.points,e=a.pointsize,f=Math.min(Math.max(0,c.min),c.max),g,h=0,i=!1;for(var j=e;j<d.length;j+=e){var k=d[j-e],l=d[j-e+1],n=d[j],o=d[j+1];if(i&&k!=null&&n==null){m.lineTo(b.p2c(h),c.p2c(f)),m.fill(),i=!1;continue}if(k==null||n==null)continue;if(k<=n&&k<b.min){if(n<b.min)continue;l=(b.min-k)/(n-k)*(o-l)+l,k=b.min}else if(n<=k&&n<b.min){if(k<b.min)continue;o=(b.min-k)/(n-k)*(o-l)+l,n=b.min}if(k>=n&&k>b.max){if(n>b.max)continue;l=(b.max-k)/(n-k)*(o-l)+l,k=b.max}else if(n>=k&&n>b.max){if(k>b.max)continue;o=(b.max-k)/(n-k)*(o-l)+l,n=b.max}i||(m.beginPath(),m.moveTo(b.p2c(k),c.p2c(f)),i=!0);if(l>=c.max&&o>=c.max){m.lineTo(b.p2c(k),c.p2c(c.max)),m.lineTo(b.p2c(n),c.p2c(c.max)),h=n;continue}if(l<=c.min&&o<=c.min){m.lineTo(b.p2c(k),c.p2c(c.min)),m.lineTo(b.p2c(n),c.p2c(c.min)),h=n;continue}var p=k,q=n;l>o||l>=c.min||o<c.min?o<=l&&o<c.min&&l>=c.min&&(n=(c.min-l)/(o-l)*(n-k)+k,o=c.min):(k=(c.min-l)/(o-l)*(n-k)+k,l=c.min),l<o||l<=c.max||o>c.max?o>=l&&o>c.max&&l<=c.max&&(n=(c.max-l)/(o-l)*(n-k)+k,o=c.max):(k=(c.max-l)/(o-l)*(n-k)+k,l=c.max),k!=p&&(l>c.min?g=c.max:g=c.min,m.lineTo(b.p2c(p),c.p2c(g)),m.lineTo(b.p2c(k),c.p2c(g))),m.lineTo(b.p2c(k),c.p2c(l)),m.lineTo(b.p2c(n),c.p2c(o)),n!=q&&(o>c.min?g=c.max:g=c.min,m.lineTo(b.p2c(n),c.p2c(g)),m.lineTo(b.p2c(q),c.p2c(g))),h=Math.max(n,q)}i&&(m.lineTo(b.p2c(h),c.p2c(f)),m.fill())}function b(a,b,c,d,e){var f=a.points,g=a.pointsize,h=null,i=null;m.beginPath();for(var j=g;j<f.length;j+=g){var k=f[j-g],l=f[j-g+1],n=f[j],o=f[j+1];if(k==null||n==null)continue;if(l<=o&&l<e.min){if(o<e.min)continue;k=(e.min-l)/(o-l)*(n-k)+k,l=e.min}else if(o<=l&&o<e.min){if(l<e.min)continue;n=(e.min-l)/(o-l)*(n-k)+k,o=e.min}if(l>=o&&l>e.max){if(o>e.max)continue;k=(e.max-l)/(o-l)*(n-k)+k,l=e.max}else if(o>=l&&o>e.max){if(l>e.max)continue;n=(e.max-l)/(o-l)*(n-k)+k,o=e.max}if(k<=n&&k<d.min){if(n<d.min)continue;l=(d.min-k)/(n-k)*(o-l)+l,k=d.min}else if(n<=k&&n<d.min){if(k<d.min)continue;o=(d.min-k)/(n-k)*(o-l)+l,n=d.min}if(k>=n&&k>d.max){if(n>d.max)continue;l=(d.max-k)/(n-k)*(o-l)+l,k=d.max}else if(n>=k&&n>d.max){if(k>d.max)continue;o=(d.max-k)/(n-k)*(o-l)+l,n=d.max}(k!=h||l!=i)&&m.moveTo(d.p2c(k)+b,e.p2c(l)+c),h=n,i=o,m.lineTo(d.p2c(n)+b,e.p2c(o)+c)}m.stroke()}m.save(),m.translate(p.left,p.top),m.lineJoin="round";var d=a.lines.lineWidth,e=a.shadowSize;if(d>0&&e>0){m.lineWidth=e,m.strokeStyle="rgba(0,0,0,0.1)";var f=Math.PI/18;b(a.datapoints,Math.sin(f)*(d/2+e/2),Math.cos(f)*(d/2+e/2),a.xaxis,a.yaxis),m.lineWidth=e/2,b(a.datapoints,Math.sin(f)*(d/2+e/4),Math.cos(f)*(d/2+e/4),a.xaxis,a.yaxis)}m.lineWidth=d,m.strokeStyle=a.color;var g=T(a.lines,a.color,0,t);g&&(m.fillStyle=g,c(a.datapoints,a.xaxis,a.yaxis)),d>0&&b(a.datapoints,0,0,a.xaxis,a.yaxis),m.restore()}function O(a){a.lines.show&&P(a),a.bars.show&&S(a),a.points.show&&Q(a)}function N(){function c(b,c){for(var d=0;d<b.ticks.length;++d){var e=b.ticks[d];if(!e.label||e.v<b.min||e.v>b.max)continue;a.push(c(e,b))}}b.find(".tickLabels").remove();var a=['<div class="tickLabels" style="font-size:smaller;color:'+h.grid.color+'">'],d=h.grid.labelMargin+h.grid.borderWidth;c(o.xaxis,function(a,b){return'<div style="position:absolute;top:'+(p.top+t+d)+"px;left:"+Math.round(p.left+b.p2c(a.v)-b.labelWidth/2)+"px;width:"+b.labelWidth+'px;text-align:center" class="tickLabel">'+a.label+"</div>"}),c(o.yaxis,function(a,b){return'<div style="position:absolute;top:'+Math.round(p.top+b.p2c(a.v)-b.labelHeight/2)+"px;right:"+(p.right+s+d)+"px;width:"+b.labelWidth+'px;text-align:right" class="tickLabel">'+a.label+"</div>"}),c(o.x2axis,function(a,b){return'<div style="position:absolute;bottom:'+(p.bottom+t+d)+"px;left:"+Math.round(p.left+b.p2c(a.v)-b.labelWidth/2)+"px;width:"+b.labelWidth+'px;text-align:center" class="tickLabel">'+a.label+"</div>"}),c(o.y2axis,function(a,b){return'<div style="position:absolute;top:'+Math.round(p.top+b.p2c(a.v)-b.labelHeight/2)+"px;left:"+(p.left+s+d)+"px;width:"+b.labelWidth+'px;text-align:left" class="tickLabel">'+a.label+"</div>"}),a.push("</div>"),b.append(a.join(""))}function M(){var b;m.save(),m.translate(p.left,p.top),h.grid.backgroundColor&&(m.fillStyle=bh(h.grid.backgroundColor,t,0,"rgba(255, 255, 255, 0)"),m.fillRect(0,0,s,t));var c=h.grid.markings;if(c){a.isFunction(c)&&(c=c({xmin:o.xaxis.min,xmax:o.xaxis.max,ymin:o.yaxis.min,ymax:o.yaxis.max,xaxis:o.xaxis,yaxis:o.yaxis,x2axis:o.x2axis,y2axis:o.y2axis}));for(b=0;b<c.length;++b){var d=c[b],e=L(d,"x"),f=L(d,"y");e.from==null&&(e.from=e.axis.min),e.to==null&&(e.to=e.axis.max),f.from==null&&(f.from=f.axis.min),f.to==null&&(f.to=f.axis.max);if(e.to<e.axis.min||e.from>e.axis.max||f.to<f.axis.min||f.from>f.axis.max)continue;e.from=Math.max(e.from,e.axis.min),e.to=Math.min(e.to,e.axis.max),f.from=Math.max(f.from,f.axis.min),f.to=Math.min(f.to,f.axis.max);if(e.from==e.to&&f.from==f.to)continue;e.from=e.axis.p2c(e.from),e.to=e.axis.p2c(e.to),f.from=f.axis.p2c(f.from),f.to=f.axis.p2c(f.to),e.from==e.to||f.from==f.to?(m.beginPath(),m.strokeStyle=d.color||h.grid.markingsColor,m.lineWidth=d.lineWidth||h.grid.markingsLineWidth,m.moveTo(e.from,f.from),m.lineTo(e.to,f.to),m.stroke()):(m.fillStyle=d.color||h.grid.markingsColor,m.fillRect(e.from,f.to,e.to-e.from,f.from-f.to))}}m.lineWidth=1,m.strokeStyle=h.grid.tickColor,m.beginPath();var g,i=o.xaxis;for(b=0;b<i.ticks.length;++b){g=i.ticks[b].v;if(g<=i.min||g>=o.xaxis.max)continue;m.moveTo(Math.floor(i.p2c(g))+m.lineWidth/2,0),m.lineTo(Math.floor(i.p2c(g))+m.lineWidth/2,t)}i=o.yaxis;for(b=0;b<i.ticks.length;++b){g=i.ticks[b].v;if(g<=i.min||g>=i.max)continue;m.moveTo(0,Math.floor(i.p2c(g))+m.lineWidth/2),m.lineTo(s,Math.floor(i.p2c(g))+m.lineWidth/2)}i=o.x2axis;for(b=0;b<i.ticks.length;++b){g=i.ticks[b].v;if(g<=i.min||g>=i.max)continue;m.moveTo(Math.floor(i.p2c(g))+m.lineWidth/2,-5),m.lineTo(Math.floor(i.p2c(g))+m.lineWidth/2,5)}i=o.y2axis;for(b=0;b<i.ticks.length;++b){g=i.ticks[b].v;if(g<=i.min||g>=i.max)continue;m.moveTo(s-5,Math.floor(i.p2c(g))+m.lineWidth/2),m.lineTo(s+5,Math.floor(i.p2c(g))+m.lineWidth/2)}m.stroke();if(h.grid.borderWidth){var j=h.grid.borderWidth;m.lineWidth=j,m.strokeStyle=h.grid.borderColor,m.strokeRect(-j/2,-j/2,s+j,t+j)}m.restore()}function L(a,b){var c=b+"axis",d=b+"2axis",e,f,g,h;a[c]?(e=o[c],f=a[c].from,g=a[c].to):a[d]?(e=o[d],f=a[d].from,g=a[d].to):(e=o[c],f=a[b+"1"],g=a[b+"2"]);if(f!=null&&g!=null&&f>g)return{from:g,to:f,axis:e};return{from:f,to:g,axis:e}}function K(){m.clearRect(0,0,q,r);var a=h.grid;a.show&&!a.aboveData&&M();for(var b=0;b<g.length;++b)O(g[b]);w(u.draw,[m]),a.show&&a.aboveData&&M()}function J(b,c){b.ticks=[];if(b.used){if(c.ticks==null)b.ticks=b.tickGenerator(b);else if(typeof c.ticks=="number")c.ticks>0&&(b.ticks=b.tickGenerator(b));else if(c.ticks){var d=c.ticks;a.isFunction(d)&&(d=d({min:b.min,max:b.max}));var e,f;for(e=0;e<d.length;++e){var g=null,h=d[e];typeof h=="object"?(f=h[0],h.length>1&&(g=h[1])):f=h,g==null&&(g=b.tickFormatter(f,b)),b.ticks[e]={v:f,label:g}}}c.autoscaleMargin!=null&&b.ticks.length>0&&(c.min==null&&(b.min=Math.min(b.min,b.ticks[0].v)),c.max==null&&b.ticks.length>1&&(b.max=Math.max(b.max,b.ticks[b.ticks.length-1].v)))}}function I(b,d){var e;typeof d.ticks=="number"&&d.ticks>0?e=d.ticks:b==o.xaxis||b==o.x2axis?e=.3*Math.sqrt(q):e=.3*Math.sqrt(r);var f=(b.max-b.min)/e,g,h,i,j,k,l,m;if(d.mode=="time"){var n={second:1e3,minute:6e4,hour:36e5,day:864e5,month:2592e6,year:525949.2*60*1e3},p=[[1,"second"],[2,"second"],[5,"second"],[10,"second"],[30,"second"],[1,"minute"],[2,"minute"],[5,"minute"],[10,"minute"],[30,"minute"],[1,"hour"],[2,"hour"],[4,"hour"],[8,"hour"],[12,"hour"],[1,"day"],[2,"day"],[3,"day"],[.25,"month"],[.5,"month"],[1,"month"],[2,"month"],[3,"month"],[6,"month"],[1,"year"]],s=0;d.minTickSize!=null&&(typeof d.tickSize=="number"?s=d.tickSize:s=d.minTickSize[0]*n[d.minTickSize[1]]);for(k=0;k<p.length-1;++k)if(f<(p[k][0]*n[p[k][1]]+p[k+1][0]*n[p[k+1][1]])/2&&p[k][0]*n[p[k][1]]>=s)break;g=p[k][0],i=p[k][1],i=="year"&&(l=Math.pow(10,Math.floor(Math.log(f/n.year)/Math.LN10)),m=f/n.year/l,m<1.5?g=1:m<3?g=2:m<7.5?g=5:g=10,g*=l),d.tickSize&&(g=d.tickSize[0],i=d.tickSize[1]),h=function(a){var b=[],d=a.tickSize[0],e=a.tickSize[1],f=new Date(a.min),g=d*n[e];e=="second"&&f.setUTCSeconds(c(f.getUTCSeconds(),d)),e=="minute"&&f.setUTCMinutes(c(f.getUTCMinutes(),d)),e=="hour"&&f.setUTCHours(c(f.getUTCHours(),d)),e=="month"&&f.setUTCMonth(c(f.getUTCMonth(),d)),e=="year"&&f.setUTCFullYear(c(f.getUTCFullYear(),d)),f.setUTCMilliseconds(0),g>=n.minute&&f.setUTCSeconds(0),g>=n.hour&&f.setUTCMinutes(0),g>=n.day&&f.setUTCHours(0),g>=n.day*4&&f.setUTCDate(1),g>=n.year&&f.setUTCMonth(0);var h=0,i=Number.NaN,j;do{j=i,i=f.getTime(),b.push({v:i,label:a.tickFormatter(i,a)});if(e=="month")if(d<1){f.setUTCDate(1);var k=f.getTime();f.setUTCMonth(f.getUTCMonth()+1);var l=f.getTime();f.setTime(i+h*n.hour+(l-k)*d),h=f.getUTCHours(),f.setUTCHours(0)}else f.setUTCMonth(f.getUTCMonth()+d);else e=="year"?f.setUTCFullYear(f.getUTCFullYear()+d):f.setTime(i+g)}while(i<a.max&&i!=j);return b},j=function(b,c){var e=new Date(b);if(d.timeformat!=null)return a.plot.formatDate(e,d.timeformat,d.monthNames);var f=c.tickSize[0]*n[c.tickSize[1]],g=c.max-c.min,h=d.twelveHourClock?" %p":"";f<n.minute?fmt="%h:%M:%S"+h:f<n.day?g<2*n.day?fmt="%h:%M"+h:fmt="%b %d %h:%M"+h:f<n.month?fmt="%b %d":f<n.year?g<n.year?fmt="%b":fmt="%b %y":fmt="%y";return a.plot.formatDate(e,fmt,d.monthNames)}}else{var t=d.tickDecimals,u=-Math.floor(Math.log(f)/Math.LN10);t!=null&&u>t&&(u=t),l=Math.pow(10,-u),m=f/l,m<1.5?g=1:m<3?(g=2,m>2.25&&(t==null||u+1<=t)&&(g=2.5,++u)):m<7.5?g=5:g=10,g*=l,d.minTickSize!=null&&g<d.minTickSize&&(g=d.minTickSize),d.tickSize!=null&&(g=d.tickSize),b.tickDecimals=Math.max(0,t!=null?t:u),h=function(a){var b=[],d=c(a.min,a.tickSize),e=0,f=Number.NaN,g;do g=f,f=d+e*a.tickSize,b.push({v:f,label:a.tickFormatter(f,a)}),++e;while(f<a.max&&f!=g);return b},j=function(a,b){return a.toFixed(b.tickDecimals)}}b.tickSize=i?[g,i]:g,b.tickGenerator=h,a.isFunction(d.tickFormatter)?b.tickFormatter=function(a,b){return""+d.tickFormatter(a,b)}:b.tickFormatter=j}function H(a,b){var c=+(b.min!=null?b.min:a.datamin),d=+(b.max!=null?b.max:a.datamax),e=d-c;if(e==0){var f=d==0?1:.01;b.min==null&&(c-=f);if(b.max==null||b.min!=null)d+=f}else{var g=b.autoscaleMargin;g!=null&&(b.min==null&&(c-=e*g,c<0&&a.datamin!=null&&a.datamin>=0&&(c=0)),b.max==null&&(d+=e*g,d>0&&a.datamax!=null&&a.datamax<=0&&(d=0)))}a.min=c,a.max=d}function G(){function e(){var a=h.grid.borderWidth;for(i=0;i<g.length;++i)a=Math.max(a,2*(g[i].points.radius+g[i].points.lineWidth/2));p.left=p.right=p.top=p.bottom=a;var b=h.grid.labelMargin+h.grid.borderWidth;o.xaxis.labelHeight>0&&(p.bottom=Math.max(a,o.xaxis.labelHeight+b)),o.yaxis.labelWidth>0&&(p.left=Math.max(a,o.yaxis.labelWidth+b)),o.x2axis.labelHeight>0&&(p.top=Math.max(a,o.x2axis.labelHeight+b)),o.y2axis.labelWidth>0&&(p.right=Math.max(a,o.y2axis.labelWidth+b)),s=q-p.left-p.right,t=r-p.bottom-p.top}function d(c,d){var e,f=[],g;c.labelWidth=d.labelWidth,c.labelHeight=d.labelHeight;if(c==o.xaxis||c==o.x2axis){c.labelWidth==null&&(c.labelWidth=q/(c.ticks.length>0?c.ticks.length:1));if(c.labelHeight==null){f=[];for(e=0;e<c.ticks.length;++e)g=c.ticks[e].label,g&&f.push('<div class="tickLabel" style="float:left;width:'+c.labelWidth+'px">'+g+"</div>");if(f.length>0){var h=a('<div style="position:absolute;top:-10000px;width:10000px;font-size:smaller">'+f.join("")+'<div style="clear:left"></div></div>').appendTo(b);c.labelHeight=h.height(),h.remove()}}}else if(c.labelWidth==null||c.labelHeight==null){for(e=0;e<c.ticks.length;++e)g=c.ticks[e].label,g&&f.push('<div class="tickLabel">'+g+"</div>");if(f.length>0){var h=a('<div style="position:absolute;top:-10000px;font-size:smaller">'+f.join("")+"</div>").appendTo(b);c.labelWidth==null&&(c.labelWidth=h.width()),c.labelHeight==null&&(c.labelHeight=h.find("div").height()),h.remove()}}c.labelWidth==null&&(c.labelWidth=0),c.labelHeight==null&&(c.labelHeight=0)}function c(a,b){function c(a){return a}var d,e,f=b.transform||c,g=b.inverseTransform;a==o.xaxis||a==o.x2axis?(d=a.scale=s/(f(a.max)-f(a.min)),e=f(a.min),f==c?a.p2c=function(a){return(a-e)*d}:a.p2c=function(a){return(f(a)-e)*d},g?a.c2p=function(a){return g(e+a/d)}:a.c2p=function(a){return e+a/d}):(d=a.scale=t/(f(a.max)-f(a.min)),e=f(a.max),f==c?a.p2c=function(a){return(e-a)*d}:a.p2c=function(a){return(e-f(a))*d},g?a.c2p=function(a){return g(e-a/d)}:a.c2p=function(a){return e-a/d})}var f;for(f in o)H(o[f],h[f]);if(h.grid.show){for(f in o)I(o[f],h[f]),J(o[f],h[f]),d(o[f],h[f]);e()}else p.left=p.right=p.top=p.bottom=0,s=q,t=r;for(f in o)c(o[f],h[f]);h.grid.show&&N(),U()}function F(){l=a([k,j]),h.grid.hoverable&&l.mousemove(Y),h.grid.clickable&&l.click(Z),w(u.bindEvents,[l])}function E(){function c(b,c){var d=document.createElement("canvas");d.width=b,d.height=c,a.browser.msie&&(d=window.G_vmlCanvasManager.initElement(d));return d}q=b.width(),r=b.height(),b.html(""),b.css("position")=="static"&&b.css("position","relative");if(q<=0||r<=0)throw"Invalid dimensions for plot, width = "+q+", height = "+r;a.browser.msie&&window.G_vmlCanvasManager.init_(document),j=a(c(q,r)).appendTo(b).get(0),m=j.getContext("2d"),k=a(c(q,r)).css({position:"absolute",left:0,top:0}).appendTo(b).get(0),n=k.getContext("2d"),n.stroke()}function D(){function s(a,b,c){b<a.datamin&&(a.datamin=b),c>a.datamax&&(a.datamax=c)}var a=Number.POSITIVE_INFINITY,b=Number.NEGATIVE_INFINITY,c,d,e,f,h,i,j,k,l,m,n,p,q,r;for(n in o)o[n].datamin=a,o[n].datamax=b,o[n].used=!1;for(c=0;c<g.length;++c)i=g[c],i.datapoints={points:[]},w(u.processRawData,[i,i.data,i.datapoints]);for(c=0;c<g.length;++c){i=g[c];var t=i.data,v=i.datapoints.format;v||(v=[],v.push({x:!0,number:!0,required:!0}),v.push({y:!0,number:!0,required:!0}),i.bars.show&&v.push({y:!0,number:!0,required:!1,defaultValue:0}),i.datapoints.format=v);if(i.datapoints.pointsize!=null)continue;i.datapoints.pointsize==null&&(i.datapoints.pointsize=v.length),k=i.datapoints.pointsize,j=i.datapoints.points,insertSteps=i.lines.show&&i.lines.steps,i.xaxis.used=i.yaxis.used=!0;for(d=e=0;d<t.length;++d,e+=k){r=t[d];var x=r==null;if(!x)for(f=0;f<k;++f)p=r[f],q=v[f],q&&(q.number&&p!=null&&(p=+p,isNaN(p)&&(p=null)),p==null&&(q.required&&(x=!0),q.defaultValue!=null&&(p=q.defaultValue))),j[e+f]=p;if(x)for(f=0;f<k;++f)p=j[e+f],p!=null&&(q=v[f],q.x&&s(i.xaxis,p,p),q.y&&s(i.yaxis,p,p)),j[e+f]=null;else if(insertSteps&&e>0&&j[e-k]!=null&&j[e-k]!=j[e]&&j[e-k+1]!=j[e+1]){for(f=0;f<k;++f)j[e+k+f]=j[e+f];j[e+1]=j[e-k+1],e+=k}}}for(c=0;c<g.length;++c)i=g[c],w(u.processDatapoints,[i,i.datapoints]);for(c=0;c<g.length;++c){i=g[c],j=i.datapoints.points,k=i.datapoints.pointsize;var y=a,z=a,A=b,B=b;for(d=0;d<j.length;d+=k){if(j[d]==null)continue;for(f=0;f<k;++f){p=j[d+f],q=v[f];if(!q)continue;q.x&&(p<y&&(y=p),p>A&&(A=p)),q.y&&(p<z&&(z=p),p>B&&(B=p))}}if(i.bars.show){var C=i.bars.align=="left"?0:-i.bars.barWidth/2;i.bars.horizontal?(z+=C,B+=C+i.bars.barWidth):(y+=C,A+=C+i.bars.barWidth)}s(i.xaxis,y,A),s(i.yaxis,z,B)}for(n in o)o[n].datamin==a&&(o[n].datamin=null),o[n].datamax==b&&(o[n].datamax=null)}function C(){var b,c=g.length,d=[],e=[];for(b=0;b<g.length;++b){var f=g[b].color;f!=null&&(--c,typeof f=="number"?e.push(f):d.push(a.color.parse(g[b].color)))}for(b=0;b<e.length;++b)c=Math.max(c,e[b]+1);var i=[],j=0;b=0;while(i.length<c){var k;h.colors.length==b?k=a.color.make(100,100,100):k=a.color.parse(h.colors[b]);var l=j%2==1?-1:1;k.scale("rgb",1+l*Math.ceil(j/2)*.2),i.push(k),++b,b>=h.colors.length&&(b=0,++j)}var m=0,n;for(b=0;b<g.length;++b){n=g[b],n.color==null?(n.color=i[m].toString(),++m):typeof n.color=="number"&&(n.color=i[n.color].toString());if(n.lines.show==null){var o,p=!0;for(o in n)if(n[o].show){p=!1;break}p&&(n.lines.show=!0)}n.xaxis=B(n,"xaxis"),n.yaxis=B(n,"yaxis")}}function B(a,b){var c=a[b];if(!c||c==1)return o[b];if(typeof c=="number")return o[b.charAt(0)+c+b.slice(1)];return c}function A(b){var c=[];for(var d=0;d<b.length;++d){var e=a.extend(!0,{},h.series);b[d].data?(e.data=b[d].data,delete b[d].data,a.extend(!0,e,b[d]),b[d].data=e.data):e.data=b[d],c.push(e)}return c}function z(a){g=A(a),C(),D()}function y(b){a.extend(!0,h,b),h.grid.borderColor==null&&(h.grid.borderColor=h.grid.color),h.xaxis.noTicks&&h.xaxis.ticks==null&&(h.xaxis.ticks=h.xaxis.noTicks),h.yaxis.noTicks&&h.yaxis.ticks==null&&(h.yaxis.ticks=h.yaxis.noTicks),h.grid.coloredAreas&&(h.grid.markings=h.grid.coloredAreas),h.grid.coloredAreasColor&&(h.grid.markingsColor=h.grid.coloredAreasColor),h.lines&&a.extend(!0,h.series.lines,h.lines),h.points&&a.extend(!0,h.series.points,h.points),h.bars&&a.extend(!0,h.series.bars,h.bars),h.shadowSize&&(h.series.shadowSize=h.shadowSize);for(var c in u)h.hooks[c]&&h.hooks[c].length&&(u[c]=u[c].concat(h.hooks[c]));w(u.processOptions,[h])}function x(){for(var b=0;b<f.length;++b){var c=f[b];c.init(v),c.options&&a.extend(!0,h,c.options)}}function w(a,b){b=[v].concat(b);for(var c=0;c<a.length;++c)a[c].apply(this,b)}var g=[],h={colors:["#edc240","#afd8f8","#cb4b4b","#4da74d","#9440ed"],legend:{show:!0,noColumns:1,labelFormatter:null,labelBoxBorderColor:"#ccc",container:null,position:"ne",margin:5,backgroundColor:null,backgroundOpacity:.85},xaxis:{mode:null,transform:null,inverseTransform:null,min:null,max:null,autoscaleMargin:null,ticks:null,tickFormatter:null,labelWidth:null,labelHeight:null,tickDecimals:null,tickSize:null,minTickSize:null,monthNames:null,timeformat:null,twelveHourClock:!1},yaxis:{autoscaleMargin:.02},x2axis:{autoscaleMargin:null},y2axis:{autoscaleMargin:.02},series:{points:{show:!1,radius:3,lineWidth:2,fill:!0,fillColor:"#ffffff"},lines:{lineWidth:2,fill:!1,fillColor:null,steps:!1},bars:{show:!1,lineWidth:2,barWidth:1,fill:!0,fillColor:null,align:"left",horizontal:!1},shadowSize:3},grid:{show:!0,aboveData:!1,color:"#545454",backgroundColor:null,tickColor:"rgba(0,0,0,0.15)",labelMargin:5,borderWidth:2,borderColor:null,markings:null,markingsColor:"#f4f4f4",markingsLineWidth:2,clickable:!1,hoverable:!1,autoHighlight:!0,mouseActiveRadius:10},hooks:{}},j=null,k=null,l=null,m=null,n=null,o={xaxis:{},yaxis:{},x2axis:{},y2axis:{}},p={left:0,right:0,top:0,bottom:0},q=0,r=0,s=0,t=0,u={processOptions:[],processRawData:[],processDatapoints:[],draw:[],bindEvents:[],drawOverlay:[]},v=this;v.setData=z,v.setupGrid=G,v.draw=K,v.getPlaceholder=function(){return b},v.getCanvas=function(){return j},v.getPlotOffset=function(){return p},v.width=function(){return s},v.height=function(){return t},v.offset=function(){var a=l.offset();a.left+=p.left,a.top+=p.top;return a},v.getData=function(){return g},v.getAxes=function(){return o},v.getOptions=function(){return h},v.highlight=bc,v.unhighlight=bd,v.triggerRedrawOverlay=ba,v.pointOffset=function(a){return{left:parseInt(B(a,"xaxis").p2c(+a.x)+p.left),top:parseInt(B(a,"yaxis").p2c(+a.y)+p.top)}},v.hooks=u,x(v),y(e),E(),z(d),G(),K(),F();var V=[],W=null}a.plot=function(c,d,e){var f=new b(a(c),d,e,a.plot.plugins);return f},a.plot.plugins=[],a.plot.formatDate=function(a,b,c){var d=function(a){a=""+a;return a.length==1?"0"+a:a},e=[],f=!1,g=a.getUTCHours(),h=g<12;c==null&&(c=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"]),b.search(/%p|%P/)!=-1&&(g>12?g=g-12:g==0&&(g=12));for(var i=0;i<b.length;++i){var j=b.charAt(i);if(f){switch(j){case"h":j=""+g;break;case"H":j=d(g);break;case"M":j=d(a.getUTCMinutes());break;case"S":j=d(a.getUTCSeconds());break;case"d":j=""+a.getUTCDate();break;case"m":j=""+(a.getUTCMonth()+1);break;case"y":j=""+a.getUTCFullYear();break;case"b":j=""+c[a.getUTCMonth()];break;case"p":j=h?"am":"pm";break;case"P":j=h?"AM":"PM"}e.push(j),f=!1}else j=="%"?f=!0:e.push(j)}return e.join("")}}(jQuery),define("lib/jquery.flot",function(){}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/ui/LineChart",["lib/DateFormat","neo4j/webadmin/ui/Tooltip","lib/jquery.flot","lib/backbone"],function(b,c){var d;return d=function(){function e(b){this.remove=a(this.remove,this),this.render=a(this.render,this),this.mouseOverPlot=a(this.mouseOverPlot,this),this.el=$(b),this.settings=this.defaultSettings,this.tooltip=new c({closeButton:!1}),this.el.bind("plothover",this.mouseOverPlot)}var d;d=(new Date).getTimezoneOffset()*60*1e3,e.prototype.defaultSettings={label:"",xaxis:{mode:"time",timeformat:"%H:%M:%S",min:0},yaxis:{},legend:{position:"nw"},series:{points:{show:!0},lines:{show:!0}},grid:{hoverable:!0},colors:["#490A3D","#BD1550","#E97F02","#F8CA00","#8A9B0F"],tooltipYFormatter:function(a){return Math.round(a)},tooltipXFormatter:function(a){return b.format(new Date(a+d))}},e.prototype.mouseOverPlot=function(a,b,c){var d,e;if(!c)return this.tooltip.hide();if(this.previousHoverPoint!==c.datapoint){this.previousHoverPoint=c.datapoint,d=this.settings.tooltipXFormatter(c.datapoint[0]),e=this.settings.tooltipYFormatter(c.datapoint[1]);return this.tooltip.show("<b>"+c.series.label+"</b><span class='chart-y'>"+e+"</span><span class='chart-x'>"+d+"</span>",[c.pageX,c.pageY])}},e.prototype.render=function(a,b){this.settings=_.extend({},this.defaultSettings,b);return $.plot(this.el,a,this.settings)},e.prototype.remove=function(){this.el.unbind("plothover",this.mouseOverPlot),this.tooltip.remove();return this.el.remove()};return e}()})}.call(this),define("neo4j/webadmin/templates/dashboard/charts",["require","exports","module"],function(){return function(vars){with(vars||{})return'<div class="headline-bar"><ul class="dashboard-zoom-tabs tabs"><li><button value="year" class="switch-dashboard-zoom">Year</button></li><li><button value="month" class="switch-dashboard-zoom">One month</button></li><li><button value="week" class="switch-dashboard-zoom">One week</button></li><li><button value="day" class="switch-dashboard-zoom">One day</button></li><li><button value="six_hours" class="switch-dashboard-zoom">6 hours</button></li><li><button value="thirty_minutes" class="switch-dashboard-zoom">30 minutes</button></li></ul><div class="break"></div></div><div id="monitor-chart-wrap"><div id="monitor-chart"></div></div><div class="footer-bar"></div>'}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/dashboard/DashboardChartsView",["neo4j/webadmin/ui/LineChart","neo4j/webadmin/views/View","neo4j/webadmin/templates/dashboard/charts","lib/backbone"],function(b,d,e){var f;return f=function(){function f(){this.unbind=a(this.unbind,this),this.bind=a(this.bind,this),this.remove=a(this.remove,this),this.highlightZoomTab=a(this.highlightZoomTab,this),this.highlightChartSwitchTab=a(this.highlightChartSwitchTab,this),this.switchZoomClicked=a(this.switchZoomClicked,this),this.switchChartClicked=a(this.switchChartClicked,this),this.redrawChart=a(this.redrawChart,this),this.render=a(this.render,this),this.initialize=a(this.initialize,this),f.__super__.constructor.apply(this,arguments)}c(f,d),f.prototype.template=e,f.prototype.events={"click .switch-dashboard-chart":"switchChartClicked","click .switch-dashboard-zoom":"switchZoomClicked"},f.prototype.initialize=function(a){this.statistics=a.statistics,this.dashboardState=a.dashboardState;return this.bind()},f.prototype.render=function(){$(this.el).html(this.template()),this.chart=new b($("#monitor-chart")),this.redrawChart(),this.highlightChartSwitchTab(this.dashboardState.getChartKey()),this.highlightZoomTab(this.dashboardState.getZoomLevelKey());return this},f.prototype.redrawChart=function(){var a,b,c,d,e,f,g,h,i;if(this.chart!=null){a=this.dashboardState.getChart(),i=this.dashboardState.getZoomLevel(),d=function(){var b,c,d,e;d=a.layers,e=[];for(b=0,c=d.length;b<c;b++)h=d[b],e.push(h.key);return e}(),g=(new Date).getTime()-i.xSpan,e=this.statistics.getMetrics(d,g,i.granularity),b=function(){var b,d;d=[];for(c=0,b=e.length;0<=b?c<b:c>b;0<=b?c+=1:c-=1)d.push(_.extend({data:e[c]},a.layers[c]));return d}(),f={xaxis:{min:g-this.statistics.timezoneOffset,mode:"time",timeformat:i.timeformat}};return this.chart.render(b,_.extend(a.chartSettings||{},f))}},f.prototype.switchChartClicked=function(a){this.highlightChartSwitchTab($(a.target).val());return this.dashboardState.setChartByKey($(a.target).val())},f.prototype.switchZoomClicked=function(a){this.highlightZoomTab($(a.target).val());return this.dashboardState.setZoomLevelByKey($(a.target).val())},f.prototype.highlightChartSwitchTab=function(a){$("button.switch-dashboard-chart",this.el).removeClass("current");return $("button.switch-dashboard-chart[value='"+a+"']",this.el).addClass("current")},f.prototype.highlightZoomTab=function(a){$("button.switch-dashboard-zoom",this.el).removeClass("current");return $("button.switch-dashboard-zoom[value='"+a+"']",this.el).addClass("current")},f.prototype.remove=function(){this.unbind(),this.chart!=null&&this.chart.remove();return f.__super__.remove.call(this)},f.prototype.bind=function(){this.dashboardState.bind("change:chart",this.redrawChart),this.dashboardState.bind("change:zoomLevel",this.redrawChart);return this.statistics.bind("change:metrics",this.redrawChart)},f.prototype.unbind=function(){this.dashboardState.unbind("change:chart",this.redrawChart),this.dashboardState.unbind("change:zoomLevel",this.redrawChart);return this.statistics.unbind("change:metrics",this.redrawChart)};return f}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/DashboardView",["neo4j/webadmin/templates/dashboard/base","./dashboard/DashboardInfoView","./dashboard/DashboardChartsView","neo4j/webadmin/views/View","lib/backbone"],function(b,d,e,f){var g;return g=function(){function g(){this.detach=a(this.detach,this),this.remove=a(this.remove,this),this.render=a(this.render,this),this.initialize=a(this.initialize,this),g.__super__.constructor.apply(this,arguments)}c(g,f),g.prototype.template=b,g.prototype.initialize=function(a){this.opts=a,this.appState=a.state,this.server=this.appState.getServer(),this.kernelBean=a.kernelBean;return this.kernelBean.bind("change",this.render)},g.prototype.render=function(){$(this.el).html(this.template({server:{url:this.server.url,version:this.kernelBean.get("KernelVersion")}})),this.infoView!=null&&this.infoView.remove(),this.chartsView!=null&&this.chartsView.remove(),this.infoView=new d(this.opts),this.chartsView=new e(this.opts),this.infoView.attach($("#dashboard-info",this.el)),this.chartsView.attach($("#dashboard-charts",this.el)),this.infoView.render(),this.chartsView.render();return this},g.prototype.remove=function(){this.kernelBean.unbind("change",this.render),this.infoView.remove(),this.chartsView.remove();return g.__super__.remove.call(this)},g.prototype.detach=function(){this.chartsView.unbind();return g.__super__.detach.call(this)};return g}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/models/JmxBackedModel",["lib/backbone"],function(){var b;return b=function(){function b(){this.parseBean=a(this.parseBean,this),this.fetch=a(this.fetch,this),this.setPollingInterval=a(this.setPollingInterval,this),this.initialize=a(this.initialize,this),b.__super__.constructor.apply(this,arguments)}c(b,Backbone.Model),b.prototype.initialize=function(a){this.server=a.server,this.jmx=this.server.manage.jmx,this.dataAvailable=!1;if(a.pollingInterval!=null&&a.pollingInterval>0){this.fetch();return this.setPollingInterval(a.pollingInterval)}},b.prototype.isDataAvailable=function(){return this.dataAvailable},b.prototype.setPollingInterval=function(a){this.interval!=null&&clearInterval(this.interval);return this.interval=setInterval(this.fetch,a)},b.prototype.fetch=function(){var a,b,c,d,e;c=this.parseBean,d=this.beans,e=[];for(b in d)a=d[b],e.push(this.jmx.getBean(a.domain,a.name,this.parseBean));return e},b.prototype.parseBean=function(a){var b,c,d,e,f;if(a!=null){this.dataAvailable=!0,c={},f=a.attributes;for(d=0,e=f.length;d<e;d++)b=f[d],c[b.name]=b.value;return this.set(c)}};return b}()})}.call(this),function(){var a=Object.prototype.hasOwnProperty,b=function(b,c){function e(){this.constructor=b}for(var d in c)a.call(c,d)&&(b[d]=c[d]);e.prototype=c.prototype,b.prototype=new e,b.__super__=c.prototype;return b};define("neo4j/webadmin/models/ServerPrimitives",["./JmxBackedModel","lib/backbone"],function(a){var c;return c=function(){function c(){c.__super__.constructor.apply(this,arguments)}b(c,a),c.prototype.beans={primitives:{domain:"neo4j",name:"Primitive count"}};return c}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/models/DiskUsage",["./JmxBackedModel","lib/backbone"],function(b){var d;return d=function(){function d(){this.getLogicalLogPercentage=a(this.getLogicalLogPercentage,this),this.getLogicalLogSize=a(this.getLogicalLogSize,this),this.getDatabasePercentage=a(this.getDatabasePercentage,this),this.getDatabaseSize=a(this.getDatabaseSize,this),d.__super__.constructor.apply(this,arguments)}c(d,b),d.prototype.beans={diskUsage:{domain:"neo4j",name:"Store file sizes"}},d.prototype.getDatabaseSize=function(){return this.get("TotalStoreSize")-this.get("LogicalLogSize")},d.prototype.getDatabasePercentage=function(){return Math.round((this.get("TotalStoreSize")-this.get("LogicalLogSize"))/this.get("TotalStoreSize")*100)},d.prototype.getLogicalLogSize=function(){return this.get("LogicalLogSize")},d.prototype.getLogicalLogPercentage=function(){return Math.round(this.get("LogicalLogSize")/this.get("TotalStoreSize")*100)};return d}()})}.call(this),function(){var a=Object.prototype.hasOwnProperty,b=function(b,c){function e(){this.constructor=b}for(var d in c)a.call(c,d)&&(b[d]=c[d]);e.prototype=c.prototype,b.prototype=new e,b.__super__=c.prototype;return b};define("neo4j/webadmin/models/CacheUsage",["./JmxBackedModel","lib/backbone"],function(a){var c;return c=function(){function c(){c.__super__.constructor.apply(this,arguments)}b(c,a),c.prototype.beans={cache:{domain:"neo4j",name:"Cache"}};return c}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/models/ServerStatistics",["lib/DateFormat","lib/backbone"],function(b){var d;return d=function(){function b(){this.toLocalTimestamps=a(this.toLocalTimestamps,this),this.addTimestampsToArray=a(this.addTimestampsToArray,this),this.getMetrics=a(this.getMetrics,this),this.setMonitorData=a(this.setMonitorData,this),this.initialize=a(this.initialize,this),b.__super__.constructor.apply(this,arguments)}c(b,Backbone.Model),b.prototype.initialize=function(b){this.timezoneOffset=(new Date).getTimezoneOffset()*60*1e3,this.server=b.server,this.heartbeat=this.server.heartbeat,this.setMonitorData(this.heartbeat.getCachedData());return this.heartbeat.addListener(a(function(a){return this.setMonitorData(a.allData)},this))},b.prototype.setMonitorData=function(a){var b,c,d,e;this.timestamps=this.toLocalTimestamps(a.timestamps),this.indexesToSave=this.getTimestampIndexes(0,3e4),this.timestamps=this.extractValues(this.timestamps,this.indexesToSave),d={},e=a.data;for(c in e)b=e[c],d["metric:"+c]=this.addTimestampsToArray(this.extractValues(b,this.indexesToSave),this.timestamps);this.set(d);return this.trigger("change:metrics")},b.prototype.getMetrics=function(a,b,c){var d,e,f,g,h,i,j;b==null&&(b=0),c==null&&(c=1e4),f=this.getClosestPreceedingTimestampIndex(b),f===-1&&(f=0),d=this.getTimestampIndexes(f,c),j=[];for(h=0,i=a.length;h<i;h++)e=a[h],g=this.get("metric:"+e),j.push(g&&f<g.length?this.extractValues(g,d):[]);return j},b.prototype.getClosestPreceedingTimestampIndex=function(a){var b,c,d;c=a-this.timezoneOffset;for(b=0,d=this.timestamps.length;0<=d?b<=d:b>=d;0<=d?b+=1:b-=1)if(this.timestamps[b]>=c)return b>0?b-1:b;return 0},b.prototype.extractValues=function(a,b){var c,d,e,f;f=[];for(d=0,e=b.length;d<e;d++)c=b[d],f.push(a[c]);return f},b.prototype.getTimestampIndexes=function(a,b){var c,d,e,f,g;e=[],f=0;for(d=a,g=this.timestamps.length;a<=g?d<=g:d>=g;a<=g?d+=1:d-=1)c=this.timestamps[d]-f,c>b&&(f=this.timestamps[d],e.push(d));return e},b.prototype.addTimestampsToArray=function(a,b){var c,d,e;e=[];for(c=0,d=a.length-1;0<=d?c<=d:c>=d;0<=d?c+=1:c-=1)e.push([b[c],a[c]]);return e},b.prototype.toLocalTimestamps=function(a){var b,c,d,e;e=[];for(c=0,d=a.length;c<d;c++)b=a[c],e.push(b-this.timezoneOffset);return e};return b}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/models/DashboardState",["lib/backbone"],function(b){var d;return d=function(){function b(){this.setChart=a(this.setChart,this),this.setChartByKey=a(this.setChartByKey,this),this.setZoomLevel=a(this.setZoomLevel,this),this.setZoomLevelByKey=a(this.setZoomLevelByKey,this),this.getZoomLevelKey=a(this.getZoomLevelKey,this),this.getZoomLevel=a(this.getZoomLevel,this),this.getChartKey=a(this.getChartKey,this),this.getChart=a(this.getChart,this),this.initialize=a(this.initialize,this),b.__super__.constructor.apply(this,arguments)}c(b,Backbone.Model),b.prototype.charts={primitives:{layers:[{label:"Nodes",key:"node_count"},{label:"Properties",key:"property_count"},{label:"Relationships",key:"relationship_count"}]},memory:{layers:[{label:"Memory usage",key:"memory_usage_percent",lines:{show:!0,fill:!0,fillColor:"#4f848f"}}],chartSettings:{yaxis:{min:0,max:100},tooltipYFormatter:function(a){return Math.floor(a)+"%"}}}},b.prototype.zoomLevels={year:{xSpan:31536e6,granularity:10368e5,timeformat:"%d/%m %y"},month:{xSpan:2592e6,granularity:864e5,timeformat:"%d/%m"},week:{xSpan:6048e5,granularity:216e5,timeformat:"%d/%m"},day:{xSpan:864e5,granularity:288e4,timeformat:"%H:%M"},six_hours:{xSpan:216e5,granularity:72e4,timeformat:"%H:%M"},thirty_minutes:{xSpan:18e5,granularity:6e4,timeformat:"%H:%M"}},b.prototype.initialize=function(a){this.setChartByKey("primitives");return this.setZoomLevelByKey("six_hours")},b.prototype.getChart=function(){return this.get("chart")},b.prototype.getChartKey=function(){return this.get("chartKey")},b.prototype.getZoomLevel=function(){return this.get("zoomLevel")},b.prototype.getZoomLevelKey=function(){return this.get("zoomLevelKey")},b.prototype.setZoomLevelByKey=function(a){this.set({zoomLevelKey:a});return this.setZoomLevel(this.zoomLevels[a])},b.prototype.setZoomLevel=function(a){return this.set({zoomLevel:a})},b.prototype.setChartByKey=function(a){this.set({chartKey:a});return this.setChart(this.charts[a])},b.prototype.setChart=function(a){return this.set({chart:a})};return b}()})}.call(this),function(){var a=Object.prototype.hasOwnProperty,b=function(b,c){function e(){this.constructor=b}for(var d in c)a.call(c,d)&&(b[d]=c[d]);e.prototype=c.prototype,b.prototype=new e,b.__super__=c.prototype;return b};define("neo4j/webadmin/models/KernelBean",["./JmxBackedModel","lib/backbone"],function(a){var c;return c=function(){function c(){c.__super__.constructor.apply(this,arguments)}b(c,a),c.prototype.beans={version:{domain:"neo4j",name:"Kernel"}};return c}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/DashboardController",["./views/DashboardView","./models/ServerPrimitives","./models/DiskUsage","./models/CacheUsage","./models/ServerStatistics","./models/DashboardState","./models/KernelBean","lib/backbone"],function(b,d,e,f,g,h,i){var j;return j=function(){function j(){this.getDashboardState=a(this.getDashboardState,this),this.getServerStatistics=a(this.getServerStatistics,this),this.getCacheUsage=a(this.getCacheUsage,this),this.getDiskUsage=a(this.getDiskUsage,this),this.getKernelBean=a(this.getKernelBean,this),this.getServerPrimitives=a(this.getServerPrimitives,this),this.getDashboardView=a(this.getDashboardView,this),this.dashboard=a(this.dashboard,this),this.initialize=a(this.initialize,this),j.__super__.constructor.apply(this,arguments)}c(j,Backbone.Controller),j.prototype.routes={"":"dashboard"},j.prototype.initialize=function(a){return this.appState=a},j.prototype.dashboard=function(){return this.appState.set({mainView:this.getDashboardView()})},j.prototype.getDashboardView=function(){var a;return(a=this.view)!=null?a:this.view=new b({state:this.appState,dashboardState:this.getDashboardState(),primitives:this.getServerPrimitives(),diskUsage:this.getDiskUsage(),cacheUsage:this.getCacheUsage(),statistics:this.getServerStatistics(),kernelBean:this.getKernelBean()})},j.prototype.getServerPrimitives=function(){var a;return(a=this.serverPrimitives)!=null?a:this.serverPrimitives=new d({server:this.appState.getServer(),pollingInterval:5e3})},j.prototype.getKernelBean=function(){var a;return(a=this.kernelBean)!=null?a:this.kernelBean=new i({server:this.appState.getServer(),pollingInterval:1e4})},j.prototype.getDiskUsage=function(){var a;return(a=this.diskUsage)!=null?a:this.diskUsage=new e({server:this.appState.getServer(),pollingInterval:5e3})},j.prototype.getCacheUsage=function(){var a;return(a=this.cacheUsage)!=null?a:this.cacheUsage=new f({server:this.appState.getServer(),pollingInterval:5e3})},j.prototype.getServerStatistics=function(){var a;return(a=this.serverStatistics)!=null?a:this.serverStatistics=new g({server:this.appState.getServer()})},j.prototype.getDashboardState=function(){var a;return(a=this.dashboardState)!=null?a:this.dashboardState=new h({server:this.appState.getServer()})};return j}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/data/Queue",["lib/backbone"],function(){var b;return b=function(){function b(){this.hasMoreItems=a(this.hasMoreItems,this),this.push=a(this.push,this),this.pull=a(this.pull,this),this.queue=[]}c(b,Backbone.Model),b.prototype.pull=function(){var a;a=this.queue.shift(),this.trigger("item:pulled",this,a);return a},b.prototype.push=function(a){this.queue.push(a);return this.trigger("item:pushed",this,a)},b.prototype.hasMoreItems=function(){return this.queue.length>0};return b}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/data/UrlSearcher",["lib/backbone"],function(){var b;return b=function(){function b(b){this.exec=a(this.exec,this),this.match=a(this.match,this),this.server=b,this.pattern=/^https?:\/\/(.+)$/i}b.prototype.match=function(a){return this.pattern.test(a)},b.prototype.exec=function(a){return this.server.getNodeOrRelationship(a)};return b}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/data/ItemUrlResolver",["lib/backbone"],function(){var b;return b=function(){function b(b){this.extractLastUrlSegment=a(this.extractLastUrlSegment,this),this.extractRelationshipId=a(this.extractRelationshipId,this),this.extractNodeId=a(this.extractNodeId,this),this.getRelationshipUrl=a(this.getRelationshipUrl,this),this.getNodeUrl=a(this.getNodeUrl,this),this.server=b}b.prototype.getNodeUrl=function(a){return this.server.url+"/db/data/node/"+a},b.prototype.getRelationshipUrl=function(a){return this.server.url+"/db/data/relationship/"+a},b.prototype.extractNodeId=function(a){return this.extractLastUrlSegment(a)},b.prototype.extractRelationshipId=function(a){return this.extractLastUrlSegment(a)},b.prototype.extractLastUrlSegment=function(a){a.substr(-1)==="/"&&(a=a.substr(0,a.length-1));return a.substr(a.lastIndexOf("/")+1)};return b}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/data/NodeSearcher",["./ItemUrlResolver","lib/backbone"],function(b){var c;return c=function(){function c(c){this.extractNodeId=a(this.extractNodeId,this),this.exec=a(this.exec,this),this.match=a(this.match,this),this.server=c,this.urlResolver=new b(c),this.pattern=/^(node:)?([0-9]+)$/i}c.prototype.match=function(a){return this.pattern.test(a)},c.prototype.exec=function(a){return this.server.node(this.urlResolver.getNodeUrl(this.extractNodeId(a)))},c.prototype.extractNodeId=function(a){var b;b=this.pattern.exec(a);return b[2]};return c}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/data/RelationshipSearcher",["./ItemUrlResolver","lib/backbone"],function(b){var c;return c=function(){function c(c){this.extractRelId=a(this.extractRelId,this),this.exec=a(this.exec,this),this.match=a(this.match,this),this.server=c,this.urlResolver=new b(c),this.pattern=/^((rel)|(relationship)):([0-9]+)$/i}c.prototype.match=function(a){return this.pattern.test(a)},c.prototype.exec=function(a){return this.server.rel(this.urlResolver.getRelationshipUrl(this.extractRelId(a)))},c.prototype.extractRelId=function(a){var b;b=this.pattern.exec(a);return b[4]};return c}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/data/RelationshipsForNodeSearcher",["./ItemUrlResolver","lib/backbone"],function(b){var c;return c=function(){function c(c){this.extractNodeId=a(this.extractNodeId,this),this.exec=a(this.exec,this),this.match=a(this.match,this),this.server=c,this.urlResolver=new b(c),this.pattern=/^((rels)|(relationships)):([0-9]+)$/i}c.prototype.match=function(a){return this.pattern.test(a)},c.prototype.exec=function(a){return this.server.node(this.urlResolver.getNodeUrl(this.extractNodeId(a))).then(function(a,b){return a.getRelationships().then(function(a){return b(a)})})},c.prototype.extractNodeId=function(a){var b;b=this.pattern.exec(a);return b[4]};return c}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/data/Search",["./UrlSearcher","./NodeSearcher","./RelationshipSearcher","./RelationshipsForNodeSearcher"],function(b,c,d,e){var f;return f=function(){function f(f){this.server=f,this.pickSearcher=a(this.pickSearcher,this),this.exec=a(this.exec,this),this.searchers=[new b(f),new c(f),new d(f),new e(f)]}f.prototype.exec=function(a){var b;b=this.pickSearcher(a);return b!=null?b.exec(a):neo4j.Promise.fulfilled(null)},f.prototype.pickSearcher=function(a){var b,c,d,e;e=this.searchers;for(c=0,d=e.length;c<d;c++){b=e[c];if(b.match(a))return b}};return f}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/data/QueuedSearch",["./Queue","./Search"],function(b,d){var e;return e=function(){function e(c){this.pickSearcher=a(this.pickSearcher,this),this.executeNextJob=a(this.executeNextJob,this),this.jobDone=a(this.jobDone,this),this.jobAdded=a(this.jobAdded,this),this.exec=a(this.exec,this),e.__super__.constructor.call(this,c),this.queue=new b,this.queue.bind("item:pushed",this.jobAdded),this.isSearching=!1}c(e,d),e.prototype.exec=function(a){var b;b=new neo4j.Promise,this.queue.push({statement:a,promise:b});return b},e.prototype.jobAdded=function(){if(!this.isSearching)return this.executeNextJob()},e.prototype.jobDone=function(){this.isSearching=!1;if(this.queue.hasMoreItems())return this.executeNextJob()},e.prototype.executeNextJob=function(){var b,c;b=this.queue.pull(),this.isSearching=!0,c=a(function(a){b.promise.fulfill(a);return setTimeout(this.jobDone,0)},this);return e.__super__.exec.call(this,b.statement).then(c,c)},e.prototype.pickSearcher=function(a){var b,c,d,e;e=this.searchers;for(c=0,d=e.length;c<d;c++){b=e[c];if(b.match(a))return b}};return e}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/security/HtmlEscaper",["lib/backbone"],function(){var b;return b=function(){function b(){this.replaceAll=a(this.replaceAll,this),this.escape=a(this.escape,this)}b.prototype.escape=function(a){return this.replaceAll(a,[[/&/g,"&amp;"],[/</g,"&lt;"],[/>/g,"&gt;"],[/"/g,"&quot;"],[/\ /g,"&nbsp;"],[/'/g,"&#x27;"],[/\//g,"&#x2F;"]])},b.prototype.replaceAll=function(a,b){var c,d,e;for(d=0,e=b.length;d<e;d++)c=b[d],a=a.replace(c[0],c[1]);return a};return b}()})}.call(this),define("neo4j/webadmin/templates/databrowser/node",["require","exports","module"],function(){return function(vars){with(vars||{})return'<div class="headline-bar pad"><div class="title"><h3>Node '+item.getId()+'</h3><p class="small">'+item.getSelf()+'</p></div><ul class="button-bar item-controls"><li><a title="Show a list of relationships for this node" href="#/data/search/rels:'+item.getId()+'/" class="data-show-relationships button">Show relationships</a></li><li><button disabled="true" class="data-save-properties button">Saved</button></li><li><button class="data-delete-item bad-button">Delete</button></li></ul><div class="break"></div></div><div class="properties"></div><div class="break"></div>'}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/models/Property",["neo4j/webadmin/security/HtmlEscaper","lib/backbone"],function(b){var d,e;e=new b;return d=function(){function b(){this.hasValueError=a(this.hasValueError,this),this.hasKeyError=a(this.hasKeyError,this),this.setKey=a(this.setKey,this),this.setValue=a(this.setValue,this),this.setValueError=a(this.setValueError,this),this.setKeyError=a(this.setKeyError,this),this.getKeyAsHtml=a(this.getKeyAsHtml,this),this.getTruncatedHtmlValue=a(this.getTruncatedHtmlValue,this),this.getValueAsHtml=a(this.getValueAsHtml,this),this.getValueAsJSON=a(this.getValueAsJSON,this),this.getKeyError=a(this.getKeyError,this),this.getValueError=a(this.getValueError,this),this.getValue=a(this.getValue,this),this.getKey=a(this.getKey,this),this.getLocalId=a(this.getLocalId,this),b.__super__.constructor.apply(this,arguments)}c(b,Backbone.Model),b.prototype.defaults={key:"",value:"",keyError:!1,valueError:!1},b.prototype.getLocalId=function(){return this.get("localId")},b.prototype.getKey=function(){return this.get("key")},b.prototype.getValue=function(){return this.get("value")},b.prototype.getValueError=function(){return this.get("valueError")},b.prototype.getKeyError=function(){return this.get("keyError")},b.prototype.getValueAsJSON=function(){return this.hasValueError()?this.getValue():JSON.stringify(this.getValue())},b.prototype.getValueAsHtml=function(){return e.escape(this.getValueAsJSON())},b.prototype.getTruncatedHtmlValue=function(a){var b;a==null&&(a=100),b=this.getValueAsJSON(),b.length>a&&(b=b.substr(0,a-3)+"..");return e.escape(b)},b.prototype.getKeyAsHtml=function(){return e.escape(this.getKey())},b.prototype.setKeyError=function(a){return this.set({keyError:a})},b.prototype.setValueError=function(a){return this.set({valueError:a})},b.prototype.setValue=function(a){return this.set({value:a})},b.prototype.setKey=function(a){return this.set({key:a})},b.prototype.hasKeyError=function(){return this.getKeyError()!==!1},b.prototype.hasValueError=function(){return this.getValueError()!==!1};return b}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/models/PropertyContainer",["neo4j/webadmin/data/ItemUrlResolver","./Property","lib/backbone"],function(b,d){var e,f;e=0;return f=function(){function f(){this.generatePropertyId=a(this.generatePropertyId,this),this.isValidArrayValue=a(this.isValidArrayValue,this),this.isMap=a(this.isMap,this),this.cleanPropertyValue=a(this.cleanPropertyValue,this),this.noErrors=a(this.noErrors,this),this.setSaveState=a(this.setSaveState,this),this.getSaveState=a(this.getSaveState,this),this.isNotSaved=a(this.isNotSaved,this),this.isSaved=a(this.isSaved,this),this.setNotSaved=a(this.setNotSaved,this),this.setSaved=a(this.setSaved,this),this.saveFailed=a(this.saveFailed,this),this.save=a(this.save,this),this.updatePropertyList=a(this.updatePropertyList,this),this.hasKey=a(this.hasKey,this),this.getPropertyByKey=a(this.getPropertyByKey,this),this.getProperty=a(this.getProperty,this),this.addProperty=a(this.addProperty,this),this.deleteProperty=a(this.deleteProperty,this),this.setValue=a(this.setValue,this),this.setKey=a(this.setKey,this),this.getId=a(this.getId,this),this.getSelf=a(this.getSelf,this),this.getItem=a(this.getItem,this),this.initialize=a(this.initialize,this),f.__super__.constructor.apply(this,arguments)}c(f,Backbone.Model),f.prototype.defaults={status:"saved"},f.prototype.initialize=function(a,c){var d,e,f;this.properties={},this.urlResolver=new b,this.item=a,this.properties={},f=this.getItem().getProperties();for(d in f)e=f[d],this.addProperty(d,e,{silent:!0});this.setSaved();return this.updatePropertyList()},f.prototype.getItem=function(){return this.item},f.prototype.getSelf=function(){return this.getItem().getSelf()},f.prototype.getId=function(){return this.item instanceof neo4j.models.Node?this.urlResolver.extractNodeId(this.getSelf()):this.urlResolver.extractRelationshipId(this.getSelf())},f.prototype.setKey=function(a,b,c){var d,e,f;c==null&&(c={}),d=this.hasKey(b,a),f=this.getProperty(a),e=f.getKey(),f.set({key:b}),this.setNotSaved(),this.getItem().removeProperty(e),d?f.setKeyError("This key is already used, please choose a different one."):(f.setKeyError(!1),this.getItem().setProperty(b,f.getValue()));return this.updatePropertyList(c)},f.prototype.setValue=function(a,b,c){var d,e;c==null&&(c={}),e=this.getProperty(a),d=this.cleanPropertyValue(b),this.setNotSaved(),d.value!=null?(e.set({valueError:!1}),e.set({value:d.value}),this.getItem().setProperty(e.getKey(),d.value)):(e.set({value:b}),e.set({valueError:d.error})),this.updatePropertyList(c);return e},f.prototype.deleteProperty=function(a,b){var c,d;b==null&&(b={}),this.setNotSaved(),d=this.getProperty(a),delete this.properties[a],this.getItem().removeProperty(d.getKey()),c=this.getPropertyByKey(d.getKey()),c&&this.setKey(c.getLocalId(),c.getKey(),b),this.updatePropertyList(b);return this.trigger("remove:property")},f.prototype.addProperty=function(a,b,c){var e;a==null&&(a=""),b==null&&(b=""),c==null&&(c={}),e=this.generatePropertyId(),this.properties[e]=new d({key:a,value:b,localId:e}),this.updatePropertyList(c);return this.trigger("add:property")},f.prototype.getProperty=function(a){return this.properties[a]},f.prototype.getPropertyByKey=function(a,b){var c,d,e;b==null&&(b=null),e=this.properties;for(c in e){d=e[c];if(d.getKey()===a&&parseInt(c)!==parseInt(b))return d}return null},f.prototype.hasKey=function(a,b){b==null&&(b=null);return this.getPropertyByKey(a,b)!==null},f.prototype.updatePropertyList=function(a){var b,c,d,e,f;a==null&&(a={}),b=[],f=this.properties;for(c in f)d=f[c],b.push(d);e=a.silent!=null&&a.silent===!0,a.silent=!0,this.set({propertyList:b},a);if(!e)return this.trigger("change:propertyList")},f.prototype.save=function(){if(this.noErrors()){this.setSaveState("saving");return this.getItem().save().then(this.setSaved,this.saveFailed)}},f.prototype.saveFailed=function(a){return this.setNotSaved()},f.prototype.setSaved=function(){return this.setSaveState("saved")},f.prototype.setNotSaved=function(){return this.setSaveState("notSaved")},f.prototype.isSaved=function(){return this.getSaveState()==="saved"},f.prototype.isNotSaved=function(){return this.getSaveState()==="notSaved"},f.prototype.getSaveState=function(){return this.get("status")},f.prototype.setSaveState=function(a,b){b==null&&(b={});return this.set({status:a})},f.prototype.noErrors=function(a){var b,c,d;a==null&&(a={}),d=this.properties;for(b in d){c=d[b];if(a.ignore==null||a.ignore!==b)if(c.hasKeyError()||c.hasValueError())return!1}return!0},f.prototype.cleanPropertyValue=function(a){var b;try{b=JSON.parse(a);return b===null?{error:"Null values are not allowed. Please use strings, numbers or arrays."}:this.isMap(b)?{error:"Maps are not supported property values. Please use strings, numbers or arrays."}:_(b).isArray()&&!this.isValidArrayValue(b)?{error:"Only arrays with one type of values, and only primitive types, is allowed."}:{value:b}}catch(c){return{error:'This does not appear to be a valid JSON value. Valid values are JSON strings, numbers or arrays. For instance 1.2, "bob" and [1,2,3].'}}},f.prototype.isMap=function(a){return JSON.stringify(a).indexOf("{")===0},f.prototype.isValidArrayValue=function(a){var b,c,d,e,f;if(a.length===0)return!0;b=a[0];if(_.isString(b))c=_.isString;else if(_.isNumber(b))c=_.isNumber;else if(_.isBoolean(b))c=_.isBoolean;else return!1;for(e=0,f=a.length;e<f;e++){d=a[e];if(!c(d))return!1}return!0},f.prototype.generatePropertyId=function(){return e++};return f}()})}.call(this),define("neo4j/webadmin/templates/databrowser/propertyEditor",["require","exports","module"],function(){return function(vars){with(vars||{})return'<ul class="property-list">'+function(){var a=[],b,c;for(b in properties)properties.hasOwnProperty(b)&&(c=properties[b],a.push('<li><ul class="property-row"><li class="property-key-wrap"><div class="property-input-wrap"><input type="hidden" value="'+c.getLocalId()+'" class="property-id" /><div class="error">'+function(){return c.hasKeyError()?c.getKeyError():""}.call(this)+'</div><input type="text" value="'+escape(c.getKey())+'" class="property-key" /></div></li><li class="property-value-wrap"><div class="property-input-wrap"><div class="error">'+function(){return c.hasValueError()?c.getValueError():""}.call(this)+'</div><input type="text" value="'+c.getValueAsHtml()+'" class="property-value" /></div></li><li class="property-actions-wrap"><div class="property-input-wrap"><button class="delete-property bad-button">Remove</button></div></li></ul><div class="break"></div></li>'));return a.join("")}.call(this)+'<li class="property-controls"><button title="Add a new property" class="add-property text-icon-button">Add property</button><div class="break"></div></li></ul>'}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/databrowser/PropertyContainerView",["neo4j/webadmin/models/PropertyContainer","neo4j/webadmin/views/View","neo4j/webadmin/templates/databrowser/propertyEditor","lib/backbone"],function(b,d,e){var f;return f=function(){function b(){this.shouldBeConvertedToString=a(this.shouldBeConvertedToString,this),this.unbind=a(this.unbind,this),this.remove=a(this.remove,this),this.renderProperties=a(this.renderProperties,this),this.render=a(this.render,this),this.setDataModel=a(this.setDataModel,this),this.getPropertyIdForElement=a(this.getPropertyIdForElement,this),this.setSaveState=a(this.setSaveState,this),this.updateSaveState=a(this.updateSaveState,this),this.updateErrorMessages=a(this.updateErrorMessages,this),this.deleteItem=a(this.deleteItem,this),this.saveChanges=a(this.saveChanges,this),this.addProperty=a(this.addProperty,this),this.deleteProperty=a(this.deleteProperty,this),this.valueChangeDone=a(this.valueChangeDone,this),this.keyChangeDone=a(this.keyChangeDone,this),this.valueChanged=a(this.valueChanged,this),this.keyChanged=a(this.keyChanged,this),this.initialize=a(this.initialize,this),b.__super__.constructor.apply(this,arguments)}c(b,d),b.prototype.events={"keyup input.property-key":"keyChanged","keyup input.property-value":"valueChanged","change input.property-key":"keyChangeDone","change input.property-value":"valueChangeDone","click button.delete-property":"deleteProperty","click button.add-property":"addProperty","click button.data-save-properties":"saveChanges","click button.data-delete-item":"deleteItem"},b.prototype.initialize=function(a){return this.template=a.template},b.prototype.keyChanged=function(a){var b;b=this.getPropertyIdForElement(a.target);if($(a.target).val()!==this.propertyContainer.getProperty(b).getKey())return this.propertyContainer.setNotSaved()},b.prototype.valueChanged=function(a){var b,c;b=this.getPropertyIdForElement(a.target);if($(a.target).val()!==this.propertyContainer.getProperty(b).getValueAsJSON())return c=this.propertyContainer.setNotSaved()},b.prototype.keyChangeDone=function(a){var b;b=this.getPropertyIdForElement(a.target),this.propertyContainer.setKey(b,$(a.target).val()),this.saveChanges();return this.updateErrorMessages()},b.prototype.valueChangeDone=function(a){var b,c;c=this.getPropertyIdForElement(a.target),b=$(a.target),this.shouldBeConvertedToString(b.val())&&b.val('"'+b.val()+'"'),this.propertyContainer.setValue(c,b.val()),this.saveChanges();return this.updateErrorMessages()},b.prototype.deleteProperty=function(a){var b;b=this.getPropertyIdForElement(a.target),this.propertyContainer.deleteProperty(b);return this.propertyContainer.save()},b.prototype.addProperty=function(a){return this.propertyContainer.addProperty()},b.prototype.saveChanges=function(a){return this.propertyContainer.save()},b.prototype.deleteItem=function(a){if(confirm("Are you sure?"))return this.propertyContainer.getItem().remove().then(function(){return window.location="#/data/search/0"})},b.prototype.updateErrorMessages=function(){var a,b,c,d,e,f,g,h,i;h=$("ul.property-row",this.el),i=[];for(f=0,g=h.length;f<g;f++)d=h[f],a=$(d).find("input.property-id").val(),c=this.propertyContainer.getProperty(a),i.push(c?(b=c.hasKeyError()?c.getKeyError():"",e=c.hasValueError()?c.getValueError():"",$(d).find(".property-key-wrap .error").html(b),$(d).find(".property-value-wrap .error").html(e)):void 0);return i},b.prototype.updateSaveState=function(a){var b;b=this.propertyContainer.getSaveState();switch(b){case"saved":return this.setSaveState("Saved",!0);case"notSaved":return this.setSaveState("Not saved",!1);case"saving":return this.setSaveState("Saving..",!0);case"cantSave":return this.setSaveState("Can't save",!0)}},b.prototype.setSaveState=function(a,b){var c;c=$("button.data-save-properties",this.el),c.html(a);return b?c.attr("disabled","disabled"):c.removeAttr("disabled")},b.prototype.getPropertyIdForElement=function(a){return $(a).closest("ul").find("input.property-id").val()},b.prototype.setDataModel=function(a){this.unbind(),this.propertyContainer=a.getData(),this.propertyContainer.bind("remove:property",this.renderProperties),this.propertyContainer.bind("add:property",this.renderProperties);return this.propertyContainer.bind("change:status",this.updateSaveState)},b.prototype.render=function(){$(this.el).html(this.template({item:this.propertyContainer})),this.renderProperties();return this},b.prototype.renderProperties=function(){$(".properties",this.el).html(e({properties:this.propertyContainer.get("propertyList")}));return this},b.prototype.remove=function(){this.unbind();return b.__super__.remove.call(this)},b.prototype.unbind=function(){if(this.propertyContainer!=null){this.propertyContainer.unbind("remove:property",this.renderProperties),this.propertyContainer.unbind("add:property",this.renderProperties);return this.propertyContainer.unbind("change:status",this.updateSaveState)}},b.prototype.shouldBeConvertedToString=function(a){try{JSON.parse(a);return!1}catch(b){return/^[a-z0-9-_\/\\\(\)#%\&!$]+$/i.test(a)}};return b}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/databrowser/NodeView",["neo4j/webadmin/templates/databrowser/node","./PropertyContainerView","lib/backbone"],function(b,d){var e;return e=function(){function e(){this.initialize=a(this.initialize,this),e.__super__.constructor.apply(this,arguments)}c(e,d),e.prototype.initialize=function(a){a==null&&(a={}),a.template=b;return e.__super__.initialize.call(this,a)};return e}()})}.call(this),define("neo4j/webadmin/templates/databrowser/relationship",["require","exports","module"],function(){return function(vars){with(vars||{})return'<div class="headline-bar pad"><div class="title"><h3>Relationship '+item.getId()+'</h3><p class="small">'+item.getSelf()+'</p></div><ul class="button-bar item-controls"><li><button disabled="true" class="data-save-properties button">Saved</button></li><li><button class="data-delete-item bad-button">Delete</button></li></ul><ul class="relationship-meta"><li><a href="#/data/search/'+item.getStartId()+'/" class="micro-button">Node '+item.getStartId()+'</a></li><li class="type">'+item.getItem().getType()+'</li><li><a href="#/data/search/'+item.getEndId()+'/" class="micro-button">Node '+item.getEndId()+'</a></li></ul><div class="break"></div></div><div class="properties"></div><div class="break"></div>'}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/databrowser/RelationshipView",["neo4j/webadmin/templates/databrowser/relationship","./PropertyContainerView","lib/backbone"],function(b,d){var e;return e=function(){function e(){this.initialize=a(this.initialize,this),e.__super__.constructor.apply(this,arguments)}c(e,d),e.prototype.initialize=function(a){a==null&&(a={}),a.template=b;return e.__super__.initialize.call(this,a)};return e}()})}.call(this),define("neo4j/webadmin/templates/databrowser/relationshipList",["require","exports","module"],function(){return function(vars){with(vars||{})return'<table cellspacing="0" class="data-table"><tbody><tr><th><h3>Relationship</h3></th><th><h3>Start node</h3></th><th><h3>Type</h3></th><th><h3>End node</h3></th>'+function(){var a=[],b,c;for(b in relationshipList.getPropertyKeys())relationshipList.getPropertyKeys().hasOwnProperty(b)&&(c=relationshipList.getPropertyKeys()[b],a.push("<th><h3>"+c+"</h3></th>"));return a.join("")}.call(this)+"</tr>"+function(){var a=[],b,c;for(b in relationshipList.getRelationships())relationshipList.getRelationships().hasOwnProperty(b)&&(c=relationshipList.getRelationships()[b],a.push('<tr><td><a href="#/data/search/rel:'+c.getId()+'/" class="micro-button">Relationship '+c.getId()+'</a></td><td><a href="#/data/search/'+c.getStartId()+'/" class="micro-button">Node '+c.getStartId()+'</a></td><td class="small">'+c.getItem().getType()+'</td><td><a href="#/data/search/'+c.getEndId()+'/" class="micro-button">Node '+c.getEndId()+"</a></td>"+function(){var a=[],b,d;for(b in relationshipList.getPropertyKeys())relationshipList.getPropertyKeys().hasOwnProperty(b)&&(d=relationshipList.getPropertyKeys()[b],a.push('<td class="small">'+function(){return c.getPropertyByKey(d)?c.getPropertyByKey(d).getTruncatedHtmlValue(50):""}.call(this)+"</td>"));return a.join("")}.call(this)+"</tr>"));return a.join("")}.call(this)+'</tbody></table><div class="break"></div>'}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/databrowser/RelationshipListView",["neo4j/webadmin/templates/databrowser/relationshipList","neo4j/webadmin/views/View","lib/backbone"],function(b,d){var e;return e=function(){function e(){this.setDataModel=a(this.setDataModel,this),this.render=a(this.render,this),e.__super__.constructor.apply(this,arguments)}c(e,d),e.prototype.render=function(){$(this.el).html(b({relationshipList:this.dataModel.getData()}));return this},e.prototype.setDataModel=function(a){return this.dataModel=a};return e}()})}.call(this),define("neo4j/webadmin/templates/databrowser/notfound",["require","exports","module"],function(){return function(vars){with(vars||{})return'<div class="pad"><h1>Not found</h1><p>There was no result returned for your query.</p></div>'}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/databrowser/TabularView",["./NodeView","./RelationshipView","./RelationshipListView","neo4j/webadmin/views/View","neo4j/webadmin/templates/databrowser/notfound","lib/backbone"],function(b,d,e,f,g){var h;return h=function(){function h(){this.remove=a(this.remove,this),this.render=a(this.render,this),h.__super__.constructor.apply(this,arguments)}c(h,f),h.prototype.initialize=function(a){this.nodeView=new b,this.relationshipView=new d,this.relationshipListView=new e,this.dataModel=a.dataModel;return this.dataModel.bind("change",this.render)},h.prototype.render=function(){var a,b;a=this.dataModel.get("type");switch(a){case"node":b=this.nodeView;break;case"relationship":b=this.relationshipView;break;case"relationshipList":b=this.relationshipListView;break;default:$(this.el).html(g());return this}b.setDataModel(this.dataModel),$(this.el).html(b.render().el),b.delegateEvents();return this},h.prototype.remove=function(){this.dataModel.unbind("change",this.render),this.nodeView.remove(),this.relationshipView.remove(),this.relationshipListView.remove();return h.__super__.remove.call(this)};return h}()})}.call(this),function(){function f(a){var f=a.currentTarget||a.srcElement,g,h,i;if(a.type==="load"||b.test(f.readyState)){h=f.getAttribute("data-requiremodule"),d[h]=!0;for(g=0;i=c[g];g++)if(d[i.name])e(i.name,i.req,i.onLoad);else break;g>0&&c.splice(0,g),setTimeout(function(){f.parentNode.removeChild(f)},15)}}function e(a,b,c){b([a],function(a){c(function(){return a})})}var a=typeof document!=="undefined"&&typeof window!=="undefined"&&(document.createElement("script").async||window.opera&&Object.prototype.toString.call(window.opera)==="[object Opera]"||"MozAppearance"in document.documentElement.style),b=/^(complete|loaded)$/,c=[],d={};define("require/order",{load:function(b,d,g,h){var i=d.nameToUrl(b,null);h.isBuild?e(b,d,g):(require.s.skipAsync[i]=!0,a?d([b],function(a){g(function(){return a})}):d.isDefined(b)?d([b],function(a){g(function(){return a})}):(c.push({name:b,req:d,onLoad:g}),require.attach(i,"",b,f,"script/cache")))}})}(),function($){var trace=function(msg){if(typeof window!="undefined"&&window.console){var len=arguments.length,args=[];for(var i=0;i<len;i++)args.push("arguments["+i+"]");eval("console.log("+args.join(",")+")")}},dirname=function(a){var b=a.replace(/^\/?(.*?)\/?$/,"$1").split("/");b.pop();return"/"+b.join("/")},basename=function(a){var b=a.replace(/^\/?(.*?)\/?$/,"$1").split("/"),c=b.pop();return c==""?null:c},_ordinalize_re=/(\d)(?=(\d\d\d)+(?!\d))/g,ordinalize=function(a){var b=""+a;a<11e3?b=(""+a).replace(_ordinalize_re,"$1,"):a<1e6?b=Math.floor(a/1e3)+"k":a<1e9&&(b=(""+Math.floor(a/1e3)).replace(_ordinalize_re,"$1,")+"m");return b},nano=function(a,b){return a.replace(/\{([\w\-\.]*)}/g,function(a,c){var d=c.split("."),e=b[d.shift()];$.each(d,function(){e.hasOwnProperty(this)?e=e[this]:e=a});return e})},objcopy=function(a){if(a===undefined)return undefined;if(a===null)return null;if(a.parentNode)return a;switch(typeof a){case"string":return a.substring(0);case"number":return a+0;case"boolean":return a===!0}var b=$.isArray(a)?[]:{};$.each(a,function(a,c){b[a]=objcopy(c)});return b},objmerge=function(a,b){a=a||{},b=b||{};var c=objcopy(a);for(var d in b)c[d]=b[d];return c},objcmp=function(a,b,c){if(!a||!b)return a===b;if(typeof a!=typeof b)return!1;if(typeof a!="object")return a===b;if($.isArray(a)){if(!$.isArray(b))return!1;if(a.length!=b.length)return!1}else{var d=[];for(var e in a)a.hasOwnProperty(e)&&d.push(e);var f=[];for(var e in b)b.hasOwnProperty(e)&&f.push(e);c||(d.sort(),f.sort());if(d.join(",")!==f.join(","))return!1}var g=!0;$.each(a,function(c){var d=objcmp(a[c],b[c]);g=g&&d;if(!g)return!1});return g},objkeys=function(a){var b=[];$.each(a,function(c,d){a.hasOwnProperty(c)&&b.push(c)});return b},objcontains=function(a){if(!a||typeof a!="object")return!1;for(var b=1,c=arguments.length;b<c;b++)if(a.hasOwnProperty(arguments[b]))return!0;return!1},uniq=function(a){var b=a.length,c={};for(var d=0;d<b;d++)c[a[d]]=!0;return objkeys(c)},arbor_path=function(){var a=$("script").map(function(a){var b=$(this).attr("src");if(b)if(b.match(/arbor[^\/\.]*.js|dev.js/))return b.match(/.*\//)||"/"});return a.length>0?a[0]:null},Colors=function(){var a=/#[0-9a-f]{6}/i,b=/#(..)(..)(..)/,c=function(a){var b=a.toString(16);return b.length==2?b:"0"+b},d=function(a){return parseInt(a,16)},e=function(a){if(!a||typeof a!="object")return!1;var b=objkeys(a).sort().join("");if(b=="abgr")return!0},f={CSS:{aliceblue:"#f0f8ff",antiquewhite:"#faebd7",aqua:"#00ffff",aquamarine:"#7fffd4",azure:"#f0ffff",beige:"#f5f5dc",bisque:"#ffe4c4",black:"#000000",blanchedalmond:"#ffebcd",blue:"#0000ff",blueviolet:"#8a2be2",brown:"#a52a2a",burlywood:"#deb887",cadetblue:"#5f9ea0",chartreuse:"#7fff00",chocolate:"#d2691e",coral:"#ff7f50",cornflowerblue:"#6495ed",cornsilk:"#fff8dc",crimson:"#dc143c",cyan:"#00ffff",darkblue:"#00008b",darkcyan:"#008b8b",darkgoldenrod:"#b8860b",darkgray:"#a9a9a9",darkgrey:"#a9a9a9",darkgreen:"#006400",darkkhaki:"#bdb76b",darkmagenta:"#8b008b",darkolivegreen:"#556b2f",darkorange:"#ff8c00",darkorchid:"#9932cc",darkred:"#8b0000",darksalmon:"#e9967a",darkseagreen:"#8fbc8f",darkslateblue:"#483d8b",darkslategray:"#2f4f4f",darkslategrey:"#2f4f4f",darkturquoise:"#00ced1",darkviolet:"#9400d3",deeppink:"#ff1493",deepskyblue:"#00bfff",dimgray:"#696969",dimgrey:"#696969",dodgerblue:"#1e90ff",firebrick:"#b22222",floralwhite:"#fffaf0",forestgreen:"#228b22",fuchsia:"#ff00ff",gainsboro:"#dcdcdc",ghostwhite:"#f8f8ff",gold:"#ffd700",goldenrod:"#daa520",gray:"#808080",grey:"#808080",green:"#008000",greenyellow:"#adff2f",honeydew:"#f0fff0",hotpink:"#ff69b4",indianred:"#cd5c5c",indigo:"#4b0082",ivory:"#fffff0",khaki:"#f0e68c",lavender:"#e6e6fa",lavenderblush:"#fff0f5",lawngreen:"#7cfc00",lemonchiffon:"#fffacd",lightblue:"#add8e6",lightcoral:"#f08080",lightcyan:"#e0ffff",lightgoldenrodyellow:"#fafad2",lightgray:"#d3d3d3",lightgrey:"#d3d3d3",lightgreen:"#90ee90",lightpink:"#ffb6c1",lightsalmon:"#ffa07a",lightseagreen:"#20b2aa",lightskyblue:"#87cefa",lightslategray:"#778899",lightslategrey:"#778899",lightsteelblue:"#b0c4de",lightyellow:"#ffffe0",lime:"#00ff00",limegreen:"#32cd32",linen:"#faf0e6",magenta:"#ff00ff",maroon:"#800000",mediumaquamarine:"#66cdaa",mediumblue:"#0000cd",mediumorchid:"#ba55d3",mediumpurple:"#9370d8",mediumseagreen:"#3cb371",mediumslateblue:"#7b68ee",mediumspringgreen:"#00fa9a",mediumturquoise:"#48d1cc",mediumvioletred:"#c71585",midnightblue:"#191970",mintcream:"#f5fffa",mistyrose:"#ffe4e1",moccasin:"#ffe4b5",navajowhite:"#ffdead",navy:"#000080",oldlace:"#fdf5e6",olive:"#808000",olivedrab:"#6b8e23",orange:"#ffa500",orangered:"#ff4500",orchid:"#da70d6",palegoldenrod:"#eee8aa",palegreen:"#98fb98",paleturquoise:"#afeeee",palevioletred:"#d87093",papayawhip:"#ffefd5",peachpuff:"#ffdab9",peru:"#cd853f",pink:"#ffc0cb",plum:"#dda0dd",powderblue:"#b0e0e6",purple:"#800080",red:"#ff0000",rosybrown:"#bc8f8f",royalblue:"#4169e1",saddlebrown:"#8b4513",salmon:"#fa8072",sandybrown:"#f4a460",seagreen:"#2e8b57",seashell:"#fff5ee",sienna:"#a0522d",silver:"#c0c0c0",skyblue:"#87ceeb",slateblue:"#6a5acd",slategray:"#708090",slategrey:"#708090",snow:"#fffafa",springgreen:"#00ff7f",steelblue:"#4682b4",tan:"#d2b48c",teal:"#008080",thistle:"#d8bfd8",tomato:"#ff6347",turquoise:"#40e0d0",violet:"#ee82ee",wheat:"#f5deb3",white:"#ffffff",whitesmoke:"#f5f5f5",yellow:"#ffff00",yellowgreen:"#9acd32"},decode:function(c){var g=arguments.length;for(var h=g-1;h>=0;h--)arguments[h]===undefined&&g--;var i=arguments;if(!c)return null;if(g==1&&e(c))return c;var j=null;if(typeof c=="string"){var k=1;g==2&&(k=i[1]);var l=f.CSS[c.toLowerCase()];l!==undefined&&(c=l);var m=c.match(a);if(m){vals=c.match(b);if(!vals||!vals.length||vals.length!=4)return null;j={r:d(vals[1]),g:d(vals[2]),b:d(vals[3]),a:k}}}else typeof c=="number"&&(g<3?g>=1&&(j={r:i[0],g:i[0],b:i[0],a:1},g==2&&(j.a*=i[1])):(j={r:i[0],g:i[1],b:i[2],a:1},g>=4&&(j.a*=i[3])));return j},validate:function(b){if(!b||typeof b!="string")return!1;if(f.CSS[b.toLowerCase()]!==undefined)return!0;if(b.match(a))return!0;return!1},mix:function(a,b,c){var d=f.decode(a),e=f.decode(b)},blend:function(a,b){b=b!==undefined?Math.max(0,Math.min(1,b)):1;var c=f.decode(a);if(!c)return null;if(b==1)return a;var c=a;typeof a=="string"&&(c=f.decode(a));var d=objcopy(c);d.a*=b;return nano("rgba({r},{g},{b},{a})",d)},encode:function(a){if(!e(a)){a=f.decode(a);if(!e(a))return null}return a.a==1?nano("#{r}{g}{b}",{r:c(a.r),g:c(a.g),b:c(a.b)}):nano("rgba({r},{g},{b},{a})",a)}};return f}(),Primitives=function(a,b,c){var d=function(a,b,c,d,e){this.x=a,this.y=b,this.w=c,this.h=d,this.style=e!==undefined?e:{}};d.prototype={draw:function(a){this._draw(a)},_draw:function(c,d,e,f,g){objcontains(c,"stroke","fill","width")&&(g=c),this.x!==undefined&&(c=this.x,d=this.y,e=this.w,f=this.h,g=objmerge(this.style,g)),g=objmerge(b,g);if(g.stroke||g.fill){var h=.5522848;ox=e/2*h,oy=f/2*h,xe=c+e,ye=d+f,xm=c+e/2,ym=d+f/2,a.save(),a.beginPath(),a.moveTo(c,ym),a.bezierCurveTo(c,ym-oy,xm-ox,d,xm,d),a.bezierCurveTo(xm+ox,d,xe,ym-oy,xe,ym),a.bezierCurveTo(xe,ym+oy,xm+ox,ye,xm,ye),a.bezierCurveTo(xm-ox,ye,c,ym+oy,c,ym),a.closePath(),g.fill!==null&&(g.alpha!==undefined?a.fillStyle=Colors.blend(g.fill,g.alpha):a.fillStyle=Colors.encode(g.fill),a.fill()),g.stroke!==null&&(a.strokeStyle=Colors.encode(g.stroke),isNaN(g.width)||(a.lineWidth=g.width),a.stroke()),a.restore()}}};var e=function(a,b,c,d,e,f){objcontains(e,"stroke","fill","width")&&(f=e,e=0),this.x=a,this.y=b,this.w=c,this.h=d,this.r=e!==undefined?e:0,this.style=f!==undefined?f:{}};e.prototype={draw:function(a){this._draw(a)},_draw:function(c,d,e,f,g,h){objcontains(g,"stroke","fill","width","alpha")?(h=g,g=0):objcontains(c,"stroke","fill","width","alpha")&&(h=c),this.x!==undefined&&(c=this.x,d=this.y,e=this.w,f=this.h,h=objmerge(this.style,h)),h=objmerge(b,h);if(h.stroke||h.fill){var i=g>0;a.save(),a.beginPath(),a.moveTo(c+g,d),a.lineTo(c+e-g,d),i&&a.quadraticCurveTo(c+e,d,c+e,d+g),a.lineTo(c+e,d+f-g),i&&a.quadraticCurveTo(c+e,d+f,c+e-g,d+f),a.lineTo(c+g,d+f),i&&a.quadraticCurveTo(c,d+f,c,d+f-g),a.lineTo(c,d+g),i&&a.quadraticCurveTo(c,d,c+g,d),h.fill!==null&&(h.alpha!==undefined?a.fillStyle=Colors.blend(h.fill,h.alpha):a.fillStyle=Colors.encode(h.fill),a.fill()),h.stroke!==null&&(a.strokeStyle=Colors.encode(h.stroke),isNaN(h.width)||(a.lineWidth=h.width),a.stroke()),a.restore()}}};var f=function(a,b,c,d,e){e!==undefined||typeof d=="number"?(this.points=[{x:a,y:b},{x:c,y:d}],this.style=e||{}):$.isArray(a)?(this.points=a,this.style=b||{}):(this.points=[a,b],this.style=c||{})};f.prototype={draw:function(c){if(this.points.length>=2){var d=[];$.isArray(this.points[0])?d=this.points:d.push(this.points),a.save(),a.beginPath(),$.each(d,function(b,c){a.moveTo(c[0].x+.5,c[0].y+.5),$.each(c,function(b,c){b!=0&&a.lineTo(c.x+.5,c.y+.5)})});var e=$.extend(objmerge(b,this.style),c);e.closed&&a.closePath();if(e.fill!==undefined){var f=Colors.decode(e.fill,e.alpha!==undefined?e.alpha:1);f&&(a.fillStyle=Colors.encode(f)),a.fill()}if(e.stroke!==undefined){var g=Colors.decode(e.stroke,e.alpha!==undefined?e.alpha:1);g&&(a.strokeStyle=Colors.encode(g)),isNaN(e.width)||(a.lineWidth=e.width),a.stroke()}a.restore()}}};var g=function(a,b,c,d){var e=Colors.decode(a,b,c,d);e&&(this.r=e.r,this.g=e.g,this.b=e.b,this.a=e.a)};g.prototype={toString:function(){return Colors.encode(this)},blend:function(){trace("blend",this.r,this.g,this.b,this.a)}};return{_Oval:d,_Rect:e,_Color:g,_Path:f}},Graphics=function(a){var b=$(a),c=$(b).get(0).getContext("2d"),d=null,e="rgb",f="origin",g={},h={background:null,fill:null,stroke:null,width:0},i={},j={font:"sans-serif",size:12,align:"left",color:Colors.decode("black"),alpha:1,baseline:"ideographic"},k=[],l=Primitives(c,h,j),m=l._Oval,n=l._Rect,o=l._Color,p=l._Path,q={init:function(){if(!c)return null;return q},size:function(a,c){!isNaN(a)&&!isNaN(c)&&b.attr({width:a,height:c});return{width:b.attr("width"),height:b.attr("height")}},clear:function(a,d,e,f){arguments.length<4&&(a=0,d=0,e=b.attr("width"),f=b.attr("height")),c.clearRect(a,d,e,f),h.background!==null&&(c.save(),c.fillStyle=Colors.encode(h.background),c.fillRect(a,d,e,f),c.restore())},background:function(a,b,c,d){if(a==null){h.background=null;return null}var e=Colors.decode(a,b,c,d);e&&(h.background=e,q.clear())},noFill:function(){h.fill=null},fill:function(a,b,d,e){if(arguments.length==0)return h.fill;if(arguments.length>0){var f=Colors.decode(a,b,d,e);h.fill=f,c.fillStyle=Colors.encode(f)}},noStroke:function(){h.stroke=null,c.strokeStyle=null},stroke:function(a,b,d,e){if(arguments.length==0&&h.stroke!==null)return h.stroke;if(arguments.length>0){var f=Colors.decode(a,b,d,e);h.stroke=f,c.strokeStyle=Colors.encode(f)}},strokeWidth:function(a){if(a===undefined)return c.lineWidth;c.lineWidth=h.width=a},Color:function(a){return new o(a)},drawStyle:function(a){if(arguments.length==0)return objcopy(h);if(arguments.length==2){var b=arguments[0],d=arguments[1];if(typeof b=="string"&&typeof d=="object"){var e={};if(d.color!==undefined){var f=Colors.decode(d.color);f&&(e.color=f)}$.each("background fill stroke width".split(" "),function(a,b){d[b]!==undefined&&(e[b]=d[b])}),$.isEmptyObject(e)||(g[b]=e)}}else arguments.length==1&&g[arguments[0]]!==undefined&&(a=g[arguments[0]]),a.width!==undefined&&(h.width=a.width),c.lineWidth=h.width,$.each("background fill stroke",function(b,c){if(a[c]!==undefined)if(a[c]===null)h[c]=null;else{var d=Colors.decode(a[c]);d&&(h[c]=d)}}),c.fillStyle=h.fill,c.strokeStyle=h.stroke},textStyle:function(a){if(arguments.length==0)return objcopy(j);if(arguments.length==2){var b=arguments[0],d=arguments[1];if(typeof b=="string"&&typeof d=="object"){var e={};if(d.color!==undefined){var f=Colors.decode(d.color);f&&(e.color=f)}$.each("font size align baseline alpha".split(" "),function(a,b){d[b]!==undefined&&(e[b]=d[b])}),$.isEmptyObject(e)||(i[b]=e)}}else{arguments.length==1&&i[arguments[0]]!==undefined&&(a=i[arguments[0]]),a.font!==undefined&&(j.font=a.font),a.size!==undefined&&(j.size=a.size),c.font=nano("{size}px {font}",j),a.align!==undefined&&(c.textAlign=j.align=a.align),a.baseline!==undefined&&(c.textBaseline=j.baseline=a.baseline),a.alpha!==undefined&&(j.alpha=a.alpha);if(a.color!==undefined){var f=Colors.decode(a.color);f&&(j.color=f)}if(j.color){var f=Colors.blend(j.color,j.alpha);f&&(c.fillStyle=f)}}},text:function(a,b,d,e){arguments.length<3||isNaN(b)?arguments.length==2&&typeof b=="object"?e=b:e=e||{}:(e=e||{},e.x=b,e.y=d);var f=objmerge(j,e);c.save(),f.align!==undefined&&(c.textAlign=f.align),f.baseline!==undefined&&(c.textBaseline=f.baseline),f.font!==undefined&&!isNaN(f.size)&&(c.font=nano("{size}px {font}",f));var g=f.alpha!==undefined?f.alpha:j.alpha,h=f.color!==undefined?f.color:j.color;c.fillStyle=Colors.blend(h,g),g>0&&c.fillText(a,Math.round(f.x),f.y),c.restore()},textWidth:function(a,b){b=objmerge(j,b||{}),c.save(),c.font=nano("{size}px {font}",b);var d=c.measureText(a).width;c.restore();return d},Rect:function(a,b,c,d,e,f){return new n(a,b,c,d,e,f)},rect:function(a,b,c,d,e,f){n.prototype._draw(a,b,c,d,e,f)},Oval:function(a,b,c,d,e){return new m(a,b,c,d,e)},oval:function(a,b,c,d,e){e=e||{},m.prototype._draw(a,b,c,d,e)},line:function(a,b,c,d,e){var f=new p(a,b,c,d);f.draw(e)},lines:function(a,b,c,d){typeof d=="number"?k.push([{x:a,y:b},{x:c,y:d}]):k.push([a,b])},drawLines:function(a){var b=new p(k);b.draw(a),k=[]}};return q.init()};arbor=typeof arbor!=="undefined"?arbor:{},$.extend(arbor,{Graphics:function(a){return Graphics(a)},colors:{CSS:Colors.CSS,validate:Colors.validate,decode:Colors.decode,encode:Colors.encode,blend:Colors.blend}})}(this.jQuery),define("lib/arbor-graphics",function(){}),function($){var trace=function(msg){if(typeof window!="undefined"&&window.console){var len=arguments.length,args=[];for(var i=0;i<len;i++)args.push("arguments["+i+"]");eval("console.log("+args.join(",")+")")}},dirname=function(a){var b=a.replace(/^\/?(.*?)\/?$/,"$1").split("/");b.pop();return"/"+b.join("/")},basename=function(a){var b=a.replace(/^\/?(.*?)\/?$/,"$1").split("/"),c=b.pop();return c==""?null:c},_ordinalize_re=/(\d)(?=(\d\d\d)+(?!\d))/g,ordinalize=function(a){var b=""+a;a<11e3?b=(""+a).replace(_ordinalize_re,"$1,"):a<1e6?b=Math.floor(a/1e3)+"k":a<1e9&&(b=(""+Math.floor(a/1e3)).replace(_ordinalize_re,"$1,")+"m");return b},nano=function(a,b){return a.replace(/\{([\w\-\.]*)}/g,function(a,c){var d=c.split("."),e=b[d.shift()];$.each(d,function(){e.hasOwnProperty(this)?e=e[this]:e=a});return e})},objcopy=function(a){if(a===undefined)return undefined;if(a===null)return null;if(a.parentNode)return a;switch(typeof a){case"string":return a.substring(0);case"number":return a+0;case"boolean":return a===!0}var b=$.isArray(a)?[]:{};$.each(a,function(a,c){b[a]=objcopy(c)});return b},objmerge=function(a,b){a=a||{},b=b||{};var c=objcopy(a);for(var d in b)c[d]=b[d];return c},objcmp=function(a,b,c){if(!a||!b)return a===b;if(typeof a!=typeof b)return!1;if(typeof a!="object")return a===b;if($.isArray(a)){if(!$.isArray(b))return!1;if(a.length!=b.length)return!1}else{var d=[];for(var e in a)a.hasOwnProperty(e)&&d.push(e);var f=[];for(var e in b)b.hasOwnProperty(e)&&f.push(e);c||(d.sort(),f.sort());if(d.join(",")!==f.join(","))return!1}var g=!0;$.each(a,function(c){var d=objcmp(a[c],b[c]);g=g&&d;if(!g)return!1});return g},objkeys=function(a){var b=[];$.each(a,function(c,d){a.hasOwnProperty(c)&&b.push(c)});return b},objcontains=function(a){if(!a||typeof a!="object")return!1;for(var b=1,c=arguments.length;b<c;b++)if(a.hasOwnProperty(arguments[b]))return!0;return!1},uniq=function(a){var b=a.length,c={};for(var d=0;d<b;d++)c[a[d]]=!0;return objkeys(c)},arbor_path=function(){var a=$("script").map(function(a){var b=$(this).attr("src");if(b)if(b.match(/arbor[^\/\.]*.js|dev.js/))return b.match(/.*\//)||"/"});return a.length>0?a[0]:null},Colors=function(){var a=/#[0-9a-f]{6}/i,b=/#(..)(..)(..)/,c=function(a){var b=a.toString(16);return b.length==2?b:"0"+b},d=function(a){return parseInt(a,16)},e=function(a){if(!a||typeof a!="object")return!1;var b=objkeys(a).sort().join("");if(b=="abgr")return!0},f={CSS:{aliceblue:"#f0f8ff",antiquewhite:"#faebd7",aqua:"#00ffff",aquamarine:"#7fffd4",azure:"#f0ffff",beige:"#f5f5dc",bisque:"#ffe4c4",black:"#000000",blanchedalmond:"#ffebcd",blue:"#0000ff",blueviolet:"#8a2be2",brown:"#a52a2a",burlywood:"#deb887",cadetblue:"#5f9ea0",chartreuse:"#7fff00",chocolate:"#d2691e",coral:"#ff7f50",cornflowerblue:"#6495ed",cornsilk:"#fff8dc",crimson:"#dc143c",cyan:"#00ffff",darkblue:"#00008b",darkcyan:"#008b8b",darkgoldenrod:"#b8860b",darkgray:"#a9a9a9",darkgrey:"#a9a9a9",darkgreen:"#006400",darkkhaki:"#bdb76b",darkmagenta:"#8b008b",darkolivegreen:"#556b2f",darkorange:"#ff8c00",darkorchid:"#9932cc",darkred:"#8b0000",darksalmon:"#e9967a",darkseagreen:"#8fbc8f",darkslateblue:"#483d8b",darkslategray:"#2f4f4f",darkslategrey:"#2f4f4f",darkturquoise:"#00ced1",darkviolet:"#9400d3",deeppink:"#ff1493",deepskyblue:"#00bfff",dimgray:"#696969",dimgrey:"#696969",dodgerblue:"#1e90ff",firebrick:"#b22222",floralwhite:"#fffaf0",forestgreen:"#228b22",fuchsia:"#ff00ff",gainsboro:"#dcdcdc",ghostwhite:"#f8f8ff",gold:"#ffd700",goldenrod:"#daa520",gray:"#808080",grey:"#808080",green:"#008000",greenyellow:"#adff2f",honeydew:"#f0fff0",hotpink:"#ff69b4",indianred:"#cd5c5c",indigo:"#4b0082",ivory:"#fffff0",khaki:"#f0e68c",lavender:"#e6e6fa",lavenderblush:"#fff0f5",lawngreen:"#7cfc00",lemonchiffon:"#fffacd",lightblue:"#add8e6",lightcoral:"#f08080",lightcyan:"#e0ffff",lightgoldenrodyellow:"#fafad2",lightgray:"#d3d3d3",lightgrey:"#d3d3d3",lightgreen:"#90ee90",lightpink:"#ffb6c1",lightsalmon:"#ffa07a",lightseagreen:"#20b2aa",lightskyblue:"#87cefa",lightslategray:"#778899",lightslategrey:"#778899",lightsteelblue:"#b0c4de",lightyellow:"#ffffe0",lime:"#00ff00",limegreen:"#32cd32",linen:"#faf0e6",magenta:"#ff00ff",maroon:"#800000",mediumaquamarine:"#66cdaa",mediumblue:"#0000cd",mediumorchid:"#ba55d3",mediumpurple:"#9370d8",mediumseagreen:"#3cb371",mediumslateblue:"#7b68ee",mediumspringgreen:"#00fa9a",mediumturquoise:"#48d1cc",mediumvioletred:"#c71585",midnightblue:"#191970",mintcream:"#f5fffa",mistyrose:"#ffe4e1",moccasin:"#ffe4b5",navajowhite:"#ffdead",navy:"#000080",oldlace:"#fdf5e6",olive:"#808000",olivedrab:"#6b8e23",orange:"#ffa500",orangered:"#ff4500",orchid:"#da70d6",palegoldenrod:"#eee8aa",palegreen:"#98fb98",paleturquoise:"#afeeee",palevioletred:"#d87093",papayawhip:"#ffefd5",peachpuff:"#ffdab9",peru:"#cd853f",pink:"#ffc0cb",plum:"#dda0dd",powderblue:"#b0e0e6",purple:"#800080",red:"#ff0000",rosybrown:"#bc8f8f",royalblue:"#4169e1",saddlebrown:"#8b4513",salmon:"#fa8072",sandybrown:"#f4a460",seagreen:"#2e8b57",seashell:"#fff5ee",sienna:"#a0522d",silver:"#c0c0c0",skyblue:"#87ceeb",slateblue:"#6a5acd",slategray:"#708090",slategrey:"#708090",snow:"#fffafa",springgreen:"#00ff7f",steelblue:"#4682b4",tan:"#d2b48c",teal:"#008080",thistle:"#d8bfd8",tomato:"#ff6347",turquoise:"#40e0d0",violet:"#ee82ee",wheat:"#f5deb3",white:"#ffffff",whitesmoke:"#f5f5f5",yellow:"#ffff00",yellowgreen:"#9acd32"},decode:function(c){var g=arguments.length;for(var h=g-1;h>=0;h--)arguments[h]===undefined&&g--;var i=arguments;if(!c)return null;if(g==1&&e(c))return c;var j=null;if(typeof c=="string"){var k=1;g==2&&(k=i[1]);var l=f.CSS[c.toLowerCase()];l!==undefined&&(c=l);var m=c.match(a);if(m){vals=c.match(b);if(!vals||!vals.length||vals.length!=4)return null;j={r:d(vals[1]),g:d(vals[2]),b:d(vals[3]),a:k}}}else typeof c=="number"&&(g<3?g>=1&&(j={r:i[0],g:i[0],b:i[0],a:1},g==2&&(j.a*=i[1])):(j={r:i[0],g:i[1],b:i[2],a:1},g>=4&&(j.a*=i[3])));return j},validate:function(b){if(!b||typeof b!="string")return!1;if(f.CSS[b.toLowerCase()]!==undefined)return!0;if(b.match(a))return!0;return!1},mix:function(a,b,c){var d=f.decode(a),e=f.decode(b)},blend:function(a,b){b=b!==undefined?Math.max(0,Math.min(1,b)):1;var c=f.decode(a);if(!c)return null;if(b==1)return a;var c=a;typeof a=="string"&&(c=f.decode(a));var d=objcopy(c);d.a*=b;return nano("rgba({r},{g},{b},{a})",d)},encode:function(a){if(!e(a)){a=f.decode(a);if(!e(a))return null}return a.a==1?nano("#{r}{g}{b}",{r:c(a.r),g:c(a.g),b:c(a.b)}):nano("rgba({r},{g},{b},{a})",a)}};return f}(),Easing=function(){var a={linear:function(a,b,c,d){return c*(a/d)+b},quadin:function(a,b,c,d){return c*(a/=d)*a+b},quadout:function(a,b,c,d){return-c*(a/=d)*(a-2)+b},quadinout:function(a,b,c,d){if((a/=d/2)<1)return c/2*a*a+b;return-c/2*(--a*(a-2)-1)+b},cubicin:function(a,b,c,d){return c*(a/=d)*a*a+b},cubicout:function(a,b,c,d){return c*((a=a/d-1)*a*a+1)+b},cubicinout:function(a,b,c,d){if((a/=d/2)<1)return c/2*a*a*a+b;return c/2*((a-=2)*a*a+2)+b},quartin:function(a,b,c,d){return c*(a/=d)*a*a*a+b},quartout:function(a,b,c,d){return-c*((a=a/d-1)*a*a*a-1)+b},quartinout:function(a,b,c,d){if((a/=d/2)<1)return c/2*a*a*a*a+b;return-c/2*((a-=2)*a*a*a-2)+b},quintin:function(a,b,c,d){return c*(a/=d)*a*a*a*a+b},quintout:function(a,b,c,d){return c*((a=a/d-1)*a*a*a*a+1)+b},quintinout:function(a,b,c,d){if((a/=d/2)<1)return c/2*a*a*a*a*a+b;return c/2*((a-=2)*a*a*a*a+2)+b},sinein:function(a,b,c,d){return-c*Math.cos(a/d*(Math.PI/2))+c+b},sineout:function(a,b,c,d){return c*Math.sin(a/d*(Math.PI/2))+b},sineinout:function(a,b,c,d){return-c/2*(Math.cos(Math.PI*a/d)-1)+b},expoin:function(a,b,c,d){return a==0?b:c*Math.pow(2,10*(a/d-1))+b},expoout:function(a,b,c,d){return a==d?b+c:c*(-Math.pow(2,-10*a/d)+1)+b},expoinout:function(a,b,c,d){if(a==0)return b;if(a==d)return b+c;if((a/=d/2)<1)return c/2*Math.pow(2,10*(a-1))+b;return c/2*(-Math.pow(2,-10*--a)+2)+b},circin:function(a,b,c,d){return-c*(Math.sqrt(1-(a/=d)*a)-1)+b},circout:function(a,b,c,d){return c*Math.sqrt(1-(a=a/d-1)*a)+b},circinout:function(a,b,c,d){if((a/=d/2)<1)return-c/2*(Math.sqrt(1-a*a)-1)+b;return c/2*(Math.sqrt(1-(a-=2)*a)+1)+b},elasticin:function(a,b,c,d){var e=1.70158,f=0,g=c;if(a==0)return b;if((a/=d)==1)return b+c;f||(f=d*.3);if(g<Math.abs(c)){g=c;var e=f/4}else var e=f/(2*Math.PI)*Math.asin(c/g);return-(g*Math.pow(2,10*(a-=1))*Math.sin((a*d-e)*(2*Math.PI)/f))+b},elasticout:function(a,b,c,d){var e=1.70158,f=0,g=c;if(a==0)return b;if((a/=d)==1)return b+c;f||(f=d*.3);if(g<Math.abs(c)){g=c;var e=f/4}else var e=f/(2*Math.PI)*Math.asin(c/g);return g*Math.pow(2,-10*a)*Math.sin((a*d-e)*(2*Math.PI)/f)+c+b},elasticinout:function(a,b,c,d){var e=1.70158,f=0,g=c;if(a==0)return b;if((a/=d/2)==2)return b+c;f||(f=d*(.3*1.5));if(g<Math.abs(c)){g=c;var e=f/4}else var e=f/(2*Math.PI)*Math.asin(c/g);if(a<1)return-.5*(g*Math.pow(2,10*(a-=1))*Math.sin((a*d-e)*(2*Math.PI)/f))+b;return g*Math.pow(2,-10*(a-=1))*Math.sin((a*d-e)*(2*Math.PI)/f)*.5+c+b},backin:function(a,b,c,d,e){e==undefined&&(e=1.70158);return c*(a/=d)*a*((e+1)*a-e)+b},backout:function(a,b,c,d,e){e==undefined&&(e=1.70158);return c*((a=a/d-1)*a*((e+1)*a+e)+1)+b},backinout:function(a,b,c,d,e){e==undefined&&(e=1.70158);if((a/=d/2)<1)return c/2*(a*a*(((e*=1.525)+1)*a-e))+b;return c/2*((a-=2)*a*(((e*=1.525)+1)*a+e)+2)+b},bouncein:function(b,c,d,e){return d-a.bounceOut(e-b,0,d,e)+c},bounceout:function(a,b,c,d){return(a/=d)<1/2.75?c*(7.5625*a*a)+b:a<2/2.75?c*(7.5625*(a-=1.5/2.75)*a+.75)+b:a<2.5/2.75?c*(7.5625*(a-=2.25/2.75)*a+.9375)+b:c*(7.5625*(a-=2.625/2.75)*a+.984375)+b},bounceinout:function(b,c,d,e){if(b<e/2)return a.bounceIn(b*2,0,d,e)*.5+c;return a.bounceOut(b*2-e,0,d,e)*.5+d*.5+c}};return a}(),Tween=function(){var a={},b=!0,c={init:function(){return c},busy:function(){var b=!1;for(var c in a){b=!0;break}return b},to:function(c,d,e){var f=(new Date).valueOf(),g={},h={from:{},to:{},colors:{},node:c,t0:f,t1:f+d*1e3,dur:d*1e3},i="linear";for(var j in e){if(j=="easing"){var k=e[j].toLowerCase();k in Easing&&(i=k);continue}if(j=="delay"){var l=(e[j]||0)*1e3;h.t0+=l,h.t1+=l;continue}Colors.validate(e[j])?(h.colors[j]=[Colors.decode(c.data[j]),Colors.decode(e[j]),e[j]],g[j]=!0):(h.from[j]=c.data[j]!=undefined?c.data[j]:e[j],h.to[j]=e[j],g[j]=!0)}h.ease=Easing[i],a[c._id]===undefined&&(a[c._id]=[]),a[c._id].push(h);if(a.length>1)for(var m=a.length-2;m>=0;m++){var n=a[m];for(var j in n.to)j in g?delete n.to[j]:g[j]=!0;for(var j in n.colors)j in g?delete n.colors[j]:g[j]=!0;$.isEmptyObject(n.colors)&&$.isEmptyObject(n.to)&&a.splice(m,1)}b=!1},interpolate:function(a,b,c,d){d=(d||"").toLowerCase();var e=Easing.linear;d in Easing&&(e=Easing[d]);var f=e(a,0,1,1);if(Colors.validate(b)&&Colors.validate(c))return lerpRGB(f,b,c);if(!isNaN(b))return lerpNumber(f,b,c);if(typeof b=="string")return f<.5?b:c},tick:function(){var c=!0;for(var d in a){c=!1;break}if(!c){var e=(new Date).valueOf();$.each(a,function(b,c){var d=!1;$.each(c,function(a,b){var c=b.ease(e-b.t0,0,1,b.dur);c=Math.min(1,c);var f=b.from,h=b.to,i=b.colors,j=b.node.data,k=c==1;for(var l in h)switch(typeof h[l]){case"number":j[l]=lerpNumber(c,f[l],h[l]),l=="alpha"&&(j[l]=Math.max(0,Math.min(1,j[l])));break;case"string":k&&(j[l]=h[l])}for(var l in i)if(k)j[l]=i[l][2];else{var m=lerpRGB(c,i[l][0],i[l][1]);j[l]=Colors.encode(m)}k&&(b.completed=!0,d=!0)}),d&&(a[b]=$.map(c,function(a){if(!a.completed)return a}),a[b].length==0&&delete a[b])}),b=$.isEmptyObject(a);return b}}};return c.init()},lerpNumber=function(a,b,c){return b+a*(c-b)},lerpRGB=function(a,b,c){a=Math.max(Math.min(a,1),0);var d={};$.each("rgba".split(""),function(e,f){d[f]=Math.round(b[f]+a*(c[f]-b[f]))});return d};arbor=typeof arbor!=="undefined"?arbor:{},$.extend(arbor,{Tween:Tween,colors:{CSS:Colors.CSS,validate:Colors.validate,decode:Colors.decode,encode:Colors.encode,blend:Colors.blend}})}(this.jQuery),define("lib/arbor-tween",function(){}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/visualization/Renderer",["order!lib/jquery","order!lib/arbor","order!lib/arbor-graphics","order!lib/arbor-tween","order!lib/backbone"],function(){var b;return b=function(){function b(b,c,d){this.nodeStyler=c,this.relationshipStyler=d,this.intersect_line_box=a(this.intersect_line_box,this),this.intersect_line_line=a(this.intersect_line_line,this),this.thesePointsAreReallyClose=a(this.thesePointsAreReallyClose,this),this.ghostify=a(this.ghostify,this),this.nodeDropped=a(this.nodeDropped,this),this.nodeDragged=a(this.nodeDragged,this),this.clicked=a(this.clicked,this),this.initMouseHandling=a(this.initMouseHandling,this),this.renderEdge=a(this.renderEdge,this),this.renderNode=a(this.renderNode,this),this.redraw=a(this.redraw,this),this.init=a(this.init,this),this.canvas=$(b).get(0),this.ctx=this.canvas.getContext("2d"),this.gfx=arbor.Graphics(this.canvas),_.extend(this,Backbone.Events)}b.prototype.init=function(a){this.particleSystem=a,this.particleSystem.screenSize(this.canvas.width,this.canvas.height),this.particleSystem.screenStep(0),this.particleSystem.screenPadding(40);return this.initMouseHandling()},b.prototype.redraw=function(){if(this.particleSystem){this.gfx.clear(),this.nodeBoxes={},this.particleSystem.eachNode(this.renderNode),this.particleSystem.eachEdge(this.renderEdge);return this.nodeBoxes={}}},b.prototype.renderNode=function(a,b){var c,d,e;d=this.nodeStyler.getStyleFor(a),c=d.labelText,e=this.ctx.measureText(""+c).width+10,(""+c).match(/^[ \t]*$/)?c=null:(b.x=Math.floor(b.x),b.y=Math.floor(b.y)),d.nodeStyle.shape==="dot"?(this.gfx.oval(b.x-e/2,b.y-e/2,e,e,d.nodeStyle),this.nodeBoxes[a.name]=[b.x-e/2,b.y-e/2,e,e]):(this.gfx.rect(b.x-e/2,b.y-10,e,20,4,d.nodeStyle),this.nodeBoxes[a.name]=[b.x-e/2,b.y-11,e,22]);if(c){this.ctx.font=d.labelStyle.font,this.ctx.textAlign="center",this.ctx.fillStyle=d.labelStyle.color;return this.ctx.fillText(c||"",b.x,b.y+4)}},b.prototype.renderEdge=function(a,b,c){var d,e,f,g,h,i,j;if(this.stopped!==!0){h=this.relationshipStyler.getStyleFor(a),i=this.intersect_line_box(b,c,this.nodeBoxes[a.source.name]);if(i===!1)return;g=this.intersect_line_box(i,c,this.nodeBoxes[a.target.name]);if(g===!1)return;this.ctx.save(),this.ctx.beginPath(),this.ctx.lineWidth=h.edgeStyle.width,this.ctx.strokeStyle=h.edgeStyle.color,this.ctx.fillStyle="rgba(0, 0, 0, 0)",this.ctx.moveTo(i.x,i.y),this.ctx.lineTo(g.x,g.y),this.ctx.stroke(),this.ctx.restore(),a.data.directed&&(this.ctx.save(),j=h.edgeStyle.width,d=6+j,e=2+j,this.ctx.fillStyle=h.edgeStyle.color,this.ctx.translate(g.x,g.y),this.ctx.rotate(Math.atan2(g.y-i.y,g.x-i.x)),this.ctx.clearRect(-d/2,-j/2,d/2,j),this.ctx.beginPath(),this.ctx.moveTo(-d,e),this.ctx.lineTo(0,0),this.ctx.lineTo(-d,-e),this.ctx.lineTo(-d*.8,-0),this.ctx.closePath(),this.ctx.fill(),this.ctx.restore());if(h.labelText){this.ctx.save(),this.ctx.font=h.labelStyle.font,this.ctx.translate(g.x,g.y),f=g.x-i.x,f<0?(this.ctx.textAlign="left",this.ctx.rotate(Math.atan2(g.y-i.y,f)-Math.PI),this.ctx.translate(20,h.edgeStyle.width-5)):(this.ctx.textAlign="right",this.ctx.rotate(Math.atan2(g.y-i.y,f)),this.ctx.translate(-20,h.edgeStyle.width-5)),this.ctx.fillStyle=h.labelStyle.color,this.ctx.fillText(h.labelText||"",0,0);return this.ctx.restore()}}},b.prototype.initMouseHandling=function(){this.selected=null,this.nearest=null,this.dragged=null;return $(this.canvas).mousedown(this.clicked)},b.prototype.start=function(){return this.stopped=!1},b.prototype.stop=function(){return this.stopped=!0},b.prototype.clicked=function(a){var b,c;c=$(this.canvas).offset(),this.dragStart={x:a.pageX,y:a.pageY},b=arbor.Point(a.pageX-c.left,a.pageY-c.top),this.selected=this.nearest=this.dragged=this.particleSystem.nearest(b),this.dragged.node!=null&&(this.dragged.node.fixed=!0),$(this.canvas).bind("mousemove",this.nodeDragged),$(window).bind("mouseup",this.nodeDropped);return!1},b.prototype.nodeDragged=function(a){var b,c,d,e;b=this.nearest&&this.nearest.node._id,d=$(this.canvas).offset(),e=arbor.Point(a.pageX-d.left,a.pageY-d.top),this.ghostify(this.dragged.node);if(this.nearest){this.dragged!==null&&this.dragged.node!==null&&(c=this.particleSystem.fromScreen(e),this.dragged.node.p=c);return!1}},b.prototype.nodeDropped=function(a){if(this.dragged!==null&&this.dragged.node!==void 0){this.dragged.node!==null&&(this.dragged.node.fixed=this.dragged.node.data.fixated),this.dragged.node.fixed=!0,this.dragged.node.mass=1,this.dragged.node!==null&&this.thesePointsAreReallyClose(this.dragStart,{x:a.pageX,y:a.pageY})&&this.trigger("node:click",this.dragged.node),this.particleSystem.start(),this.dragged=null,this.selected=null,$(this.canvas).unbind("mousemove",this.nodeDragged),$(window).unbind("mouseup",this.nodeDropped);return!1}},b.prototype.ghostify=function(a){return a.fixed=!0},b.prototype.thesePointsAreReallyClose=function(a,b){return Math.abs(a.x-b.x)<5&&Math.abs(a.y-b.y)<5},b.prototype.intersect_line_line=function(a,b,c,d){var e,f,g;e=(d.y-c.y)*(b.x-a.x)-(d.x-c.x)*(b.y-a.y);if(e===0)return!1;f=((d.x-c.x)*(a.y-c.y)-(d.y-c.y)*(a.x-c.x))/e,g=((b.x-a.x)*(a.y-c.y)-(b.y-a.y)*(a.x-c.x))/e;return f<0||f>1||g<0||g>1?!1:arbor.Point(a.x+f*(b.x-a.x),a.y+f*(b.y-a.y))},b.prototype.intersect_line_box=function(a,b,c){var d,e,f,g,h,i,j;g={x:c[0],y:c[1]},j=c[2],f=c[3],h={x:g.x,y:g.y},i={x:g.x+j,y:g.y},d={x:g.x,y:g.y+f},e={x:g.x+j,y:g.y+f};return this.intersect_line_line(a,b,h,i)||this.intersect_line_line(a,b,i,e)||this.intersect_line_line(a,b,e,d)||this.intersect_line_line(a,b,d,h)||!1};return b}()})}.call(this),function(){define("neo4j/webadmin/visualization/NodeStyler",["neo4j/webadmin/data/ItemUrlResolver"],function(a){var b;return b=function(){function b(){this.labelProperties=[],this.itemUrlUtils=new a}b.prototype.defaultExploredStyle={nodeStyle:{fill:"#000000",alpha:.9},labelStyle:{color:"white",font:"12px Helvetica"}},b.prototype.defaultUnexploredStyle={nodeStyle:{fill:"#000000",alpha:.2},labelStyle:{color:"rgba(255, 255, 255, 0.4)",font:"12px Helvetica"}},b.prototype.defaultGroupStyle={nodeStyle:{shape:"dot",fill:"#000000",alpha:.8},labelStyle:{color:"white",font:"10px Helvetica"}},b.prototype.getStyleFor=function(a){var b,c,d,e,f,g,h,i,j,k;h=a.data.type;if(h==="group")f=this.defaultGroupStyle.nodeStyle,c=this.defaultGroupStyle.labelStyle,d=a.data.group.nodeCount;else{if(a.data.neoNode!=null){e=a.data.neoNode,b=this.itemUrlUtils.extractNodeId(e.getSelf()),k=this.labelProperties;for(i=0,j=k.length;i<j;i++){g=k[i];if(e.hasProperty(g)){d=b+": "+e.getProperty(g);break}}d!=null?d:d=b}else d="?";h==="explored"?(f=this.defaultExploredStyle.nodeStyle,c=this.defaultExploredStyle.labelStyle):(f=this.defaultUnexploredStyle.nodeStyle,c=this.defaultUnexploredStyle.labelStyle)}return{nodeStyle:f,labelStyle:c,labelText:d}},b.prototype.setLabelProperties=function(a){return this.labelProperties=a};return b}()})}.call(this),function(){define("neo4j/webadmin/visualization/RelationshipStyler",[],function(){var a;return a=function(){function a(){}a.prototype.defaultBetweenExploredStyle={edgeStyle:{color:"rgba(0, 0, 0, 1)",width:1},labelStyle:{color:"rgba(0, 0, 0, 1)",font:"10px Helvetica"}},a.prototype.defaultToUnknownStyle={edgeStyle:{color:"rgba(0, 0, 0, 0.2)",width:1},labelStyle:{color:"rgba(0, 0, 0, 0.4)",font:"10px Helvetica"}},a.prototype.defaultToGroupStyle={edgeStyle:{color:"rgba(0, 0, 0, 0.8)",width:1},labelStyle:{color:"rgba(0, 0, 0, 0.8)",font:"10px Helvetica"}},a.prototype.getStyleFor=function(a){var b,c,d,e,f,g;e=a.source.data.type,b=a.target.data.type,a.target.data.relType!==null&&(f=function(){var b,c;b=a.data.relationships,c=[];for(g in b)d=b[g],c.push(d.getType());return c}(),f=_.uniq(f),c=f.join(", "));if(e==="explored"&&b==="explored")return{edgeStyle:this.defaultBetweenExploredStyle.edgeStyle,labelStyle:this.defaultBetweenExploredStyle.labelStyle,labelText:c};if(e==="unexplored"||b==="unexplored")return{edgeStyle:this.defaultToUnknownStyle.edgeStyle,labelStyle:this.defaultToUnknownStyle.labelStyle,labelText:c};return{edgeStyle:this.defaultToGroupStyle.edgeStyle,labelStyle:this.defaultToGroupStyle.labelStyle,labelText:a.data.relType}};return a}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/visualization/VisualDataModel",[],function(){var b;return b=function(){function b(b){this.groupingThreshold=b!=null?b:5,this.addNode=a(this.addNode,this),this.clear()}b.prototype.clear=function(){this.groupCount=0,this.visualGraph={nodes:{},edges:{}};return this.data={relationships:{},nodes:{},groups:{}}},b.prototype.getVisualGraph=function(){return this.visualGraph},b.prototype.addNode=function(a,b,c){var d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y;this.ungroup([a]),this.ungroup(c),(v=(l=this.data.nodes)[s=a.getSelf()])!=null?v:l[s]={node:a,groups:{}},this.visualGraph.nodes[a.getSelf()]={neoNode:a,type:"explored"};for(o=0,q=c.length;o<q;o++)j=c[o],(w=(m=this.data.nodes)[t=j.getSelf()])!=null?w:m[t]={node:j,groups:{}};h={incoming:{},outgoing:{}};for(p=0,r=b.length;p<r;p++){i=b[p];if(this.data.relationships[i.getSelf()]!=null)continue;this.data.relationships[i.getSelf()]=i,g=i.getOtherNodeUrl(a.getSelf()),d=i.isStartNode(a.getSelf())?"outgoing":"incoming",this.visualGraph.nodes[g]==null?((x=(n=h[d])[u=i.getType()])!=null?x:n[u]={relationships:[]},h[d][i.getType()].relationships.push(i)):this._addRelationship(i.getStartNodeUrl(),i.getEndNodeUrl(),i)}y=[];for(d in h)f=h[d],y.push(function(){var b;b=[];for(k in f)e=f[k],b.push(function(){var b,c,f,g;if(e.relationships.length<this.groupingThreshold){f=e.relationships,g=[];for(b=0,c=f.length;b<c;b++)i=f[b],g.push(this._addUnexploredNode(a,i));return g}return this._addGroup(a,e.relationships,d)}.call(this));return b}.call(this));return y},b.prototype.ungroup=function(a){var b,c,d,e,f,g,h,i,j,k;k=[];for(i=0,j=a.length;i<j;i++)f=a[i],g=f.getSelf(),k.push(function(){var a,f,i,j,k;if(this.data.nodes[g]!=null){e=this.data.nodes[g],i=e.groups,k=[];for(d in i){c=i[d],b=c.group,b.nodeCount--,delete b.grouped[g],j=c.relationships;for(a=0,f=j.length;a<f;a++)h=j[a],this._addUnexploredNode(b.baseNode,h);k.push(b.nodeCount<=0?this._removeGroup(b):void 0)}return k}}.call(this));return k},b.prototype.unexplore=function(a){var b,c,d,e,f;b=a.getSelf();if(!this._isLastExploredNode(a))if(this.visualGraph.nodes[b]!=null){f=this.visualGraph.nodes[b],f.type="unexplored",a.fixed=!1,c=this._getUnexploredNodesRelatedTo(b);for(e in c)d=c[e],this._hasExploredRelationships(e,b)||this.removeNode(d.node);this._removeGroupsFor(a);if(!this._hasExploredRelationships(b))return this.removeNode(a)}},b.prototype.removeNode=function(a){var b;b=a.getSelf(),delete this.visualGraph.nodes[b],delete this.data.nodes[b];return this._removeRelationshipsFor(a)},b.prototype._isLastExploredNode=function(a){var b,c,d,e;b=a.getSelf(),e=this.visualGraph.nodes;for(c in e){d=e[c];if(d.type==="explored"&&c!==b)return!1}return!0},b.prototype._getUnexploredNodesRelatedTo=function(a){var b,c,d,e,f,g;b=[],g=this.visualGraph.edges;for(c in g){e=g[c];for(f in e)d=e[f],c===a&&(this.visualGraph.nodes[f].type!=null&&this.visualGraph.nodes[f].type==="unexplored"&&(b[f]=this.data.nodes[f])),f===a&&(this.visualGraph.nodes[c].type!=null&&this.visualGraph.nodes[c].type==="unexplored"&&(b[c]=this.data.nodes[c]))}return b},b.prototype._hasExploredRelationships=function(a,b){var c,d,e,f,g;b==null&&(b=""),g=this.visualGraph.edges;for(c in g){e=g[c];for(f in e){d=e[f];if(c===a)if(f!==b&&this.visualGraph.nodes[f].type==="explored")return!0;if(f===a)if(c!==b&&this.visualGraph.nodes[c].type==="explored")return!0}}return!1},b.prototype._addRelationship=function(a,b,c,d){var e,f,g,h;d==null&&(d=null),(g=(e=this.visualGraph.edges)[a])!=null?g:e[a]={},(h=(f=this.visualGraph.edges[a])[b])!=null?h:f[b]={length:.5,relationships:{},directed:!0,relType:d};if(c!==!1)return this.visualGraph.edges[a][b].relationships[c.getSelf()]=c},b.prototype._addUnexploredNode=function(a,b){var c,d,e;c=b.getOtherNodeUrl(a.getSelf()),(e=(d=this.visualGraph.nodes)[c])!=null?e:d[c]={neoNode:this.data.nodes[c].node,type:"unexplored"};return this._addRelationship(b.getStartNodeUrl(),b.getEndNodeUrl(),b)},b.prototype._addGroup=function(a,b,c){var d,e,f,g,h,i,j,k,l,m,n,o;d=a.getSelf(),i=0,f={};for(n=0,o=b.length;n<o;n++){l=b[n],k=l.getOtherNodeUrl(d);if(this.data.nodes[k]==null)continue;j=this.data.nodes[k],f[k]==null&&(f[k]={node:j.node,relationships:[]},i++),f[k].relationships.push(l)}g="group-"+this.groupCount++,e=this.data.groups[g]={key:g,baseNode:a,grouped:f,nodeCount:i},this.visualGraph.nodes[g]={key:g,type:"group",group:e};for(m in f)h=f[m],this.data.nodes[m].groups[g]={group:e,relationships:h.relationships};return c==="outgoing"?this._addRelationship(a.getSelf(),g,!1,b[0].getType()):this._addRelationship(g,a.getSelf(),!1,b[0].getType())},b.prototype._removeRelationshipsFor=function(a){var b,c,d,e,f,g,h,i,j;c=a.getSelf(),i=this.visualGraph.edges;for(b in i){f=i[b];for(g in f){e=f[g];if(g===c||b===c){j=this.visualGraph.edges[b][g].relationships;for(h in j)d=j[h],delete this.data.relationships[d.getSelf()]}g===c&&delete this.visualGraph.edges[b][g]}}if(this.visualGraph.edges[c]!=null)return delete this.visualGraph.edges[c]},b.prototype._removeRelationshipsInGroup=function(a){var b,c,d,e,f,g;f=a.grouped,g=[];for(e in f)b=f[e],c=this.data.nodes[e],c.groups[a.key]!=null&&delete c.groups[a.key],g.push(function(){var a,c,e,f;e=b.relationships,f=[];for(a=0,c=e.length;a<c;a++)d=e[a],f.push(delete this.data.relationships[d.getSelf()]);return f}.call(this));return g},b.prototype._removeGroup=function(a){delete this.visualGraph.nodes[a.key],delete this.data.groups[a.key];if(this.visualGraph.edges[a.key]!=null)return delete this.visualGraph.edges[a.key];if(this.visualGraph.edges[a.baseNode.getSelf()]!=null&&this.visualGraph.edges[a.baseNode.getSelf()][a.key]!=null)return delete this.visualGraph.edges[a.baseNode.getSelf()][a.key]},b.prototype._removeGroupsFor=function(a){var b,c,d,e,f;d=a.getSelf(),e=this.data.groups,f=[];for(c in e)b=e[c],f.push(b.baseNode.getSelf()===d?(this._removeRelationshipsInGroup(b),this._removeGroup(b)):void 0);return f};return b}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/ui/Overlay",["lib/backbone","lib/jquery"],function(){var b,c,d;d=$("<div class='overlay'></div>"),c=!1;return b=function(){function b(b){b==null&&(b={}),this.hide=a(this.hide,this),this.show=a(this.show,this),this.el=d}b.prototype.show=function(a,b,d){c||(this.el.appendTo("body"),c=!0);return this.el.show()},b.prototype.hide=function(){return this.el.hide()};return b}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/Dialog",["neo4j/webadmin/ui/Overlay","neo4j/webadmin/views/View","lib/backbone"],function(b,d){var e;return e=function(){function e(){this.attach=a(this.attach,this),this.detach=a(this.detach,this),this.remove=a(this.remove,this),this.hide=a(this.hide,this),this.wrapperClicked=a(this.wrapperClicked,this),this.show=a(this.show,this),e.__super__.constructor.apply(this,arguments)}c(e,d),e.prototype.className="dialog",e.prototype.initialize=function(){this.wrapper=$("<div class='dialog-wrap'></div>"),this.wrapper.append(this.el),this.attachedToBody=!1;return this.overlay=new b},e.prototype.show=function(a){a==null&&(a=!1),this.overlay.show(),this.bind(),this.attachedToBody||$("body").append(this.wrapper),this.render(),this.wrapper.show();if(a)return setTimeout(this.hide,a)},e.prototype.bind=function(){return this.wrapper.bind("click",this.wrapperClicked)},e.prototype.unbind=function(){return this.wrapper.unbind("click",this.wrapperClicked)},e.prototype.wrapperClicked=function(a){if(a.originalTarget===a.currentTarget)return this.hide()},e.prototype.hide=function(){this.unbind(),this.wrapper.hide();return this.overlay.hide()},e.prototype.remove=function(){this.unbind(),this.wrapper.remove();return this.overlay.hide()},e.prototype.detach=function(){return this.wrapper.detach()},e.prototype.attach=function(a){return $(a).append(this.wrapper)};return e}()})}.call(this),define("neo4j/webadmin/templates/filterList",["require","exports","module"],function(){return function(vars){with(vars||{})return'<p><input type="text" value="'+filter+'" class="filterText" /></p><p class="selectWrap"></p>'}}),define("neo4j/webadmin/templates/filterListSelect",["require","exports","module"],function(){return function(vars){with(vars||{})return'<select multiple="multiple" class="selectList">'+function(){var a=[],b,c;for(b in items)items.hasOwnProperty(b)&&(c=items[b],a.push('<option value="'+c.key+'">'+c.label+"</option>"));return a.join("")}.call(this)+"</select>"}}),function(){var a=Object.prototype.hasOwnProperty,b=function(b,c){function e(){this.constructor=b}for(var d in c)a.call(c,d)&&(b[d]=c[d]);e.prototype=c.prototype,b.prototype=new e,b.__super__=c.prototype;return b};define("neo4j/webadmin/views/FilterList",["neo4j/webadmin/views/View","neo4j/webadmin/templates/filterList","neo4j/webadmin/templates/filterListSelect","lib/backbone"],function(a,c,d){var e,f;e="Search available nodes";return f=function(){function f(){f.__super__.constructor.apply(this,arguments)}b(f,a),f.prototype.events={"keyup .filterText":"filterKeyUp","change .filterText":"filterChanged","focus .filterText":"filterFocused","blur .filterText":"filterUnfocused"},f.prototype.initialize=function(a){var b,c,d;this.items=this.filteredItems=a,this.filter="",this.keyMap={};for(c=0,d=a.length;c<d;c++)b=a[c],this.keyMap[b.key]=b;return f.__super__.initialize.call(this)},f.prototype.render=function(){$(this.el).html(c({filter:this.filter})),this.renderListSelector();return $(".filterText",this.el).focus()},f.prototype.height=function(a){return a!=null?$(".selectList",this.el).height(a-50):f.__super__.height.call(this)},f.prototype.renderListSelector=function(){return $(".selectWrap",this.el).html(d({items:this.filteredItems}))},f.prototype.filterKeyUp=function(a){if($(a.target).val().toLowerCase()!==this.filter)return this.filterChanged(a)},f.prototype.filterFocused=function(a){if($(a.target).val()===e)return $(a.target).val("")},f.prototype.filterUnfocused=function(a){if($(a.target).val().length===0)return $(a.target).val(e)},f.prototype.filterChanged=function(a){var b,c,d,f;this.filter=$(a.target).val().toLowerCase();if(this.filter.length===0||this.filter===e.toLowerCase())this.filteredItems=this.items;else{this.filteredItems=[],f=this.items;for(c=0,d=f.length;c<d;c++)b=f[c],b.label.toLowerCase().indexOf(this.filter)!==-1&&this.filteredItems.push(b)}return this.renderListSelector()},f.prototype.getFilteredItems=function(){var a,b,c,d,e;b=$(".selectList",this.el).val();if(b!==null){e=[];for(c=0,d=b.length;c<d;c++)a=b[c],e.push(this.keyMap[a]);return e}return[]};return f}()})}.call(this),define("neo4j/webadmin/templates/nodeFilterDialog",["require","exports","module"],function(){return function(vars){with(vars||{})return'<h1>Choose nodes</h1><div class="filter"></div><ul class="button-bar"><li><button class="complete button">Select</button></li><li><button class="selectAll button">Select all</button></li><li><button class="cancel button bad-button">Select none</button></li></ul>'}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/NodeFilterDialog",["neo4j/webadmin/data/ItemUrlResolver","neo4j/webadmin/views/Dialog","neo4j/webadmin/views/FilterList","neo4j/webadmin/templates/nodeFilterDialog","lib/backbone"],function(b,d,e,f){var g;return g=function(){function g(){this.complete=a(this.complete,this),this.wrapperClicked=a(this.wrapperClicked,this),g.__super__.constructor.apply(this,arguments)}c(g,d),g.prototype.events={"click .complete":"complete","click .selectAll":"selectAll","click .cancel":"cancel"},g.prototype.initialize=function(a){var c,d,f,h,i,j;this.completeCallback=a.completeCallback,this.urlResolver=new b,i=a.labelProperties||[],this.nodes=a.nodes,c=function(){var a,b,c,e,g,k;g=this.nodes,k=[];for(a=0,c=g.length;a<c;a++){j=g[a],d=this.urlResolver.extractNodeId(j.getSelf()),f=d;for(b=0,e=i.length;b<e;b++)h=i[b],j.hasProperty(h)&&(f=""+d+": "+JSON.stringify(j.getProperty(h)));k.push({node:j,key:j.getSelf(),label:f})}return k}.call(this),this.filterList=new e(c);return g.__super__.initialize.call(this)},g.prototype.render=function(){var a;$(this.el).html(f()),this.filterList.attach($(".filter",this.el)),this.filterList.render(),a=$(this.el).height();return this.filterList.height(a-80)},g.prototype.wrapperClicked=function(a){if(a.originalTarget===a.currentTarget)return this.cancel()},g.prototype.complete=function(){var a,b;b=function(){var b,c,d,e;d=this.filterList.getFilteredItems(),e=[];for(b=0,c=d.length;b<c;b++)a=d[b],e.push(a.node);return e}.call(this);return this.completeCallback(b,this)},g.prototype.selectAll=function(){return this.completeCallback(this.nodes,this)},g.prototype.cancel=function(){return this.completeCallback([],this)};return g}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/visualization/VisualGraph",["neo4j/webadmin/visualization/Renderer","neo4j/webadmin/visualization/NodeStyler","neo4j/webadmin/visualization/RelationshipStyler","neo4j/webadmin/visualization/VisualDataModel","neo4j/webadmin/views/NodeFilterDialog","order!lib/jquery","order!lib/arbor","order!lib/arbor-graphics","order!lib/arbor-tween"],function(b,c,d,e,f){var g;return g=function(){function g(f,g,h,i){this.server=f,g==null&&(g=800),h==null&&(h=400),this.groupingThreshold=i!=null?i:10,this.detach=a(this.detach,this),this.attach=a(this.attach,this),this.start=a(this.start,this),this.stop=a(this.stop,this),this.floatNode=a(this.floatNode,this),this.reflow=a(this.reflow,this),this.getNodeStyler=a(this.getNodeStyler,this),this.nodeClicked=a(this.nodeClicked,this),this.addNodes=a(this.addNodes,this),this.addNode=a(this.addNode,this),this.setNodes=a(this.setNodes,this),this.setNode=a(this.setNode,this),this.steadyStateCheck=a(this.steadyStateCheck,this),this.el=$("<canvas width='"+g+"' height='"+h+"'></canvas>"),this.labelProperties=[],this.nodeStyler=new c,this.relationshipStyler=new d,this.dataModel=new e,this.sys=arbor.ParticleSystem(),this.sys.parameters({repulsion:10,stiffness:100,friction:.5,gravity:!0,fps:30,dt:.015,precision:.5}),this.stop(),this.sys.renderer=new b(this.el,this.nodeStyler,this.relationshipStyler),this.sys.renderer.bind("node:click",this.nodeClicked),this.sys.screenPadding(20),this.steadStateWorker=setInterval(this.steadyStateCheck,1e3)}g.prototype.steadyStateCheck=function(){var a,b;a=this.sys.energy();if(a!=null){b=a.mean;if(b<.01)return this.sys.stop()}},g.prototype.setNode=function(a){return this.setNodes([a])},g.prototype.setNodes=function(a){this.dataModel.clear();return this.addNodes(a)},g.prototype.addNode=function(a){return this.addNodes([a])},g.prototype.addNodes=function(b){var c,d,e,f,g;c=b.length,this.sys.stop(),g=[];for(e=0,f=b.length;e<f;e++)d=b[e],g.push(a(function(d){var e,f;e=d.getRelationships(),f=d.traverse({});return neo4j.Promise.join(e,f).then(a(function(a){var e;e=a[0],b=a[1],this.dataModel.addNode(d,e,b);if(--c===0){this.sys.merge(this.dataModel.getVisualGraph());return this.sys.start()}},this))},this)(d));return g},g.prototype.nodeClicked=function(b){var c,d,e,g,h;if(b.data.type!=null)switch(b.data.type){case"unexplored":return this.addNode(b.data.neoNode);case"explored":this.dataModel.unexplore(b.data.neoNode);return this.sys.merge(this.dataModel.getVisualGraph());case"group":g=function(){var a,c;a=b.data.group.grouped,c=[];for(h in a)e=a[h],c.push(e.node);return c}(),c=a(function(a,b){b.remove(),this.dataModel.ungroup(a);return this.sys.merge(this.dataModel.getVisualGraph())},this),d=new f({nodes:g,completeCallback:c,labelProperties:this.labelProperties});return d.show()}},g.prototype.setLabelProperties=function(a){this.nodeStyler.setLabelProperties(a);return this.labelProperties=a},g.prototype.getNodeStyler=function(){return this.nodeStyler},g.prototype.reflow=function(){this.sys.eachNode(this.floatNode),this.sys.parameters({gravity:!0});return this.start()},g.prototype.floatNode=function(a,b){return a.fixed=!1},g.prototype.stop=function(){this.sys.renderer!=null&&this.sys.renderer.stop(),this.sys.parameters({gravity:!1});return this.sys.stop()},g.prototype.start=function(){this.sys.renderer!=null&&this.sys.renderer.start();return this.sys.start()},g.prototype.attach=function(a){this.detach(),$(a).prepend(this.el);return this.start()},g.prototype.detach=function(){this.stop();return this.el.detach()};return g}()})}.call(this),define("neo4j/webadmin/templates/databrowser/visualizationSettings",["require","exports","module"],function(){return function(vars){with(vars||{})return'<p><label for="create-relationship-from">Label keys</label><input type="text" value="'+labels+'" id="visualization-label-properties" /><div class="helpbox break">Comma separated list of property keys to use for labeling nodes, in priority order.</div></p><ul class="button-bar popout-controls"><li><button class="button" id="save-visualization-settings">Done</button></li></ul>'}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/databrowser/VisualizationSettingsDialog",["neo4j/webadmin/data/ItemUrlResolver","neo4j/webadmin/templates/databrowser/visualizationSettings","neo4j/webadmin/views/View","lib/backbone"],function(b,d,e){var f;return f=function(){function b(){this.render=a(this.render,this),this.position=a(this.position,this),this.save=a(this.save,this),this.initialize=a(this.initialize,this),b.__super__.constructor.apply(this,arguments)}c(b,e),b.prototype.className="popout",b.prototype.events={"click #save-visualization-settings":"save"},b.prototype.initialize=function(a){$("body").append(this.el),this.baseElement=a.baseElement,this.closeCallback=a.closeCallback,this.settings=a.appState.getVisualizationSettings(),this.position();return this.render()},b.prototype.save=function(){var a;a=$("#visualization-label-properties").val().split(","),this.settings.setLabelProperties(a),this.settings.save();return this.closeCallback()},b.prototype.position=function(){var a,b,c;a=$(this.baseElement).offset(),c=a.top+$(this.baseElement).outerHeight(),b=a.left-($(this.el).outerWidth()-$(this.baseElement).outerWidth());return $(this.el).css({position:"absolute",top:c+"px",left:b+"px"})},b.prototype.render=function(){$(this.el).html(d({labels:this.settings.getLabelProperties().join(",")}));return this};return b}()})}.call(this),define("neo4j/webadmin/templates/databrowser/visualization",["require","exports","module"],function(){return function(vars){with(vars||{})return'<div id="visualization"><ul class="button-bar item-controls"><li><button title="Visualization settings" class="text-icon-button" id="visualization-show-settings">Visualization settings</button></li><li><button title="Re-animate graph layout" class="icon-button" id="visualization-reflow"></button></li></ul></div><div class="break"></div>'}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/databrowser/VisualizedView",["neo4j/webadmin/visualization/VisualGraph","neo4j/webadmin/data/ItemUrlResolver","neo4j/webadmin/views/databrowser/VisualizationSettingsDialog","neo4j/webadmin/views/View","neo4j/webadmin/security/HtmlEscaper","neo4j/webadmin/templates/databrowser/visualization","lib/backbone"],function(b,d,e,f,g,h){var i;return i=function(){function d(){this.attach=a(this.attach,this),this.detach=a(this.detach,this),this.remove=a(this.remove,this),this.reflowGraphLayout=a(this.reflowGraphLayout,this),this.hideSettingsDialog=a(this.hideSettingsDialog,this),this.showSettingsDialog=a(this.showSettingsDialog,this),this.getViz=a(this.getViz,this),this.settingsChanged=a(this.settingsChanged,this),this.render=a(this.render,this),d.__super__.constructor.apply(this,arguments)}c(d,f),d.prototype.events={"click #visualization-show-settings":"showSettingsDialog","click #visualization-reflow":"reflowGraphLayout"},d.prototype.initialize=function(a){this.server=a.server,this.appState=a.appState,this.dataModel=a.dataModel,this.settings=this.appState.getVisualizationSettings();return this.settings.bind("change",this.settingsChanged)},d.prototype.render=function(){if(this.browserHasRequiredFeatures()){this.vizEl!=null&&this.getViz().detach(),$(this.el).html(h()),this.vizEl=$("#visualization",this.el),this.getViz().attach(this.vizEl);switch(this.dataModel.get("type")){case"node":this.visualizeFromNode(this.dataModel.getData().getItem());break;case"relationship":this.visualizeFromRelationships([this.dataModel.getData().getItem()]);break;case"relationshipList":this.visualizeFromRelationships(this.dataModel.getData().getRawRelationships())}}else this.showBrowserNotSupportedMessage();return this},d.prototype.visualizeFromNode=function(a){return this.getViz().setNode(a)},d.prototype.visualizeFromRelationships=function(b){var c,d,e,f,g,h,i;c=10,f={},g=[];for(e=0,i=b.length;0<=i?e<i:e>i;0<=i?e+=1:e-=1){h=b[e];if(e>=c){alert("Only showing the first ten in the set, to avoid crashing the visualization. We're working on adding filtering here!");break}f[h.getStartNodeUrl()]==null&&(f[h.getStartNodeUrl()]=!0,g.push(h.getStartNode())),f[h.getEndNodeUrl()]==null&&(f[h.getStartNodeUrl()]=!0,g.push(h.getEndNode()))}d=neo4j.Promise.join.apply(this,g);return d.then(a(function(a){return this.getViz().setNodes(a)},this))},d.prototype.settingsChanged=function(){if(this.viz!=null)return this.viz.setLabelProperties(this.settings.getLabelProperties())},d.prototype.getViz=function(){var a,c,d;c=$(document).width()-40,a=$(document).height()-160,(d=this.viz)!=null?d:this.viz=new b(this.server,c,a),this.settingsChanged();return this.viz},d.prototype.showSettingsDialog=function(){var a;if(this.settingsDialog!=null)return this.hideSettingsDialog();a=$("#visualization-show-settings"),a.addClass("selected");return this.settingsDialog=new e({appState:this.appState,baseElement:a,closeCallback:this.hideSettingsDialog})},d.prototype.hideSettingsDialog=function(){if(this.settingsDialog!=null){this.settingsDialog.remove(),delete this.settingsDialog;return $("#visualization-show-settings").removeClass("selected")}},d.prototype.browserHasRequiredFeatures=function(){return Object.prototype.__defineGetter__!=null},d.prototype.showBrowserNotSupportedMessage=function(){return $(this.el).html("<div class='pad'>          <h1>I currently do not support visualization in this browser :(</h1>          <p>I can't find the __defineGetter__ API method, which the visualization lib I use, Arbor.js, needs.</p>          <p>If you really want to use visualization (it's pretty awesome), please consider using Google Chrome, Firefox or Safari.</p>          </div>")},d.prototype.reflowGraphLayout=function(){if(this.viz!==null)return this.viz.reflow()},d.prototype.remove=function(){this.browserHasRequiredFeatures()&&(this.dataModel.unbind("change:data",this.render),this.hideSettingsDialog(),this.getViz().stop());return d.__super__.remove.call(this)},d.prototype.detach=function(){this.browserHasRequiredFeatures()&&(this.dataModel.unbind("change:data",this.render),this.hideSettingsDialog(),this.getViz().stop());return d.__super__.detach.call(this)},d.prototype.attach=function(a){d.__super__.attach.call(this,a);if(this.browserHasRequiredFeatures()&&this.vizEl!=null){this.getViz().start();return this.dataModel.bind("change:data",this.render)}};return d}()})}.call(this),define("neo4j/webadmin/templates/databrowser/createRelationship",["require","exports","module"],function(){return function(vars){with(vars||{})return'<p><label for="create-relationship-from">From node</label><input type="text" value="'+from+'" id="create-relationship-from" /></p><p><label for="create-relationship-type">Type</label><input type="text" value="'+type+'" id="create-relationship-type" /></p><p><select id="create-relationship-types">&nbsp;<option>Types in use</option>'+function(){var a=[],b,c;for(b in types)types.hasOwnProperty(b)&&(c=types[b],a.push("<option>"+c+"</option>"));return a.join("")}.call(this)+'</select><div class="break"></div></p><p><label for="create-relationship-to">To node</label><input type="text" value="'+to+'" id="create-relationship-to" /></p><ul class="button-bar popout-controls"><li><button class="button" id="create-relationship">Create</button></li></ul>'}}),function(){define("neo4j/webadmin/ui/FormHelper",["lib/backbone","lib/jquery"],function(){var a;return a=function(){function a(a){a==null&&(a="body"),this.context=$(a)}a.prototype.addErrorTo=function(a,b,c){var d,e;c==null&&(c="p"),e=$(a,this.context).closest(c),d=e.find(".error"),d.length===0&&(d=$("<div class='error'></div>"),e.prepend(d));return d.html(b)},a.prototype.removeAllErrors=function(){return $(".error",this.context).remove()},a.prototype.removeErrorsFrom=function(a,b){b==null&&(b="p");return $(a,this.context).closest(b).find(".error").remove()};return a}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/databrowser/CreateRelationshipDialog",["neo4j/webadmin/data/ItemUrlResolver","neo4j/webadmin/templates/databrowser/createRelationship","neo4j/webadmin/views/View","neo4j/webadmin/ui/FormHelper","lib/backbone"],function(b,d,e,f){var g;return g=function(){function g(){this.render=a(this.render,this),this.position=a(this.position,this),this.saveFailed=a(this.saveFailed,this),this.saveSuccessful=a(this.saveSuccessful,this),this.save=a(this.save,this),this.pickedFromAvailableTypes=a(this.pickedFromAvailableTypes,this),this.initialize=a(this.initialize,this),g.__super__.constructor.apply(this,arguments)}c(g,e),g.prototype.className="popout",g.prototype.events={"click #create-relationship":"save","change #create-relationship-types":"pickedFromAvailableTypes"},g.prototype.initialize=function(c){$(this.el).hide(),$("body").append(this.el),this.formHelper=new f(this.el),this.baseElement=c.baseElement,this.server=c.server,this.dataModel=c.dataModel,this.closeCallback=c.closeCallback,this.urlResolver=new b(this.server),this.type="RELATED_TO",this.dataModel.dataIsSingleNode()?this.from=this.dataModel.getData().getId():this.from="",this.to="";return this.server.getAvailableRelationshipTypes().then(a(function(a){this.types=a,this.position(),this.render();return $(this.el).show()},this))},g.prototype.pickedFromAvailableTypes=function(){var a;a=$("#create-relationship-types").val(),a!=="Types in use"&&$("#create-relationship-type").val(a);return $("#create-relationship-types").val("Types in use")},g.prototype.save=function(){var a;this.formHelper.removeAllErrors(),a=$("#create-relationship-type").val();return this.server.rel(this.getFromUrl(),a,this.getToUrl()).then(this.saveSuccessful,this.saveFailed)},g.prototype.saveSuccessful=function(a){var b;b=this.urlResolver.extractRelationshipId(a.getSelf()),this.dataModel.setData(a,!0,{silent:!0}),this.dataModel.setQuery("rel:"+b,!0);return this.closeCallback()},g.prototype.saveFailed=function(a){return a instanceof neo4j.exceptions.NotFoundException?a.url===this.getFromUrl()?this.formHelper.addErrorTo("#create-relationship-from","This node cannot be found."):this.formHelper.addErrorTo("#create-relationship-to","This node cannot be found."):this.formHelper.addErrorTo("#create-relationship-from","Unable to create relationship.")},g.prototype.getFromUrl=function(){return this.urlResolver.getNodeUrl(this.urlResolver.extractNodeId($("#create-relationship-from").val()))},g.prototype.getToUrl=function(){return this.urlResolver.getNodeUrl(this.urlResolver.extractNodeId($("#create-relationship-to").val()))},g.prototype.position=function(){var a,b,c;a=$(this.baseElement).offset(),c=a.top+$(this.baseElement).outerHeight(),b=a.left-($(this.el).outerWidth()-$(this.baseElement).outerWidth());return $(this.el).css({position:"absolute",top:c+"px",left:b+"px"})},g.prototype.render=function(){$(this.el).html(d({from:this.from,to:this.to,type:this.type,types:this.types}));return this};return g}()})}.call(this),define("neo4j/webadmin/templates/databrowser/base",["require","exports","module"],function(){return function(vars){with(vars||{})return'<div class="workarea"><div class="controls pad"><div class="span-half data-console-wrap"><input value="'+query+'" id="data-console" /><button title="Search" class="icon-button" id="data-execute-console"></button><div class="helpbox break">Search by: [node id], rel:[relationship id], rels:[node id]</div></div><div class="span-half last"><ul class="data-toolbar button-bar"><li><button title="Create a node" class="text-icon-button" id="data-create-node">Node</button></li><li><button title="Create a relationship" class="text-icon-button" id="data-create-relationship">Relationship</button></li>'+function(){return viewType==="tabular"?'<li><button title="Switch view mode" class="icon-button" id="data-switch-view"></button></li>':""}.call(this)+function(){return viewType!=="tabular"?'<li><button title="Switch view mode" class="icon-button tabular" id="data-switch-view"></button></li>':""}.call(this)+'</ul></div><div class="break"></div></div><div id="data-area"></div></div>'}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/DataBrowserView",["neo4j/webadmin/data/Search","neo4j/webadmin/data/ItemUrlResolver","neo4j/webadmin/security/HtmlEscaper","./databrowser/TabularView","./databrowser/VisualizedView","./databrowser/CreateRelationshipDialog","neo4j/webadmin/views/View","neo4j/webadmin/templates/databrowser/base","lib/backbone"],function(b,d,e,f,g,h,i,j){var k;return k=function(){function b(){this.remove=a(this.remove,this),this.switchToTabularView=a(this.switchToTabularView,this),this.switchToVisualizedView=a(this.switchToVisualizedView,this),this.switchView=a(this.switchView,this),this.hideCreateRelationshipDialog=a(this.hideCreateRelationshipDialog,this),this.createRelationship=a(this.createRelationship,this),this.createNode=a(this.createNode,this),this.search=a(this.search,this),this.queryChanged=a(this.queryChanged,this),this.renderDataView=a(this.renderDataView,this),this.render=a(this.render,this),b.__super__.constructor.apply(this,arguments)}c(b,i),b.prototype.template=j,b.prototype.events={"keyup #data-console":"search","click #data-create-node":"createNode","click #data-create-relationship":"createRelationship","click #data-switch-view":"switchView"},b.prototype.initialize=function(a){this.dataModel=a.dataModel,this.appState=a.state,this.server=a.state.getServer(),this.htmlEscaper=new e,this.urlResolver=new d(this.server),this.dataModel.bind("change:query",this.queryChanged);return this.switchToTabularView()},b.prototype.render=function(){$(this.el).html(this.template({query:this.htmlEscaper.escape(this.dataModel.getQuery()),viewType:this.viewType,dataType:this.dataModel.getDataType()}));return this.renderDataView()},b.prototype.renderDataView=function(){this.dataView.attach($("#data-area",this.el).empty()),this.dataView.render();return this},b.prototype.queryChanged=function(){return $("#data-console",this.el).val(this.dataModel.getQuery())},b.prototype.search=function(a){return this.dataModel.setQuery($("#data-console",this.el).val())},b.prototype.createNode=function(){return this.server.node({}).then(a(function(a){var b;b=this.urlResolver.extractNodeId(a.getSelf()),this.dataModel.setData(a,!0,{silent:!0});return this.dataModel.setQuery(b,!0)},this))},b.prototype.createRelationship=function(){var a;if(this.createRelationshipDialog!=null)return this.hideCreateRelationshipDialog();a=$("#data-create-relationship"),a.addClass("selected");return this.createRelationshipDialog=new h({baseElement:a,dataModel:this.dataModel,server:this.server,closeCallback:this.hideCreateRelationshipDialog})},b.prototype.hideCreateRelationshipDialog=function(){if(this.createRelationshipDialog!=null){this.createRelationshipDialog.remove(),delete this.createRelationshipDialog;return $("#data-create-relationship").removeClass("selected")}},b.prototype.switchView=function(a){this.viewType==="visualized"?($(a.target).removeClass("tabular"),this.switchToTabularView()):($(a.target).addClass("tabular"),this.switchToVisualizedView());return this.renderDataView()},b.prototype.switchToVisualizedView=function(){var a;this.dataView!=null&&this.dataView.detach(),(a=this.visualizedView)!=null?a:this.visualizedView=new g({dataModel:this.dataModel,appState:this.appState,server:this.server}),this.viewType="visualized";return this.dataView=this.visualizedView},b.prototype.switchToTabularView=function(){var a;this.dataView!=null&&this.dataView.detach(),(a=this.tabularView)!=null?a:this.tabularView=new f({dataModel:this.dataModel,appState:this.appState,server:this.server}),this.viewType="tabular";return this.dataView=this.tabularView},b.prototype.unbind=function(){return this.dataModel.unbind("change:query",this.queryChanged)},b.prototype.detach=function(){this.unbind(),this.hideCreateRelationshipDialog(),this.dataView!=null&&this.dataView.detach();return b.__super__.detach.call(this)},b.prototype.remove=function(){this.unbind(),this.hideCreateRelationshipDialog();return this.dataView.remove()};return b}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/databrowser/VisualizationSettingsView",["neo4j/webadmin/templates/databrowser/visualizationSettings","neo4j/webadmin/views/View","lib/backbone"],function(b,d){var e;return e=function(){function e(){this.render=a(this.render,this),this.initialize=a(this.initialize,this),e.__super__.constructor.apply(this,arguments)}c(e,d),e.prototype.initialize=function(a){return this.appState=a.appState},e.prototype.render=function(){$(this.el).html(b());return this};return e}()})}.call(this),function(){var a=Object.prototype.hasOwnProperty,b=function(b,c){function e(){this.constructor=b}for(var d in c)a.call(c,d)&&(b[d]=c[d]);e.prototype=c.prototype,b.prototype=new e,b.__super__=c.prototype;return b};define("neo4j/webadmin/models/NodeProxy",["./PropertyContainer","lib/backbone"],function(a){var c;return c=function(){function c(){c.__super__.constructor.apply(this,arguments)}b(c,a);return c}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/models/RelationshipProxy",["./PropertyContainer","lib/backbone"],function(b){var d;return d=function(){function d(){this.getStartId=a(this.getStartId,this),this.getEndId=a(this.getEndId,this),d.__super__.constructor.apply(this,arguments)}c(d,b),d.prototype.getEndId=function(){return this.urlResolver.extractRelationshipId(this.getItem().getEndNodeUrl())},d.prototype.getStartId=function(){return this.urlResolver.extractRelationshipId(this.getItem().getStartNodeUrl())};return d}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/models/RelationshipList",["neo4j/webadmin/data/ItemUrlResolver","./RelationshipProxy","lib/backbone"],function(b,d){var e;return e=function(){function b(){this.getRawRelationships=a(this.getRawRelationships,this),this.getRelationships=a(this.getRelationships,this),this.getPropertyKeys=a(this.getPropertyKeys,this),this.setRawRelationships=a(this.setRawRelationships,this),this.initialize=a(this.initialize,this),b.__super__.constructor.apply(this,arguments)}c(b,Backbone.Model),b.prototype.initialize=function(a){return this.setRawRelationships(a||[])},b.prototype.setRawRelationships=function(a){var b,c,e,f,g,h,i,j,k;this.set({rawRelationships:a}),g=[],c={};for(i=0,j=a.length;i<j;i++){f=a[i],k=f.getProperties();for(b in k)h=k[b],c[b]=!0;g.push(new d(f))}e=function(){var a;a=[];for(b in c)h=c[b],a.push(b);return a}(),this.set({propertyKeys:e});return this.set({relationships:g})},b.prototype.getPropertyKeys=function(){return this.get("propertyKeys")},b.prototype.getRelationships=function(){return this.get("relationships")},b.prototype.getRawRelationships=function(){return this.get("rawRelationships")};return b}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/models/DataBrowserState",["./NodeProxy","./RelationshipProxy","./RelationshipList","lib/backbone"],function(b,d,e){var f;return f=function(){function f(){this.setData=a(this.setData,this),this.setQuery=a(this.setQuery,this),this.dataIsSingleRelationship=a(this.dataIsSingleRelationship,this),this.dataIsSingleNode=a(this.dataIsSingleNode,this),this.getDataType=a(this.getDataType,this),this.getData=a(this.getData,this),this.getQuery=a(this.getQuery,this),this.initialize=a(this.initialize,this),f.__super__.constructor.apply(this,arguments)}c(f,Backbone.Model),f.prototype.defaults={type:null,data:null,query:null,queryOutOfSyncWithData:!0},f.prototype.initialize=function(a){return this.server=a.server},f.prototype.getQuery=function(){return this.get("query")},f.prototype.getData=function(){return this.get("data")},f.prototype.getDataType=function(){return this.get("type")},f.prototype.dataIsSingleNode=function(){return this.get("type")==="node"},f.prototype.dataIsSingleRelationship=function(){return this.get("type")==="relationship"},f.prototype.setQuery=function(a,b,c){b==null&&(b=!1),c==null&&(c={});if(this.get("query")!==a){this.set({queryOutOfSyncWithData:!b},c);return this.set({query:a},c)}},f.prototype.setData=function(a,c,f){c==null&&(c=!0),f==null&&(f={}),this.set({data:a,queryOutOfSyncWithData:!c},{silent:!0});return a instanceof neo4j.models.Node?this.set({type:"node",data:new b(a)},f):a instanceof neo4j.models.Relationship?this.set({type:"relationship",data:new d(a)},f):_(a).isArray()?this.set({type:"relationshipList",data:new e(a)},f):this.set({data:null,type:"not-found"},f)};return f}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/DataBrowserController",["neo4j/webadmin/data/QueuedSearch","./views/DataBrowserView","./views/databrowser/VisualizationSettingsView","./models/DataBrowserState","lib/backbone"],function(b,d,e,f){var g;return g=function(){function e(){this.getDataBrowserView=a(this.getDataBrowserView,this),this.showResult=a(this.showResult,this),this.queryChanged=a(this.queryChanged,this),this.search=a(this.search,this),this.base=a(this.base,this),this.initialize=a(this.initialize,this),e.__super__.constructor.apply(this,arguments)}c(e,Backbone.Controller),e.prototype.routes={"/data/":"base","/data/search/*query":"search"},e.prototype.initialize=function(a){this.appState=a,this.server=a.get("server"),this.searcher=new b(this.server),this.dataModel=new f({server:this.server});return this.dataModel.bind("change:query",this.queryChanged)},e.prototype.base=function(){return this.queryChanged()},e.prototype.search=function(a){while(a.charAt(a.length-1)==="/")a=a.substr(0,a.length-1);this.dataModel.setQuery(a);return this.appState.set({mainView:this.getDataBrowserView()})},e.prototype.queryChanged=function(){var a,b;a=this.dataModel.get("query");if(a===null)return this.search("0");b="#/data/search/"+a+"/",location.hash!==b&&(location.hash=b);if(this.dataModel.get("queryOutOfSyncWithData"))return this.searcher.exec(this.dataModel.get("query")).then(this.showResult,this.showResult)},e.prototype.showResult=function(a){return this.dataModel.setData(a)},e.prototype.getDataBrowserView=function(){var a;return(a=this.view)!=null?a:this.view=new d({state:this.appState,dataModel:this.dataModel})};return e}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/models/Console",["neo4j/webadmin/security/HtmlEscaper","lib/backbone"],function(b){var d;return d=function(){function d(){this.pushLines=a(this.pushLines,this),this.pushHistory=a(this.pushHistory,this),this.parseEvalResult=a(this.parseEvalResult,this),this.nextHistory=a(this.nextHistory,this),this.prevHistory=a(this.prevHistory,this),this.eval=a(this.eval,this),this.initialize=a(this.initialize,this),d.__super__.constructor.apply(this,arguments)}c(d,Backbone.Model),d.prototype.defaults={lines:[],history:[],historyIndex:0,showPrompt:!1,prompt:""},d.prototype.initialize=function(a){this.server=a.server,this.eval("init()",!1,!1);return this.htmlEscaper=new b},d.prototype.eval=function(a,b,c){b==null&&(b=!0),c==null&&(c=!0),this.set({showPrompt:!1,prompt:""},{silent:!0}),b&&this.pushLines([a],"gremlin> "),c&&this.pushHistory(a);return this.server.manage.console.exec(a,"awesome",this.parseEvalResult)},d.prototype.prevHistory=function(){var a,b,c;a=this.get("history"),b=this.get("historyIndex");if(a.length>b){b++,c=a[a.length-b];return this.set({historyIndex:b,prompt:c})}},d.prototype.nextHistory=function(){var a,b,c;a=this.get("history"),b=this.get("historyIndex");if(b>1){b--,c=a[a.length-b];return this.set({historyIndex:b,prompt:c})}if(b===1){b--;return this.set({historyIndex:b,prompt:""})}return this.set({prompt:""})},d.prototype.parseEvalResult=function(a){_(a).isString()&&a.length>0?(a.substr(-1)==="\n"&&(a=a.substr(0,a.length-1)),a=a.split("\n")):a=[],this.set({showPrompt:!0},{silent:!0});return this.pushLines(a)},d.prototype.pushHistory=function(a){var b;if(a.length>0){b=this.get("history");if(b.length===0||b[b.length-1]!==a)return this.set({history:b.concat([a]),historyIndex:0},{silent:!0})}},d.prototype.pushLines=function(a,b){var c;b==null&&(b="==> "),a=function(){var d,e,f;f=[];for(d=0,e=a.length;d<e;d++)c=a[d],f.push(this.htmlEscaper.escape(b+c));return f}.call(this);return this.set({lines:this.get("lines").concat(a)})};return d}()})}.call(this),define("neo4j/webadmin/templates/console/base",["require","exports","module"],function(){return function(vars){with(vars||{})return'<div class="sidebar"><p class="pad">The Neo4j console allows you to use the <a href="http://gremlin.tinkerpop.com" target="_BLANK">Gremlin graph traversal language</a> for working with your graph. Gremlin is an expressive data flow language that can be used for graph query and manipulation, built on and adding to <a href="http://groovy.codehaus.org/Documentation" target="_BLANK">Groovy</a>.</p><p class="pad">Using Gremlin, you can perform powerful data manipulations. <a href="http://gremlin.tinkerpop.com" target="_BLANK">More information.</a></p><div class="foldout"><h2><a href="#" class="foldout_trigger">Cheat sheet</a></h2><div class="foldout_content"><ul class="info_list"><li><h3>Local graph</h3><p>&gt; g</p></li><li><h3>Set variable</h3><p>&gt; myVar = "My Value"</p></li><li><h3>Get node by id</h3><p>&gt; refNode = g.v(0)</p></li><li><h3>Set property on Node</h3><p>&gt; refNode.name = "Bob"</p></li><li><h3>List all node properties</h3><p>&gt; refNode.map()</p></li><li><h3>Define a properties map</h3><p>&gt; props = [:]</p></li><li><h3>Add a property to the map</h3><p>&gt; props["name"] = "Ariel"</p></li><li><h3>Create a node</h3><p>&gt; secondNode = g.addVertex(props)</p></li><li><h3>Another property map</h3><p>&gt; edgeProps = ["quality":"awesome"]</p></li><li><h3>Create relation</h3><p>&gt; myRelation = g.addEdge(edgeProps, refNode, secondNode, \'KNOWS\')</p></li><li><h3>Remove node or relation</h3><p>&gt; g.removeEdge(myRelation)</p><p>&gt; g.removeVertex(secondNode)</p></li><li><h3>List relations of node</h3></h3><p><ul><li>&gt; refNode.bothE</li><li>&gt; refNode.inE</li><li>&gt; refNode.outE</li><li>&gt; refNode.bothE{it.label="relation type"}</li></ul></p></li><li><h3>List nodes of relation</h3><p><ul><li>&gt; myRelation.bothV</li><li>&gt; myRelation.inV</li><li>&gt; myRelation.outV</li></ul></p></li></ul></div></div><div class="foldout"><h2><a href="#" class="foldout_trigger">If the console hangs</a></h2><div class="foldout_content"><p class="pad">If you done goofed, you can reset the gremlin console by clearing your browser cookies for webadmin.</p></div></div></div><div class="workarea with-sidebar pad" id="console-base"><div id="console"></div></div>'}}),define("neo4j/webadmin/templates/console/console",["require","exports","module"],function(){return function(vars){with(vars||{})return"<ul>"+function(){var a=[],b,c;for(b in lines)lines.hasOwnProperty(b)&&(c=lines[b],a.push("<li>"+c+"</li>"));return a.join("")}.call(this)+"<li>"+function(){return showPrompt?'gremlin> <input type="text" value="'+prompt+'" id="console-input" />':""}.call(this)+"</li></ul>"}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/ConsoleView",["neo4j/webadmin/templates/console/base","neo4j/webadmin/templates/console/console","neo4j/webadmin/views/View","lib/backbone"],function(b,d,e){var f;return f=function(){function f(){this.remove=a(this.remove,this),this.scrollToBottomOfConsole=a(this.scrollToBottomOfConsole,this),this.renderConsole=a(this.renderConsole,this),this.render=a(this.render,this),this.wrapperClicked=a(this.wrapperClicked,this),this.consoleKeyUp=a(this.consoleKeyUp,this),this.initialize=a(this.initialize,this),f.__super__.constructor.apply(this,arguments)}c(f,e),f.prototype.events={"keyup #console-input":"consoleKeyUp","click #console-base":"wrapperClicked"},f.prototype.initialize=function(a){this.appState=a.appState,this.consoleState=a.consoleState;return this.consoleState.bind("change",this.renderConsole)},f.prototype.consoleKeyUp=function(a){if(a.keyCode===13)return this.consoleState.eval($("#console-input").val());if(a.keyCode===38)return this.consoleState.prevHistory();if(a.keyCode===40)return this.consoleState.nextHistory()},f.prototype.wrapperClicked=function(a){return $("#console-input").focus()},f.prototype.render=function(){$(this.el).html(b()),this.renderConsole();return this},f.prototype.renderConsole=function(){$("#console",this.el).html(d({lines:this.consoleState.get("lines"),prompt:this.consoleState.get("prompt"),showPrompt:this.consoleState.get("showPrompt")})),this.delegateEvents(),$("#console-input").focus();return this.scrollToBottomOfConsole()},f.prototype.scrollToBottomOfConsole=function(){var a;a=$("#console",this.el);if(a[0])return a[0].scrollTop=a[0].scrollHeight},f.prototype.remove=function(){this.consoleState.unbind("change",this.renderConsole);return f.__super__.remove.call(this)};return f}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/ConsoleController",["./models/Console","./views/ConsoleView","lib/backbone"],function(b,d){var e;return e=function(){function e(){this.getConsoleView=a(this.getConsoleView,this),this.console=a(this.console,this),this.initialize=a(this.initialize,this),e.__super__.constructor.apply(this,arguments)}c(e,Backbone.Controller),e.prototype.routes={"/console/":"console"},e.prototype.initialize=function(a){this.appState=a;return this.consoleState=new b({server:this.appState.get("server")})},e.prototype.console=function(){return this.appState.set({mainView:this.getConsoleView()})},e.prototype.getConsoleView=function(){var a;return(a=this.view)!=null?a:this.view=new d({appState:this.appState,consoleState:this.consoleState})};return e}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/models/ServerInfo",["lib/backbone"],function(){var b;return b=function(){function b(){this.getBean=a(this.getBean,this),this.setBean=a(this.setBean,this),this.parseJmxBeans=a(this.parseJmxBeans,this),this.fetch=a(this.fetch,this),this.setCurrent=a(this.setCurrent,this),this.initialize=a(this.initialize,this),b.__super__.constructor.apply(this,arguments)}c(b,Backbone.Model),b.prototype.initialize=function(a){return this.server=a.server},b.prototype.setCurrent=function(a,b){this.current={domain:a,beanName:b};return this.get("domains")!=null&&this.getBean(a,b)!=null?this.set({current:this.getBean(a,b)}):this.fetch()},b.prototype.fetch=function(){return this.server.manage.jmx.query(["*:*"],this.parseJmxBeans)},b.prototype.parseJmxBeans=function(a){var b,c,d,e,f,g,h;b="org.neo4j",a=a.sort(function(a,c){var d,e;d=a.domain===b?"000"+a.getName():a.jmxName,e=c.domain===b?"000"+c.getName():c.jmxName;return d.toLowerCase()>e.toLowerCase()}),f=[],e=null,d=[];for(g=0,h=a.length;g<h;g++)c=a[g],e!==c.domain&&(e=c.domain,d=[],f.push({name:c.domain,beans:d})),d.push(c),this.setBean(c),this.current!=null&&this.current.domain===e&&this.current.beanName===c.getName()&&this.set({current:c},{silent:!0});this.current==null&&f.length>0&&f[0].beans.length>0&&this.set({current:f[0].beans[0]},{silent:!0});return this.set({domains:f})},b.prototype.setBean=function(a){var b;b={},b[""+a.domain+":"+a.getName()]=a;return this.set(b,{silent:!0})},b.prototype.getBean=function(a,b){return this.get(""+a+":"+b)};return b}()})}.call(this),define("neo4j/webadmin/templates/serverinfo/base",["require","exports","module"],function(){return function(vars){with(vars||{})return'<div class="sidebar"><ol>'+function(){var a=[],b,c;for(b in domains)domains.hasOwnProperty(b)&&(c=domains[b],a.push("<lh>"+c.name+"</lh>"+function(){var a=[],b,d;for(b in c.beans)c.beans.hasOwnProperty(b)&&(d=c.beans[b],a.push('<li><a href="#/info/'+d.domain+"/"+d.getName()+'/">'+d.getName()+"</a></li>"));return a.join("")}.call(this)));return a.join("")}.call(this)+'</ol></div><div class="workarea with-sidebar" id="info-bean"></div>'}}),define("neo4j/webadmin/templates/serverinfo/bean",["require","exports","module"],function(){return function(vars){with(vars||{})return function(){return typeof bean!="undefined"?'<div class="pad"><h2>'+bean.getName()+'</h2><p class="small">'+bean.description+'</p></div><table cellspacing="0" class="data-table"><tbody>'+function(){var a=[],b,c;for(b in attributes)attributes.hasOwnProperty(b)&&(c=attributes[b],a.push('<tr><td style="padding-left:'+c.indent*10+'px;"><h3>'+c.name+'</h3><p class="small">'+c.description+'</p></td><td class="value">'+c.value+"</td></tr>"));return a.join("")}.call(this)+"</tbody></table>":""}.call(this)+function(){return typeof bean=="undefined"?'<div class="pad"><h2>No information found</h2><p>Unable to locate any info for the specified JMX bean.</p></div>':""}.call(this)}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/ServerInfoView",["neo4j/webadmin/templates/serverinfo/base","neo4j/webadmin/templates/serverinfo/bean","neo4j/webadmin/views/View","lib/backbone"],function(b,d,e){var f;return f=function(){function f(){this.remove=a(this.remove,this),this.flattenAttributes=a(this.flattenAttributes,this),this.renderBean=a(this.renderBean,this),this.render=a(this.render,this),f.__super__.constructor.apply(this,arguments)}c(f,e),f.prototype.initialize=function(a){this.serverInfo=a.serverInfo,this.baseTemplate=b,this.beanTemplate=d,this.serverInfo.bind("change:domains",this.render);return this.serverInfo.bind("change:current",this.renderBean)},f.prototype.render=function(){$(this.el).html(this.baseTemplate({domains:this.serverInfo.get("domains")})),this.renderBean();return this},f.prototype.renderBean=function(){var a;a=this.serverInfo.get("current"),$("#info-bean",this.el).empty().append(this.beanTemplate({bean:a,attributes:a!=null?this.flattenAttributes(a.attributes):[]}));return this},f.prototype.flattenAttributes=function(a,b,c){var d,e,f,g,h;b==null&&(b=[]),c==null&&(c=1);for(g=0,h=a.length;g<h;g++)d=a[g],e=d.name!=null?d.name:d.type!=null?d.type:"",f={name:e,description:d.description,indent:c},b.push(f),d.value==null?f.value="":_(d.value).isArray()&&_(d.value[0]).isString()?f.value=d.value.join(", "):_(d.value).isArray()?(f.value="",this.flattenAttributes(d.value,b,c+1)):typeof d.value==="object"?(f.value="",this.flattenAttributes(d.value.value,b,c+1)):f.value=d.value;return b},f.prototype.remove=function(){this.serverInfo.unbind("change:domains",this.render),this.serverInfo.unbind("change:current",this.renderBean);return f.__super__.remove.call(this)};return f}()})}.call(this),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/ServerInfoController",["./models/ServerInfo","./views/ServerInfoView","lib/backbone"],function(b,d){var e;return e=function(){function e(){this.getServerInfoView=a(this.getServerInfoView,this),this.bean=a(this.bean,this),this.base=a(this.base,this),this.initialize=a(this.initialize,this),e.__super__.constructor.apply(this,arguments)}c(e,Backbone.Controller),e.prototype.routes={"/info/":"base","/info/:domain/:name/":"bean"},e.prototype.initialize=function(a){this.appState=a,this.serverInfo=new b({server:this.appState.get("server")});return this.server=this.appState.get("server")},e.prototype.base=function(){this.appState.set({mainView:this.getServerInfoView()});return this.serverInfo.fetch()},e.prototype.bean=function(a,b){this.appState.set({mainView:this.getServerInfoView()});return this.serverInfo.setCurrent(a,b)},e.prototype.getServerInfoView=function(){var a;return(a=this.view)!=null?a:this.view=new d({appState:this.appState,serverInfo:this.serverInfo})};return e}()})}.call(this),has=function(a){function k(a,c){var d=typeof a[c];return d=="object"?!!a[c]:!b[d]}function j(a){if(a)while(a.lastChild)a.removeChild(a.lastChild);return a}function i(a,b){var d=!1,e=a.charAt(0).toUpperCase()+a.slice(1),f=c.length,g=b.style;if(typeof g[a]=="string")d=!0;else while(f--)if(typeof g[c[f]+e]=="string"){d=!0;break}return d}function h(b,c,g){f[b]=g?c(a,d,e):c}function g(b){typeof f[b]=="function"&&(f[b]=f[b](a,d,e));return f[b]}var b={"boolean":1,number:1,string:1,"undefined":1},c=["Webkit","Moz","O","ms","Khtml"],d=k(a,"document")&&a.document,e=d&&k(d,"createElement")&&d.createElement("DiV"),f={};g.add=h,g.clearElement=j,g.cssprop=i,g.isHostType=k,g._tests=f,g.add("dom",function(a,b,c){return b&&c&&k(a,"location")&&k(b,"documentElement")&&k(b,"getElementById")&&k(b,"getElementsByName")&&k(b,"getElementsByTagName")&&k(b,"createComment")&&k(b,"createElement")&&k(b,"createTextNode")&&k(c,"appendChild")&&k(c,"insertBefore")&&k(c,"removeChild")&&k(c,"getAttribute")&&k(c,"setAttribute")&&k(c,"removeAttribute")&&k(c,"style")&&typeof c.style.cssText=="string"});try{document.execCommand("BackgroundImageCache",!1,!0)}catch(l){}return g}(this),function(a,b,c,d){var e="string",f="function";b("native-console",function(a){return"console"in a}),b("native-xhr",function(b){return a.isHostType(b,"XMLHttpRequest")}),b("native-cors-xhr",function(b){return a("native-xhr")&&"withCredentials"in new XMLHttpRequest}),b("native-xhr-uploadevents",function(b){return a("native-xhr")&&"upload"in new XMLHttpRequest}),b("activex",function(b){return a.isHostType(b,"ActiveXObject")}),b("activex-enabled",function(b){var c=null;if(a("activex"))try{c=!!(new ActiveXObject("htmlfile"))}catch(d){c=!1}return c}),b("native-navigator",function(a){return"navigator"in a}),b("native-geolocation",function(b){return a("native-navigator")&&"geolocation"in b.navigator}),b("native-crosswindowmessaging",function(a){return"postMessage"in a}),b("native-orientation",function(a){return"ondeviceorientation"in a}),b("native-worker",function(a){return"Worker"in a}),b("native-sharedworker",function(a){return"SharedWorker"in a}),b("native-eventsource",function(a){return"EventSource"in a}),b("eval-global-scope",function(a){var b="__eval"+Number(new Date),c=!1;try{a.eval("var "+b+"=true")}catch(e){}c=a[b]===!0;if(c)try{delete a[b]}catch(e){a[b]=d}return c}),b("native-sql-db",function(a){var b="hasjstestdb",c="openDatabase"in a;if(c)try{c=!!openDatabase(b,"1.0",b,2e4)}catch(d){c=!1}return c}),b("native-indexeddb",function(a){return"indexedDB"in a}),b("native-localstorage",function(a){var b=!1;try{b="localStorage"in a&&"setItem"in localStorage}catch(c){}return b}),b("native-sessionstorage",function(a){var b=!1;try{b="sessionStorage"in a&&"setItem"in sessionStorage}catch(c){}return b}),b("native-history-state",function(a){return"history"in a&&"pushState"in history}),b("native-websockets",function(a){return"WebSocket"in a})}(has,has.add,has.cssprop),define("lib/has",function(){}),function(){var a=Object.prototype.hasOwnProperty,b=function(b,c){function e(){this.constructor=b}for(var d in c)a.call(c,d)&&(b[d]=c[d]);e.prototype=c.prototype,b.prototype=new e,b.__super__=c.prototype;return b};define("neo4j/webadmin/models/LocallyStoredModel",["lib/backbone","lib/has"],function(){var a,c,d;c=function(){function a(){}a.prototype.store=function(a,b){return localStorage.setItem(a,JSON.stringify(b))},a.prototype.fetch=function(a,b){var c;b==null&&(b={}),c=localStorage.getItem(a);return c!==null?JSON.parse(c):b};return a}(),a=function(){function a(){this.storage={}}a.prototype.store=function(a,b){return this.storage[a]=b},a.prototype.fetch=function(a,b){b==null&&(b={});return this.storage[a]!=null?this.storage[a]:this.defaults};return a}();return d=function(){function d(){d.__super__.constructor.apply(this,arguments)}b(d,Backbone.Model),d.prototype.initialize=function(){return has("native-localstorage")?this.storingStrategy=new c:this.storingStrategy=new a},d.prototype.getStorageKey=function(){return"default-locally-stored-model"},d.prototype.fetch=function(){this.clear({silent:!0});return this.set(this.storingStrategy.fetch(this.getStorageKey(),this.defaults))},d.prototype.save=function(){return this.storingStrategy.store(this.getStorageKey(),this.toJSON())};return d}()})}.call(this),function(){var a=Object.prototype.hasOwnProperty,b=function(b,c){function e(){this.constructor=b}for(var d in c)a.call(c,d)&&(b[d]=c[d]);e.prototype=c.prototype,b.prototype=new e,b.__super__=c.prototype;return b};define("neo4j/webadmin/models/VisualizationSettings",["neo4j/webadmin/models/LocallyStoredModel"],function(a){var c;return c=function(){function c(){c.__super__.constructor.apply(this,arguments)}b(c,a),c.prototype.defaults={labelProperties:["name"]},c.prototype.getStorageKey=function(){return"visualization-settings"},c.prototype.getLabelProperties=function(){return this.get("labelProperties")||[]},c.prototype.setLabelProperties=function(a){return this.set({labelProperties:a})};return c}()})}.call(this),function(){var a=Object.prototype.hasOwnProperty,b=function(b,c){function e(){this.constructor=b}for(var d in c)a.call(c,d)&&(b[d]=c[d]);e.prototype=c.prototype,b.prototype=new e,b.__super__=c.prototype;return b};define("neo4j/webadmin/models/ApplicationState",["neo4j/webadmin/models/VisualizationSettings","lib/backbone"],function(a){var c;return c=function(){function c(){c.__super__.constructor.apply(this,arguments)}b(c,Backbone.Model),c.prototype.getServer=function(){return this.get("server")},c.prototype.getVisualizationSettings=function(){this.visualizationSettings==null&&(this.visualizationSettings=new a,this.visualizationSettings.fetch());return this.visualizationSettings};return c}()})}.call(this),define("neo4j/webadmin/templates/base",["require","exports","module"],function(){return function(vars){with(vars||{})return'<div id="header"><div id="header_submenu"><ul class="horizontal_menu"><li><a href="http://docs.neo4j.org/" class="micro-button">Documentation</a></li></ul></div><img src="img/logo.png" id="logo" /><ul id="mainmenu">'+function(){var a=[],b,c;for(b in mainmenu)mainmenu.hasOwnProperty(b)&&(c=mainmenu[b],a.push('<li class="title-button">'+function(){return c.current?'<a href="'+c.url+'" class="current"><span class="subtitle">'+c.subtitle+"</span><span>"+c.label+"</span></a>":""}.call(this)+function(){return c.current?"":'<a href="'+c.url+'"><span class="subtitle">'+c.subtitle+"</span><span>"+c.label+"</span></a>"}.call(this)+"</li>"));return a.join("")}.call(this)+'</ul></div><div id="contents"></div><div id="footer"><p class="copyright">Copyright (c) 2002-2010 <a href="http://neotechnology.com">Neo Technology</a>. This is free software, available under the  <a href="http://www.gnu.org/licenses/agpl.html">GNU Affero General Public License</a> version 3 or greater.</p></div>'}}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}},b=Object.prototype.hasOwnProperty,c=function(a,c){function e(){this.constructor=a}for(var d in c)b.call(c,d)&&(a[d]=c[d]);e.prototype=c.prototype,a.prototype=new e,a.__super__=c.prototype;return a};define("neo4j/webadmin/views/BaseView",["neo4j/webadmin/templates/base","neo4j/webadmin/views/View","lib/backbone"],function(b,d){var e;return e=function(){function e(){this.remove=a(this.remove,this),this.mainViewChanged=a(this.mainViewChanged,this),this.initialize=a(this.initialize,this),e.__super__.constructor.apply(this,arguments)}c(e,d),e.prototype.template=b,e.prototype.initialize=function(a){this.appState=a.appState;return this.appState.bind("change:mainView",this.mainViewChanged)},e.prototype.mainViewChanged=function(a){this.mainView!=null&&this.mainView.detach(),this.mainView=a.attributes.mainView;return this.render()},e.prototype.render=function(){$(this.el).html(this.template({mainmenu:[{label:"Dashboard",subtitle:"Overview",url:"#",current:location.hash===""},{label:"Data browser",subtitle:"Explore and edit",url:"#/data/",current:location.hash.indexOf("#/data/")===0},{label:"Console",subtitle:"Power tool",url:"#/console/",current:location.hash==="#/console/"},{label:"Server info",subtitle:"Details",url:"#/info/",current:location.hash==="#/info/"}]})),this.mainView!=null&&(this.mainView.attach($("#contents")),this.mainView.render());return this},e.prototype.remove=function(){this.appState.unbind("change:mainView",this.mainViewChanged),this.mainView!=null&&this.mainView.remove();return e.__super__.remove.call(this)};return e}()})}.call(this),function(){define("neo4j/webadmin/ui/FoldoutWatcher",["require","exports","module"],function(){var a;return a=function(){function a(){}a.prototype.init=function(){return $("a.foldout_trigger").live("click",function(a){a.preventDefault();return $(a.target).closest(".foldout").toggleClass("visible")})};return a}()})}.call(this),function(a){function b(b){if(typeof b.data==="string"){var c=b.handler,d=b.data.toLowerCase().split(" ");b.handler=function(b){if(this===b.target||!/textarea|select/i.test(b.target.nodeName)&&b.target.type!=="text"){var e=b.type!=="keypress"&&a.hotkeys.specialKeys[b.which],f=String.fromCharCode(b.which).toLowerCase(),g,h="",i={};b.altKey&&e!=="alt"&&(h+="alt+"),b.ctrlKey&&e!=="ctrl"&&(h+="ctrl+"),b.metaKey&&!b.ctrlKey&&e!=="meta"&&(h+="meta+"),b.shiftKey&&e!=="shift"&&(h+="shift+"),e?i[h+e]=!0:(i[h+f]=!0,i[h+a.hotkeys.shiftNums[f]]=!0,h==="shift+"&&(i[a.hotkeys.shiftNums[f]]=!0));for(var j=0,k=d.length;j<k;j++)if(i[d[j]])return c.apply(this,arguments)}}}}a.hotkeys={version:"0.8",specialKeys:{8:"backspace",9:"tab",13:"return",16:"shift",17:"ctrl",18:"alt",19:"pause",20:"capslock",27:"esc",32:"space",33:"pageup",34:"pagedown",35:"end",36:"home",37:"left",38:"up",39:"right",40:"down",45:"insert",46:"del",96:"0",97:"1",98:"2",99:"3",100:"4",101:"5",102:"6",103:"7",104:"8",105:"9",106:"*",107:"+",109:"-",110:".",111:"/",112:"f1",113:"f2",114:"f3",115:"f4",116:"f5",117:"f6",118:"f7",119:"f8",120:"f9",121:"f10",122:"f11",123:"f12",144:"numlock",145:"scroll",191:"/",224:"meta"},shiftNums:{"`":"~",1:"!",2:"@",3:"#",4:"$",5:"%",6:"^",7:"&",8:"*",9:"(",0:")","-":"_","=":"+",";":": ","'":'"',",":"<",".":">","/":"?","\\":"|"}},a.each(["keydown","keyup","keypress"],function(){a.event.special[this]={add:b}})}(jQuery),define("lib/jquery.hotkeys",function(){}),function(){var a=function(a,b){return function(){return a.apply(b,arguments)}};define("neo4j/webadmin/KeyboardShortcuts",["order!lib/jquery","order!lib/jquery.hotkeys"],function(){var b;return b=function(){function b(b,c,d,e){this.search=a(this.search,this),this.init=a(this.init,this),this.databrowserController=c}b.prototype.shortcuts={s:"search"},b.prototype.init=function(){var a,b,c,d;c=this.shortcuts,d=[];for(a in c)b=c[a],d.push($(document).bind("keyup",a,this[b]));return d},b.prototype.search=function(a){this.databrowserController.base();return setTimeout(function(){$("#data-console").val("");return $("#data-console").focus()},1)};return b}()})}.call(this),define("neo4j/webadmin/templates/splash",["require","exports","module"],function(){return function(vars){with(vars||{})return'<div id="splash-wrap"><div id="splash"><img src="img/logo.png" id="splash-logo" /></div></div>'}}),function(){var a=this,b=a._,c={},d=Array.prototype,e=Object.prototype,f=d.slice,g=d.unshift,h=e.toString,i=e.hasOwnProperty,j=d.forEach,k=d.map,l=d.reduce,m=d.reduceRight,n=d.filter,o=d.every,p=d.some,q=d.indexOf,r=d.lastIndexOf,s=Array.isArray,t=Object.keys,u=function(a){return new z(a)};typeof module!=="undefined"&&module.exports?(module.exports=u,u._=u):a._=u,u.VERSION="1.1.4";var v=u.each=u.forEach=function(a,b,d){var e;if(a!=null)if(j&&a.forEach===j)a.forEach(b,d);else if(u.isNumber(a.length)){for(var f=0,g=a.length;f<g;f++)if(b.call(d,a[f],f,a)===c)return}else for(var h in a)if(i.call(a,h))if(b.call(d,a[h],h,a)===c)return};u.map=function(a,b,c){var d=[];if(a==null)return d;if(k&&a.map===k)return a.map(b,c);v(a,function(a,e,f){d[d.length]=b.call(c,a,e,f)});return d},u.reduce=u.foldl=u.inject=function(a,b,c,d){var e=c!==void 0;a==null&&(a=[]);if(l&&a.reduce===l){d&&(b=u.bind(b,d));return e?a.reduce(b,c):a.reduce(b)}v(a,function(a,f,g){e||f!==0?c=b.call(d,c,a,f,g):(c=a,e=!0)});if(!e)throw new TypeError("Reduce of empty array with no initial value");return c},u.reduceRight=u.foldr=function(a,b,c,d){a==null&&(a=[]);if(m&&a.reduceRight===m){d&&(b=u.bind(b,d));return c!==void 0?a.reduceRight(b,c):a.reduceRight(b)}var e=(u.isArray(a)?a.slice():u.toArray(a)).reverse();return u.reduce(e,b,c,d)},u.find=u.detect=function(a,b,c){var d;w(a,function(a,e,f){if(b.call(c,a,e,f)){d=a;return!0}});return d},u.filter=u.select=function(a,b,c){var d=[];if(a==null)return d;if(n&&a.filter===n)return a.filter(b,c);v(a,function(a,e,f){b.call(c,a,e,f)&&(d[d.length]=a)});return d},u.reject=function(a,b,c){var d=[];if(a==null)return d;v(a,function(a,e,f){b.call(c,a,e,f)||(d[d.length]=a)});return d},u.every=u.all=function(a,b,d){b=b||u.identity;var e=!0;if(a==null)return e;if(o&&a.every===o)return a.every(b,d);v(a,function(a,f,g){if(!(e=e&&b.call(d,a,f,g)))return c});return e};var w=u.some=u.any=function(a,b,d){b=b||u.identity;var e=!1;if(a==null)return e;if(p&&a.some===p)return a.some(b,d);v(a,function(a,f,g){if(e=b.call(d,a,f,g))return c});return e};u.include=u.contains=function(a,b){var c=!1;if(a==null)return c;if(q&&a.indexOf===q)return a.indexOf(b)!=-1;w(a,function(a){if(c=a===b)return!0});return c},u.invoke=function(a,b){var c=f.call(arguments,2);return u.map(a,function(a){return(b?a[b]:a).apply(a,c)})},u.pluck=function(a,b){return u.map(a,function(a){return a[b]})},u.max=function(a,b,c){if(!b&&u.isArray(a))return Math.max.apply(Math,a);var d={computed:-Infinity};v(a,function(a,e,f){var g=b?b.call(c,a,e,f):a;g>=d.computed&&(d={value:a,computed:g})});return d.value},u.min=function(a,b,c){if(!b&&u.isArray(a))return Math.min.apply(Math,a);var d={computed:Infinity};v(a,function(a,e,f){var g=b?b.call(c,a,e,f):a;g<d.computed&&(d={value:a,computed:g})});return d.value},u.sortBy=function(a,b,c){return u.pluck(u.map(a,function(a,d,e){return{value:a,criteria:b.call(c,a,d,e)}}).sort(function(a,b){var c=a.criteria,d=b.criteria;return c<d?-1:c>d?1:0}),"value")},u.sortedIndex=function(a,b,c){c=c||u.identity;var d=0,e=a.length;while(d<e){var f=d+e>>1;c(a[f])<c(b)?d=f+1:e=f}return d},u.toArray=function(a){if(!a)return[];if(a.toArray)return a.toArray();if(u.isArray(a))return a;if(u.isArguments(a))return f.call(a);return u.values(a)},u.size=function(a){return u.toArray(a).length},u.first=u.head=function(a,b,c){return b&&!c?f.call(a,0,b):a[0]},u.rest=u.tail=function(a,b,c){return f.call(a,u.isUndefined(b)||c?1:b)},u.last=function(a){return a[a.length-1]},u.compact=function(a){return u.filter(a,function(a){return!!a})},u.flatten=function(a){return u.reduce(a,function(a,b){if(u.isArray(b))return a.concat(u.flatten(b));a[a.length]=b;return a},[])},u.without=function(a){var b=f.call(arguments,1);return u.filter(a,function(a){return!u.include(b,a)})},u.uniq=u.unique=function(a){return u.reduce(a,function(a,b,c){if(0==c||!u.include(a,b))a[a.length]=b;return a},[])},u.intersect=function(a){var b=f.call(arguments,1);return u.filter(u.uniq(a),function(a){return u.every(b,function(b){return u.indexOf(b,a)>=0})})},u.zip=function(){var a=f.call(arguments),b=u.max(u.pluck(a,"length")),c=Array(b);for(var d=0;d<b;d++)c[d]=u.pluck(a,""+d);return c},u.indexOf=function(a,b,c){if(a==null)return-1;if(c){var d=u.sortedIndex(a,b);return a[d]===b?d:-1}if(q&&a.indexOf===q)return a.indexOf(b);for(var d=0,e=a.length;d<e;d++)if(a[d]===b)return d;return-1},u.lastIndexOf=function(a,b){if(a==null)return-1;if(r&&a.lastIndexOf===r)return a.lastIndexOf(b);var c=a.length;while(c--)if(a[c]===b)return c;return-1},u.range=function(a,b,c){var d=f.call(arguments),e=d.length<=1,a=e?0:d[0],b=e?d[0]:d[1],c=d[2]||1,g=Math.max(Math.ceil((b-a)/c),0),h=0,i=Array(g);while(h<g)i[h++]=a,a+=c;return i},u.bind=function(a,b){var c=f.call(arguments,2);return function(){return a.apply(b||{},c.concat(f.call(arguments)))}},u.bindAll=function(a){var b=f.call(arguments,1);b.length==0&&(b=u.functions(a)),v(b,function(b){a[b]=u.bind(a[b],a)});return a},u.memoize=function(a,b){var c={};b=b||u.identity;return function(){var d=b.apply(this,arguments);return d in c?c[d]:c[d]=a.apply(this,arguments)}},u.delay=function(a,b){var c=f.call(arguments,2);return setTimeout(function(){return a.apply(a,c)},b)},u.defer=function(a){return u.delay.apply(u,[a,1].concat(f.call(arguments,1)))};var x=function(a,b,c){var d;return function(){var e=this,f=arguments,g=function(){d=null,a.apply(e,f)};c&&clearTimeout(d);if(c||!d)d=setTimeout(g,b)}};u.throttle=function(a,b){return x(a,b,!1)},u.debounce=function(a,b){return x(a,b,!0)},u.wrap=function(a,b){return function(){var c=[a].concat(f.call(arguments));return b.apply(this,c)}},u.compose=function(){var a=f.call(arguments);return function(){var b=f.call(arguments);for(var c=a.length-1;c>=0;c--)b=[a[c].apply(this,b)];return b[0]}},u.keys=t||function(a){if(u.isArray(a))return u.range(0,a.length);var b=[];for(var c in a)i.call(a,c)&&(b[b.length]=c);return b},u.values=function(a){return u.map(a,u.identity)},u.functions=u.methods=function(a){return u.filter(u.keys(a),function(b){return u.isFunction(a[b])}).sort()},u.extend=function(a){v(f.call(arguments,1),function(b){for(var c in b)a[c]=b[c]});return a},u.clone=function(a){return u.isArray(a)?a.slice():u.extend({},a)},u.tap=function(a,b){b(a);return a},u.isEqual=function(a,b){if(a===b)return!0;var c=typeof a,d=typeof b;if(c!=d)return!1;if(a==b)return!0;if(!a&&b||a&&!b)return!1;a._chain&&(a=a._wrapped),b._chain&&(b=b._wrapped);if(a.isEqual)return a.isEqual(b);if(u.isDate(a)&&u.isDate(b))return a.getTime()===b.getTime();if(u.isNaN(a)&&u.isNaN(b))return!1;if(u.isRegExp(a)&&u.isRegExp(b))return a.source===b.source&&a.global===b.global&&a.ignoreCase===b.ignoreCase&&a.multiline===b.multiline;if(c!=="object")return!1;if(a.length&&a.length!==b.length)return!1;var e=u.keys(a),f=u.keys(b);if(e.length!=f.length)return!1;for(var g in a)if(!(g in b)||!u.isEqual(a[g],b[g]))return!1;return!0},u.isEmpty=function(a){if(u.isArray(a)||u.isString(a))return a.length===0;for(var b in a)if(i.call(a,b))return!1;return!0},u.isElement=function(a){return a&&a.nodeType==1},u.isArray=s||function(a){return h.call(a)==="[object Array]"},u.isArguments=function(a){return a&&i.call(a,"callee")},u.isFunction=function(a){return!!(a&&a.constructor&&a.call&&a.apply)},u.isString=function(a){return!!(a===""||a&&a.charCodeAt&&a.substr)},u.isNumber=function(a){return!!(a===0||a&&a.toExponential&&a.toFixed)},u.isNaN=function(a){return a!==a},u.isBoolean=function(a){return a===!0||a===!1},u.isDate=function(a){return!!(a&&a.getTimezoneOffset&&a.setUTCFullYear)},u.isRegExp=function(a){return a&&a.test&&a.exec&&(a.ignoreCase||a.ignoreCase===!1)},u.isNull=function(a){return a===null},u.isUndefined=function(a){return a===void 0},u.noConflict=function(){a._=b;return this},u.identity=function(a){return a},u.times=function(a,b,c){for(var d=0;d<a;d++)b.call(c,d)},u.mixin=function(a){v(u.functions(a),function(b){B(b,u[b]=a[b])})};var y=0;u.uniqueId=function(a){var b=y++;return a?a+b:b},u.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g},u.template=function(a,b){var c=u.templateSettings,d="var __p=[],print=function(){__p.push.apply(__p,arguments);};with(obj||{}){__p.push('"+a.replace(/\\/g,"\\\\").replace(/'/g,"\\'").replace(c.interpolate,function(a,b){return"',"+b.replace(/\\'/g,"'")+",'"}).replace(c.evaluate||null,function(a,b){return"');"+b.replace(/\\'/g,"'").replace(/[\r\n\t]/g," ")+"__p.push('"}).replace(/\r/g,"\\r").replace(/\n/g,"\\n").replace(/\t/g,"\\t")+"');}return __p.join('');",e=new Function("obj",d);return b?e(b):e};var z=function(a){this._wrapped=a};u.prototype=z.prototype;var A=function(a,b){return b?u(a).chain():a},B=function(a,b){z.prototype[a]=function(){var a=f.call(arguments);g.call(a,this._wrapped);return A(b.apply(u,a),this._chain)}};u.mixin(u),v(["pop","push","reverse","shift","sort","splice","unshift"],function(a){var b=d[a];z.prototype[a]=function(){b.apply(this._wrapped,arguments);return A(this._wrapped,this._chain)}}),v(["concat","join","slice"],function(a){var b=d[a];z.prototype[a]=function(){return A(b.apply(this._wrapped,arguments),this._chain)}}),z.prototype.chain=function(){this._chain=!0;return this},z.prototype.value=function(){return this._wrapped}}();var neo4j=neo4j||{};neo4j.services=neo4j.services||{},neo4j.exceptions=neo4j.exceptions||{},neo4j.exceptions.HttpException=function(a,b,c,d){var d=d||"A server error or a network error occurred. Status code: "+a+".";this.status=a,this.data=b||{},this.req=c||{},Error.call(this,d)},neo4j.exceptions.HttpException.prototype=new Error,neo4j.exceptions.HttpException.RESPONSE_CODES={Conflict:409,NotFound:404},function(){var a=neo4j.exceptions.HttpException.prototype,b=neo4j.exceptions.HttpException.RESPONSE_CODES;_.each(_.keys(b),function(c){a["is"+c]=function(){return this.status===b[c]}})}(),neo4j.exceptions.ConnectionLostException=function(){neo4j.exceptions.HttpException.call(this,-1,null,null,"The server connection was lost.")},neo4j.exceptions.HttpException.prototype=new neo4j.exceptions.HttpException,neo4j.exceptions.NotFoundException=function(a){Error.call(this,"The object at url "+a+" does not exist."),this.url=a},neo4j.exceptions.NotFoundException.prototype=new Error,neo4j.exceptions.InvalidDataException=function(){Error.call(this,"Unable to create relationship or node from the provided data. This may be because you tried to get a node or relationship from an invalid url.")},neo4j.exceptions.InvalidDataException.prototype=new Error,neo4j.exceptions.StartNodeSameAsEndNodeException=function(a){Error.call(this,"You cannot create a relationship with the same start and end node."),this.url=a},neo4j.exceptions.StartNodeSameAsEndNodeException.prototype=new Error,_.extend(neo4j,{setTimeout:function(a,b){if(typeof setTimeout!="undefined")return setTimeout(a,b);b===0?a():neo4j.log("No timeout implementation found, unable to do timed tasks.")},clearTimeout:function(a){typeof clearTimeout!="undefined"?clearTimeout(intervalId):neo4j.log("No timeout implementation found, unable to do timed tasks.")},_intervals:{}}),_.extend(neo4j,{setInterval:function(a,b){if(typeof setInterval!="undefined")return setInterval(a,b);if(typeof setTimeout!="undefined"){var c=(new Date).getTime();function d(){a(),neo4j._intervals[c]=setTimeout(d,b)}neo4j._intervals[c]=setTimeout(d,b);return c}neo4j.log("No timeout or interval implementation found, unable to do timed tasks.")},clearInterval:function(a){typeof clearInterval!="undefined"?clearInterval(a):typeof clearTimeout!="undefined"?clearTimeout(neo4j._intervals[a]):neo4j.log("No timeout or interval implementation found, unable to do timed tasks.")},_intervals:{}}),neo4j.Promise=function(a){_.bindAll(this,"then","fulfill","fail","addHandlers","addFulfilledHandler","addFailedHandler","_callHandlers","_callHandler","_addHandler"),this._handlers=[],typeof a==="function"&&a(this.fulfill,this.fail)},neo4j.Promise.wrap=function(a){return a instanceof neo4j.Promise?a:neo4j.Promise.fulfilled(a)},neo4j.Promise.fulfilled=function(a){return new neo4j.Promise(function(b){b(a)})},neo4j.Promise.join=function(){var a=_.toArray(arguments);return a.length==1?a[0]:new neo4j.Promise(function(b,c){function e(a){a.length>0?a.shift().addFulfilledHandler(function(b){d.push(b),e(a)}):b(d)}var d=[];for(var f=0,g=a.length;f<g;f++)a[f].addFailedHandler(c);e(a)})},_.extend(neo4j.Promise.prototype,{then:function(a,b){var c=this;return new neo4j.Promise(function(d,e){c.addHandlers(function(b){a?a(b,d,e):d(b)},function(a){typeof b==="function"?b(a,d,e):e(a)})})},chain:function(a){var b=this;this.chainedPromise=a,a.then(null,function(a){b.fail(a)})},fulfill:function(a){if(this.chainedPromise){var b=this;this.chainedPromise.then(function(){b._fulfill(a)})}else this._fulfill(a)},fail:function(a){this._complete||(this._failedResult=a,this._fulfilled=!1,this._complete=!0,this._callHandlers())},_fulfill:function(a){this._complete||(this._fulfilledResult=a,this._fulfilled=!0,this._complete=!0,this._callHandlers())},_callHandlers:function(){_.each(this._handlers,this._callHandler)},_callHandler:function(a){this._fulfilled&&typeof a.fulfilled==="function"?a.fulfilled(this._fulfilledResult):typeof a.failed==="function"&&a.failed(this._failedResult)},addHandlers:function(a,b){a=a||function(){},b=b||function(){},this._addHandler({fulfilled:a,failed:b})},addFulfilledHandler:function(a){this.addHandlers(a)},addFailedHandler:function(a){this.addHandlers(null,a)},_addHandler:function(a){this._complete?this._callHandler(a):this._handlers.push(a)}}),neo4j.cachedFunction=function(a,b,c){var d=null,e=null,f=!1,c=c||!1,g=[];return function h(){var h=arguments[b];f?h.apply(e,d):(g.push(h),g.length===1&&(arguments[b]=function(){e=this,d=arguments,f=!0;for(var a in g)g[a].apply(e,d);g=[],c&&setTimeout(function(){f=!1},c)},a.apply(this,arguments)))}},neo4j.log=function(){typeof console!="undefined"&&typeof console.log==="function"&&console.log.apply(this,arguments)},neo4j.proxy=function(a,b){return _.bind(a,b)},neo4j.Events=function(a){this.uniqueNamespaceCount=0,this.handlers={},this.context=a||{}},neo4j.Events.prototype.createUniqueNamespace=function(){return"uniq#"+this.uniqueNamespaceCount++},neo4j.Events.prototype.bind=function(a,b){typeof this.handlers[a]==="undefined"&&(this.handlers[a]=[]),this.handlers[a].push(b)},neo4j.Events.prototype.trigger=function(a,b){if(typeof this.handlers[a]!=="undefined"){var b=b||{},c=this.handlers[a],d=_.extend({key:a,data:b},this.context);for(var e=0,f=c.length;e<f;e++)neo4j.setTimeout(function(b){return function(){try{b(d)}catch(c){neo4j.log("Event handler for event "+a+" threw exception.",c)}}}(c[e]),0)}},neo4j.events=new neo4j.Events,neo4j.jqueryWebProvider={ajax:function(a){var b=a.timeout||5e3,c=a.method,d=a.url,e=a.data,f=a.success,g=a.failure,h=function(a){try{if(a.status===200)return f(null)}catch(b){}try{if(a.status===0)g(new neo4j.exceptions.ConnectionLostException);else{var c=JSON.parse(a.responseText);g(new neo4j.exceptions.HttpException(a.status,c,a))}}catch(b){g(new neo4j.exceptions.HttpException(-1,{},a))}},i=this.isCrossDomain;setTimeout(function(a,c,d,e,f){d===null||d==="null"?d="":d=JSON.stringify(d);return function(){if(i(c)&&window.XDomainRequest)typeof f==="function"&&f(new neo4j.exceptions.HttpException(-1,null,null,"Cross-domain requests are available in IE, but are not yet implemented in neo4js."));else var g=!1,o=$.ajax({url:c,type:a,data:d,timeout:b,cache:!1,processData:!1,success:function(a,b,c){c.status===0?h(c):e.apply(this,arguments)},contentType:"application/json",error:h,dataType:"json"})}}(c,d,e,f,g),0)},isCrossDomain:function(a){if(a){var b=a.indexOf("://");return b===-1||b>7?!1:a.substring(b+3).split("/",1)[0]!==window.location.host}return!1}},neo4j.Web=function(a){this.webProvider=a||neo4j.jqueryWebProvider},_.extend(neo4j.Web.prototype,{get:function(a,b,c,d){return this.ajax("GET",a,b,c,d)},post:function(a,b,c,d){return this.ajax("POST",a,b,c,d)},put:function(a,b,c,d){return this.ajax("PUT",a,b,c,d)},del:function(a,b,c,d){return this.ajax("DELETE",a,b,c,d)},ajax:function(){var a=this._processAjaxArguments(arguments),b=this;a.userFail=this.wrapFailureCallback(a.failure),a.userSuccess=a.success;return new neo4j.Promise(function(c,d){a.failure=function(){d.call(this,{error:arguments[0],args:arguments}),a.userFail.apply(this,arguments)},a.success=function(){c.call(this,{data:arguments[0],args:arguments}),a.userSuccess.apply(this,arguments)};try{b.webProvider.ajax(a)}catch(e){a.failure(e)}})},looksLikeUrl:function(a){var b=/(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;return b.test(a)},setWebProvider:function(a){this.webProvider=a},replace:function(a,b){var c={url:a};_.each(_.keys(b),function(a){c.url=c.url.replace("{"+a+"}",b[a])});return c.url},wrapFailureCallback:function(a){return function(b){typeof b!="undefined"&&b instanceof neo4j.exceptions.ConnectionLostException&&neo4j.events.trigger("web.connection.failed",_.toArray(arguments)),a.apply(this,arguments)}},_processAjaxArguments:function(a){var b,c,d,e,f,a=_.toArray(a);b=a.shift(),c=a.shift(),d=a.length>0&&!_.isFunction(a[0])?a.shift():null,e=a.length>0?a.shift():null,f=a.length>0?a.shift():null,e=_.isFunction(e)?e:function(){},f=_.isFunction(f)?f:function(){};return{method:b,url:c,data:d,success:e,failure:f}}}),neo4j.Service=function(a){this.callsWaiting=[],this.loadServiceDefinition=neo4j.cachedFunction(this.loadServiceDefinition,0),this.events=new neo4j.Events,this.bind=neo4j.proxy(this.events.bind,this.events),this.trigger=neo4j.proxy(this.events.trigger,this.events),this.db=a,this.db.bind("services.loaded",neo4j.proxy(function(){this.initialized||this.setNotAvailable()},this))},neo4j.Service.resourceFactory=function(a){var b=a.urlArgs||[],c=b.length,d=a.after?a.after:function(a,b){b(a)},e=a.before?a.before:function(a,b){a.apply(this,b)},f=a.errorHandler?a.errorHandler:function(a,b){a({message:"An error occurred, please see attached error object.",error:b})},g=function(){var e=neo4j.proxy(d,this),g=neo4j.proxy(f,this);if(c>0){var h={};for(var i=0;i<c;i++)h[b[i]]=arguments[i];var j=this.db.web.replace(this.resources[a.resource],h)}else var j=this.resources[a.resource];var k=null,l=function(){};arguments.length>c&&(typeof arguments[arguments.length-1]==="function"&&(l=arguments[arguments.length-1]),arguments.length-1>c&&(k=arguments[arguments.length-2])),k!==null?this.db.web.ajax(a.method,j,k,function(a){e(a,l)},function(a){g(l,a)}):this.db.web.ajax(a.method,j,function(a){e(a,l)},function(a){g(l,a)})};return function(){this.serviceMethodPreflight(function(){e.call(this,neo4j.proxy(g,this),arguments)},arguments)}},_.extend(neo4j.Service.prototype,{initialized:!1,available:null,resources:null,handleWaitingCalls:function(){for(var a=0,b=this.callsWaiting.length;a<b;a++)try{this.serviceMethodPreflight(this.callsWaiting[a].method,this.callsWaiting[a].args)}catch(c){neo4j.log(c)}},loadServiceDefinition:function(a){this.get("/",neo4j.proxy(function(b){this.resources=b.resources,this.trigger("service.definition.loaded",b),a(b)},this))},makeAvailable:function(a){this.initialized=!0,this.available=!0,this.url=a,this.handleWaitingCalls()},setNotAvailable:function(){this.initialized=!0,this.available=!1,this.handleWaitingCalls()},get:function(a,b,c,d){this.db.web.get(this.url+a,b,c,d)},del:function(a,b,c,d){this.db.web.del(this.url+a,b,c,d)},post:function(a,b,c,d){this.db.web.post(this.url+a,b,c,d)},put:function(a,b,c,d){this.db.web.put(this.url+a,b,c,d)},serviceMethodPreflight:function(a,b){if(this.available===!1)throw new Error("The service you are accessing is not available for this server.");this.initialized?(b=b||[],this.resources!==null?a.apply(this,b):this.loadServiceDefinition(neo4j.proxy(function(){a.apply(this,b)},this))):this.callsWaiting.push({method:a,args:b})}}),neo4j.GraphDatabaseHeartbeat=function(a){this.db=a,this.monitor=a.manage.monitor,this.listeners={},this.idCounter=0,this.listenerCounter=0,this.timespan={year:31536e6,month:26784e5,week:6048e5,day:864e5,hours:216e5,minutes:21e5},this.startTimestamp=(new Date).getTime()-this.timespan.year,this.endTimestamp=this.startTimestamp+1,this.timestamps=[],this.data={},this.isPolling=!1,this.processMonitorData=neo4j.proxy(this.processMonitorData,this),this.beat=neo4j.proxy(this.beat,this),this.waitForPulse=neo4j.proxy(this.waitForPulse,this),neo4j.setInterval(this.beat,2e3)},neo4j.GraphDatabaseHeartbeat.prototype.addListener=function(a){this.listenerCounter++,this.listeners[this.idCounter++]=a;return this.idCounter},neo4j.GraphDatabaseHeartbeat.prototype.removeListener=function(a){var b=!1;if(typeof a==="function"){for(var c in this.listeners)if(this.listeners[c]===a){delete this.listeners[c],b;break}}else this.listeners[a]&&(delete this.listeners[a],b=!0);b&&this.listenerCounter--},neo4j.GraphDatabaseHeartbeat.prototype.getCachedData=function(){return{timestamps:this.timestamps,data:this.data,endTimestamp:this.endTimestamp,startTimestamp:this.startTimestamp}},neo4j.GraphDatabaseHeartbeat.prototype.beat=function(){this.listenerCounter>0&&!this.isPolling&&this.monitor.available&&(this.isPolling=!0,this.monitor.getDataFrom(this.endTimestamp,this.processMonitorData))},neo4j.GraphDatabaseHeartbeat.prototype.processMonitorData=function(a){this.isPolling=!1;if(a&&!a.error){var b=this.findDataBoundaries(a);if(b.dataEnd<0)this.adjustRequestedTimespan();else{this.endTimestamp=a.timestamps[b.dataEnd];var c=a.timestamps.splice(b.dataStart,b.dataEnd-b.dataStart);this.timestamps=this.timestamps.concat(c);var d={};for(var e in a.data)d[e]=a.data[e].splice(b.dataStart,b.dataEnd-b.dataStart),typeof this.data[e]==="undefined"&&(this.data[e]=[]),this.data[e]=this.data[e].concat(d[e]);var f={server:this.server,newData:{data:d,timestamps:c,end_time:this.endTimestamp,start_time:a.start_time},allData:this.getCachedData()};this.callListeners(f)}}},neo4j.GraphDatabaseHeartbeat.prototype.waitForPulse=function(a){if(!this.pulsePromise){var b=this,c=this.db.get;this.pulsePromise=new neo4j.Promise(function(a){var d={interval:null};d.interval=neo4j.setInterval(function(){c("",function(c){c!==null&&(neo4j.clearInterval(d.interval),b.pulsePromise=null,a(!0))})},4e3)})}this.pulsePromise.addFulfilledHandler(a);return this.pulsePromise},neo4j.GraphDatabaseHeartbeat.prototype.adjustRequestedTimespan=function(a){var b=(new Date).getTime()-this.endTimestamp;b<this.timespan.year?b<this.timespan.month?b<this.timespan.week?b<this.timespan.day?b>=this.timespan.day&&(this.endTimestamp=(new Date).getTime()-this.timespan.minutes,this.beat()):(this.endTimestamp=(new Date).getTime()-this.timespan.hours,this.beat()):(this.endTimestamp=(new Date).getTime()-this.timespan.day,this.beat()):(this.endTimestamp=(new Date).getTime()-this.timespan.week,this.beat()):(this.endTimestamp=(new Date).getTime()-this.timespan.month,this.beat())},neo4j.GraphDatabaseHeartbeat.prototype.findDataBoundaries=function(a){var b=this.getFirstKey(a),c=-1,d=-1;if(b){for(c=a.timestamps.length-1;c>=0;c--)if(typeof a.data[b][c]==="number")break;for(d=0;d<=c;d++)if(typeof a.data[b][d]==="number")break}return{dataStart:d,dataEnd:c}},neo4j.GraphDatabaseHeartbeat.prototype.callListeners=function(a){for(var b in this.listeners)setTimeout(function(b){return function(){b(a)}}(this.listeners[b]),0)},neo4j.GraphDatabaseHeartbeat.prototype.getFirstKey=function(a){if(typeof a==="object")for(var b in a.data)break;return b?b:null},neo4j.models=neo4j.models||{},neo4j.models.JMXBean=function(a){this.parse(a)},neo4j.models.JMXBean.prototype.parse=function(a){var b=this.parseName(a.name);this.domain=b.domain,delete b.domain,this.properties=b,this.attributes=a.attributes,this.description=a.description,this.jmxName=a.name},neo4j.models.JMXBean.prototype.getName=function(a){if(this.properties.name)return this.properties.name;for(var b in this.properties)return this.properties[b];return this.domain},neo4j.models.JMXBean.prototype.parseName=function(a){var b=a.split(":"),c,d,e={};d=b[0],b=b[1].split(",");for(var f=0,g=b.length;f<g;f++)c=b[f].split("="),e[c[0]]=c[1];e.domain=d;return e},neo4j.models.JMXBean.prototype.getAttribute=function(a){var b=a.toLowerCase();for(var c=0,d=this.attributes.length;c<d;c++)if(this.attributes[c].name.toLowerCase()===b)return this.attributes[c];return null},neo4j.models.PropertyContainer=function(){_.bindAll(this,"getSelf","exists","getProperty","setProperty","getProperties","setProperties"),this._data=this._data||{}},_.extend(neo4j.models.PropertyContainer.prototype,{getSelf:function(){return typeof this._self!="undefined"?this._self:null},exists:function(){return this.getSelf()!==null},hasProperty:function(a){return a in this._data},getProperty:function(a){return this._data[a]||null},setProperty:function(a,b){this._data[a]=b},getProperties:function(){return this._data},setProperties:function(a){this._data=_.extend(this._data,a)},removeProperty:function(a){delete this._data[a]}}),neo4j.models.Node=function(a,b){neo4j.models.PropertyContainer.call(this),this.db=b,this._init(a),_.bindAll(this,"save","fetch","getRelationships","_init")},neo4j.models.Node.IN="in",neo4j.models.Node.OUT="out",neo4j.models.Node.ALL="all",neo4j.traverse={},neo4j.traverse.RETURN_NODES="node",neo4j.traverse.RETURN_RELATIONSHIPS="relationship",neo4j.traverse.RETURN_PATHS="path",_.extend(neo4j.models.Node.prototype,neo4j.models.PropertyContainer.prototype,{save:function(){var a=this,b=this.db.web;return this.exists()?new neo4j.Promise(function(c,d){b.put(a._urls.properties,a.getProperties(),function(){c(a)},d)}):new neo4j.Promise(function(c,d){a.db.getServiceDefinition().then(function(e){b.post(e.node,a._data).then(function(b){a._init(b.data),c(a)},d)},d)})},fetch:function(){var a=this,b=this.db.web;return new neo4j.Promise(function(c,d){b.get(a._self).then(function(b){b.data&&b.data.self?(a._init(b.data),c(a)):d(new neo4j.exceptions.InvalidDataException)},function(b){d(new neo4j.exceptions.NotFoundException(a._self))})})},remove:function(){var a=this,b=this.db.web,c=!1,d=this.db,e=a.getSelf();return new neo4j.Promise(function(f,g){b.del(a.getSelf()).then(function(){d.getReferenceNodeUrl().then(function(a){a==e&&d.forceRediscovery(),f(!0)},g)},function(b){b.error.isConflict()&&!c&&a.getRelationships().then(function(b){_.each(b,function(a){a.remove()}),c=!0,a.remove().then(function(){f(!0)},g)},g)})})},getCreateRelationshipUrl:function(){if(this.exists())return this._urls.create_relationship;throw new Error("You can't get the create relationship url until you have saved the node!")},traverse:function(a,b){b=b||neo4j.traverse.RETURN_NODES;var c=this.db.web.replace(this._urls.traverse,{returnType:b}),d=this,e;switch(b){case neo4j.traverse.RETURN_RELATIONSHIPS:e=neo4j.models.Relationship;break;case neo4j.traverse.RETURN_PATHS:e=neo4j.models.Path;break;default:e=neo4j.models.Node}return new neo4j.Promise(function(b,f){d.db.web.post(c,a).then(function(a){var c=_.map(a.data,function(a){return new e(a,d.db)});b(c)},f)})},getRelationships:function(a,b){var a=a||neo4j.models.Node.ALL,b=b||null,c=this,d,e=b?!0:!1;_.isArray(b)&&(b=b.join("&"));switch(a){case neo4j.models.Node.IN:d=e?this._urls.incoming_typed_relationships:this._urls.incoming_relationships;break;case neo4j.models.Node.OUT:d=e?this._urls.outgoing_typed_relationships:this._urls.outgoing_relationships;break;default:d=e?this._urls.all_typed_relationships:this._urls.all_relationships}e&&(d=this.db.web.replace(d,{"-list|&|types":b}));return new neo4j.Promise(function(a,b){c.db.web.get(d).then(function(b){var d=_.map(b.data,function(a){return new neo4j.models.Relationship(a,c.db)});a(d)},b)})},_init:function(a){this._self=a.self||null,this._data=a.data||{},this._urls={properties:a.properties||"",traverse:a.traverse||"",create_relationship:a.create_relationship||"",all_relationships:a.all_relationships||"",all_typed_relationships:a.all_typed_relationships||"",incoming_relationships:a.incoming_relationships||"",incoming_typed_relationships:a.incoming_typed_relationships||"",outgoing_relationships:a.outgoing_relationships||"",outgoing_typed_relationships:a.outgoing_typed_relationships||""}}}),neo4j.models.Relationship=function(a,b){neo4j.models.PropertyContainer.call(this),this.db=b,this._init(a),_.bindAll(this,"save","fetch","_init")},_.extend(neo4j.models.Relationship.prototype,neo4j.models.PropertyContainer.prototype,{save:function(){var a=this,b=this.db.web;return this.exists()?new neo4j.Promise(function(c,d){b.put(a._urls.properties,a.getProperties()).then(function(){c(a)},d)}):this.getStartNode().then(function(c,d,e){var f=b.post(c.getCreateRelationshipUrl(),{to:a._endUrl,type:a.getType(),data:a.getProperties()});f.then(function(b){a._init(b.data),d(a)},function(b){if(b.error&&b.error.data&&b.error.data.exception){var c=b.error.data.exception;if(c.indexOf("EndNodeNotFoundException")>-1||c.indexOf("BadInputException")>-1&&c.indexOf(a._endUrl)>-1)return e(new neo4j.exceptions.NotFoundException(a._endUrl));if(c.indexOf("StartNodeSameAsEndNodeException")>-1)return e(new neo4j.exceptions.StartNodeSameAsEndNodeException(a._endUrl))}e(b)})})},fetch:function(){var a=this,b=this.db.web;return new neo4j.Promise(function(c,d){b.get(a._self).then(function(b){b.data&&b.data.self&&b.data.start&&b.data.end?(a._init(b.data),c(a)):d(new neo4j.exceptions.InvalidDataException)},d)})},remove:function(){var a=this,b=this.db.web;return new neo4j.Promise(function(c,d){b.del(a.getSelf()).then(function(){c(!0)},d)})},getType:function(){return this._type||null},getStartNode:function(){return this._getNode("_startNode","_startUrl")},getStartNodeUrl:function(){return this._startUrl},isStartNode:function(a){return a instanceof neo4j.models.Node?this._startUrl===a.getSelf():this._startUrl===a},getEndNode:function(){return this._getNode("_endNode","_endUrl")},getEndNodeUrl:function(){return this._endUrl},isEndNode:function(a){return a instanceof neo4j.models.Node?this._endUrl===a.getSelf():this._endUrl===a},getOtherNode:function(a){return this.isStartNode(a)?this.getEndNode():this.getStartNode()},getOtherNodeUrl:function(a){return this.isStartNode(a)?this.getEndNodeUrl():this.getStartNodeUrl()},_getNode:function(a,b){if(typeof this[a]!="undefined")return neo4j.Promise.fulfilled(this[a]);var c=this;return this.db.node(this[b]).then(function(b,d){c[a]=b,d(b)})},_init:function(a){this._self=a.self||null,this._data=a.data||{},this._type=a.type||null,this._urls={properties:a.properties||""},typeof a.start!="undefined"&&(a.start instanceof neo4j.models.Node?(this._startNode=a.start,this._startUrl=a.start.getSelf()):this._startUrl=a.start),typeof a.end!="undefined"&&(a.end instanceof neo4j.models.Node?(this._endNode=a.end,this._endUrl=a.end.getSelf()):this._endUrl=a.end)}}),neo4j.models.Path=function(a,b){this.db=b,this._init(a),_.bindAll(this,"_init")},_.extend(neo4j.models.Path.prototype,{_init:function(a){this._start=a.start,this._end=a.end,this._length=a.length,this._nodeUrls=a.nodes,this._relationshipUrls=a.relationships}}),neo4j.services.BackupService=function(a){neo4j.Service.call(this,a)},_.extend(neo4j.services.BackupService.prototype,neo4j.Service.prototype),neo4j.services.BackupService.prototype.triggerManual=neo4j.Service.resourceFactory({resource:"trigger_manual",method:"POST",errorHandler:function(a,b){b.exception=="NoBackupFoundationException"&&a(!1)}}),neo4j.services.BackupService.prototype.triggerManualFoundation=neo4j.Service.resourceFactory({resource:"trigger_manual_foundation",method:"POST"}),neo4j.services.BackupService.prototype.getJobs=neo4j.Service.resourceFactory({resource:"jobs",method:"GET"}),neo4j.services.BackupService.prototype.getJob=function(a,b){this.getJobs(function(c){for(var d in c.jobList)if(c.jobList[d].id==a){b(c.jobList[d]);return}b(null)})},neo4j.services.BackupService.prototype.deleteJob=neo4j.Service.resourceFactory({resource:"job",method:"DELETE",urlArgs:["id"]}),neo4j.services.BackupService.prototype.triggerJobFoundation=neo4j.Service.resourceFactory({resource:"trigger_job_foundation",method:"POST",urlArgs:["id"]}),neo4j.services.BackupService.prototype.setJob=neo4j.Service.resourceFactory({resource:"jobs",method:"PUT"}),neo4j.services.ConfigService=function(a){neo4j.Service.call(this,a)},_.extend(neo4j.services.ConfigService.prototype,neo4j.Service.prototype),neo4j.services.ConfigService.prototype.getProperties=neo4j.Service.resourceFactory({resource:"properties",method:"GET",before:function(a,b){var c=b[0];a(function(a){var b={};for(var d in a)b[a[d].key]=a[d];c(b)})}}),neo4j.services.ConfigService.prototype.getProperty=function(a,b){this.getProperties(function(c){for(var d in c)if(d===a){b(c[d]);return}b(null)})},neo4j.services.ConfigService.prototype.setProperties=neo4j.Service.resourceFactory({resource:"properties",method:"POST",before:function(a,b){var c=[],d;for(var e in b[0])d={key:e,value:b[0][e]},c.push(d),this.db.trigger("config.property.set",d);a(c,b[1])}}),neo4j.services.ConfigService.prototype.setProperty=function(a,b,c){var d={};d[a]=b,this.setProperties(d,c)},neo4j.services.ImportService=function(a){neo4j.Service.call(this,a)},_.extend(neo4j.services.ImportService.prototype,neo4j.Service.prototype),neo4j.services.ImportService.prototype.fromUrl=neo4j.Service.resourceFactory({resource:"import_from_url",method:"POST",before:function(a,b){a({url:b[0]},b[1])}}),neo4j.services.ImportService.prototype.getUploadUrl=function(a){this.serviceMethodPreflight(function(a){a(this.resources.import_from_file)},arguments)},neo4j.services.ExportService=function(a){neo4j.Service.call(this,a)},_.extend(neo4j.services.ExportService.prototype,neo4j.Service.prototype),neo4j.services.ExportService.prototype.all=neo4j.Service.resourceFactory({resource:"export_all",method:"POST"}),neo4j.services.ConsoleService=function(a){neo4j.Service.call(this,a)},_.extend(neo4j.services.ConsoleService.prototype,neo4j.Service.prototype),neo4j.services.ConsoleService.prototype.exec=neo4j.Service.resourceFactory({resource:"exec",method:"POST",before:function(a,b){a({command:b[0],engine:b[1]},b[2])}}),neo4j.services.JmxService=function(a){neo4j.Service.call(this,a),this.kernelInstance=neo4j.cachedFunction(this.kernelInstance,0,2e3)},_.extend(neo4j.services.JmxService.prototype,neo4j.Service.prototype),neo4j.services.JmxService.prototype.getDomains=neo4j.Service.resourceFactory({resource:"domains",method:"GET"}),neo4j.services.JmxService.prototype.getDomain=neo4j.Service.resourceFactory({resource:"domain",method:"GET",urlArgs:["domain"],after:function(a,b){var c=[];for(var d=0,e=a.beans;d<e;d++)c.push(new neo4j.models.JMXBean(a.beans[d]));a.beans=c,b(a)}}),neo4j.services.JmxService.prototype.getBean=neo4j.Service.resourceFactory({resource:"bean",method:"GET",urlArgs:["domain","objectName"],before:function(a,b){if(b[0]==="neo4j"){var c=this;this.kernelInstance(function(c){b[0]="org.neo4j",b[1]=escape(c+",name="+b[1]),a.apply(this,b)})}else b[0]=escape(b[0]),b[1]=escape(b[1]),a.apply(this,b)},after:function(a,b){a.length>0?b(new neo4j.models.JMXBean(a[0])):b(null)}}),neo4j.services.JmxService.prototype.query=neo4j.Service.resourceFactory({resource:"query",method:"POST",after:function(a,b){var c=[];for(var d=0,e=a.length;d<e;d++)c.push(new neo4j.models.JMXBean(a[d]));b(c)}}),neo4j.services.JmxService.prototype.kernelInstance=function(a){var b=this.db.web;this.serviceMethodPreflight(function(a){var c=this.resources.kernelquery;b.get(c,function(b){var c=b?b.split(":")[1].split(",")[0]:null;a(c)})},[a])},neo4j.services.LifecycleService=function(a){neo4j.Service.call(this,a)},_.extend(neo4j.services.LifecycleService.prototype,neo4j.Service.prototype),neo4j.services.LifecycleService.prototype.getStatus=neo4j.Service.resourceFactory({resource:"status",method:"GET"}),neo4j.services.LifecycleService.prototype.start=neo4j.Service.resourceFactory({resource:"start",method:"POST"}),neo4j.services.LifecycleService.prototype.stop=neo4j.Service.resourceFactory({resource:"stop",method:"POST"}),neo4j.services.LifecycleService.prototype.restart=neo4j.Service.resourceFactory({resource:"restart",method:"POST"}),neo4j.services.MonitorService=function(a){neo4j.Service.call(this,a)},_.extend(neo4j.services.MonitorService.prototype,neo4j.Service.prototype),neo4j.services.MonitorService.prototype.getData=neo4j.Service.resourceFactory({resource:"latest_data",method:"GET"}),neo4j.services.MonitorService.prototype.getDataFrom=neo4j.Service.resourceFactory({resource:"data_from",method:"GET",urlArgs:["start"]}),neo4j.services.MonitorService.prototype.getDataBetween=neo4j.Service.resourceFactory({resource:"data_period",method:"GET",urlArgs:["start","stop"]}),neo4j.GraphDatabaseManager=function(a){_.bindAll(this,"discoverServices"),this.db=a,this.backup=new neo4j.services.BackupService(a),this.config=new neo4j.services.ConfigService(a),this.importing=new neo4j.services.ImportService(a),this.exporting=new neo4j.services.ExportService(a),this.console=new neo4j.services.ConsoleService(a),this.jmx=new neo4j.services.JmxService(a),this.lifecycle=new neo4j.services.LifecycleService(a),this.monitor=new neo4j.services.MonitorService(a),this.db.getServiceDefinition().then(this.discoverServices)},_.extend(neo4j.GraphDatabaseManager.prototype,{servicesLoaded:function(){return this.services?!0:!1},availableServices:function(){if(this.services){if(!this.serviceNames){this.serviceNames=[];for(var a in this.services)this.serviceNames.push(a)}return this.serviceNames}throw new Error("Service definition has not been loaded yet.")},discoverServices:function(){var a=this;this.db.getDiscoveryDocument().then(function(b){a.db.web.get(b.management,neo4j.proxy(function(a){this.services=a.services;for(var b in a.services)this[b]&&this[b].makeAvailable(a.services[b]);this.db.trigger("services.loaded")},a),neo4j.proxy(function(a){neo4j.log("Unable to fetch service descriptions for server "+this.url+". Server management will be unavailable.")},this))})}}),neo4j.GraphDatabase=function(a,b){this.url=a,this.events=new neo4j.Events({db:this}),this.bind=neo4j.proxy(this.events.bind,this.events),this.web=b||new neo4j.Web,this.trigger=neo4j.proxy(this.events.trigger,this.events),this.manage=new neo4j.GraphDatabaseManager(this),this.heartbeat=new neo4j.GraphDatabaseHeartbeat(this),this.rel=this.relationship,this.referenceNode=this.getReferenceNode,_.bindAll(this,"getServiceDefinition","getReferenceNode","node","relationship","getReferenceNodeUrl","getAvailableRelationshipTypes","get","put","post","del","forceRediscovery")},_.extend(neo4j.GraphDatabase.prototype,{node:function(a){var b=this,c=neo4j.Promise.wrap(a);return c.then(function(a,c,d){if(typeof a==="object"){var e=new neo4j.models.Node({data:a},b);e.save().then(function(a){c(a)},d)}else{var e=new neo4j.models.Node({self:a},b);e.fetch().then(function(a){c(a)},function(){d(new neo4j.exceptions.NotFoundException(a))})}})},relationship:function(a,b,c,d){var e=this;if(typeof b=="undefined"){var f=neo4j.Promise.wrap(a);return f.then(function(a,b,c){var d=new neo4j.models.Relationship({self:a},e);d.fetch().then(function(a){b(a)},function(){c(new neo4j.exceptions.NotFoundException(a))})})}var g=neo4j.Promise.wrap(d||{}),h=neo4j.Promise.wrap(b),i=neo4j.Promise.wrap(a),j=neo4j.Promise.wrap(c),k=neo4j.Promise.join(i,j,h,g);return k.then(function(a,b,c){var d=new neo4j.models.Relationship({start:a[0],end:a[1],type:a[2],data:a[3]},e);d.save().then(function(a){b(a)},c)})},getNodeOrRelationship:function(a){var b=this;return this.isNodeUrl(a).then(function(c,d,e){c?b.node(a).then(function(a){d(a)},e):b.rel(a).then(function(a){d(a)},e)})},getReferenceNode:function(){return this.node(this.getReferenceNodeUrl())},getAvailableRelationshipTypes:function(){var a=this;return this.getServiceDefinition().then(function(b,c,d){a.web.get(b.relationship_types,function(a){c(a)},d)})},getReferenceNodeUrl:function(){return this.getServiceDefinition().then(function(a,b,c){typeof a.reference_node!=="undefined"?b(a.reference_node):c()})},nodeUri:function(a){return this.getServiceDefinition().then(function(b,c){/^[0-9]+$/i.test(a)?c(b.node+"/"+a):c(a)})},getServiceDefinition:function(){if(typeof this._serviceDefinitionPromise==="undefined"){var a=this;this._serviceDefinitionPromise=this.getDiscoveryDocument().then(function(b,c,d){a.web.get(b.data,function(a){c(a)})})}return this._serviceDefinitionPromise},getDiscoveryDocument:function(){if(typeof this._discoveryDocumentPromise==="undefined"){var a=this;this._discoveryDocumentPromise=new neo4j.Promise(function(b,c){a.web.get(a.url,function(a){b(a)})})}return this._discoveryDocumentPromise},get:function(a,b,c,d){this.web.get(this.url+a,b,c,d)},del:function(a,b,c,d){this.web.del(this.url+a,b,c,d)},post:function(a,b,c,d){this.web.post(this.url+a,b,c,d)},put:function(a,b,c,d){this.web.put(this.url+a,b,c,d)},stripUrlBase:function(a){if(typeof a==="undefined"||a.indexOf("://")==-1)return a;return a.indexOf(this.url)===0?a.substring(this.url.length):a.indexOf(this.manageUrl)===0?a.substring(this.manageUrl.length):a.substring(a.indexOf("/",8))},isNodeUrl:function(a){return this.getServiceDefinition().then(function(b,c){c(a.indexOf(b.node)===0)})},toJSONString:function(){return{url:this.url,manageUrl:this.manageUrl}},forceRediscovery:function(){delete this._discoveryDocumentPromise,delete this._serviceDefinitionPromise}}),define("lib/neo4js",function(){}),function(){window.log=function(){var a,b,c,d;$("#messages").length===0&&$("body").append("<ul id='messages'></ul>"),d=[];for(b=0,c=arguments.length;b<c;b++)a=arguments[b],d.push($("#messages").append("<li>"+a));return d},require(["neo4j/webadmin/DashboardController","neo4j/webadmin/DataBrowserController","neo4j/webadmin/ConsoleController","neo4j/webadmin/ServerInfoController","neo4j/webadmin/models/ApplicationState","neo4j/webadmin/views/BaseView","neo4j/webadmin/ui/FoldoutWatcher","neo4j/webadmin/KeyboardShortcuts","neo4j/webadmin/templates/splash","lib/jquery","lib/neo4js","lib/backbone"],function(a,b,c,d,e,f,g,h,i){var j,k,l,m,n,o,p,q,r;j=new e,j.set({server:new neo4j.GraphDatabase(location.protocol+"//"+location.host)}),k=new f({appState:j}),m=new a(j),n=new b(j),l=new c(j),q=new d(j),o=new g,o.init(),r=new h(m,n,l,q),r.init(),p=function(){$("body").empty().append(k.el);return Backbone.history.start()},$("body").html(i());return setTimeout(p,2e3)})}.call(this),define("webadmin",function(){})